<DatabaseProperties>
<DbVersion=12.5.12/>
</DatabaseProperties>
<DatabaseCreateScript>
CREATE DATABASE "c:\avgdatacenter\avgdb.fdb" USER "SYSDBA" PASSWORD "masterkey";
CONNECT "c:\avgdatacenter\avgdb.fdb" USER "SYSDBA" PASSWORD "masterkey";
<Table name="AVG_ADMRepType">
CREATE TABLE "AVG_ADMRepType" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_GUID VARCHAR(36),
	Description VARCHAR(8192),
	GraphSetting VARCHAR(8192),
	Name VARCHAR(250),
	SqlQuery VARCHAR(8192),
	SummInformation VARCHAR(8192),
	TplName VARCHAR(255),
	TypeIdTplFiles INTEGER
);
CREATE GENERATOR GAVG_ADMREPTYPE_CODE;
SET GENERATOR GAVG_ADMREPTYPE_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_ADMREPTYPE_NEW FOR "AVG_ADMRepType" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_ADMREPTYPE_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_ADMRepTplFiles">
CREATE TABLE "AVG_ADMRepTplFiles" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	Data BLOB,
	Data2 BLOB,
	DataCRC VARCHAR(16),
	DataCRC2 VARCHAR(16),
	DataSize INTEGER,
	DataSize2 INTEGER,
	NumIndex INTEGER
);
CREATE GENERATOR GAVG_ADMREPTPLFILES_CODE;
SET GENERATOR GAVG_ADMREPTPLFILES_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_ADMREPTPLFILES_NEW FOR "AVG_ADMRepTplFiles" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_ADMREPTPLFILES_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_ADMRepTypeConf">
CREATE TABLE "AVG_ADMRepTypeConf" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_GUID VARCHAR(36),
	ConfName VARCHAR(255),
	DefaultValue VARCHAR(1024),
	Description VARCHAR(8192),
	FlagValue VARCHAR(8192),
	MainValue VARCHAR(8192),
	TypeId VARCHAR(36),
	UserName VARCHAR(1024),
	UserValue VARCHAR(8192),
	ValueType INTEGER
);
CREATE GENERATOR GAVG_ADMREPTYPECONF_CODE;
SET GENERATOR GAVG_ADMREPTYPECONF_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_ADMREPTYPECONF_NEW FOR "AVG_ADMRepTypeConf" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_ADMREPTYPECONF_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_ADMRepShedule">
CREATE TABLE "AVG_ADMRepShedule" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_GUID VARCHAR(36),
	Deleted INTEGER,
	Description VARCHAR(8192),
	EmailAttachFormat INTEGER,
	EmailSend INTEGER,
	EmailSubject VARCHAR(2048),
	EmailText VARCHAR(4096),
	EmailTo VARCHAR(1024),
	ExportFile VARCHAR(256),
	ExportFormat INTEGER,
	GeneratePeriod INTEGER,
	Name VARCHAR(255),
	NextGenerate VARCHAR(20)
);
CREATE GENERATOR GAVG_ADMREPSHEDULE_CODE;
SET GENERATOR GAVG_ADMREPSHEDULE_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_ADMREPSHEDULE_NEW FOR "AVG_ADMRepShedule" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_ADMREPSHEDULE_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_ADMRepSheduleConf">
CREATE TABLE "AVG_ADMRepSheduleConf" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	ConfId VARCHAR(36),
	MainValue VARCHAR(1024),
	SheduleId VARCHAR(36),
	TypeId VARCHAR(36)
);
CREATE GENERATOR GAVG_ADMREPSHEDULECONF_CODE;
SET GENERATOR GAVG_ADMREPSHEDULECONF_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_ADMREPSHEDULECONF_NEW FOR "AVG_ADMRepSheduleConf" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_ADMREPSHEDULECONF_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_ADMRepReport">
CREATE TABLE "AVG_ADMRepReport" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_GUID VARCHAR(36),
	GeneratePeriod INTEGER,
	GenerateTime VARCHAR(20),
	ReportCRC VARCHAR(16),
	SheduleId VARCHAR(36),
	TypeId VARCHAR(36)
);
CREATE GENERATOR GAVG_ADMREPREPORT_CODE;
SET GENERATOR GAVG_ADMREPREPORT_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_ADMREPREPORT_NEW FOR "AVG_ADMRepReport" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_ADMREPREPORT_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_DefTables">
CREATE TABLE "AVG_DefTables" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	mergeColumnIds VARCHAR(200),
	mergeMethod INTEGER,
	tableId INTEGER,
	tableName VARCHAR(200)
);
CREATE GENERATOR GAVG_DEFTABLES_CODE;
SET GENERATOR GAVG_DEFTABLES_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_DEFTABLES_NEW FOR "AVG_DefTables" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_DEFTABLES_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_DefDatabase">
CREATE TABLE "AVG_DefDatabase" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	colFlags INTEGER,
	control INTEGER,
	defaultValue VARCHAR(4096),
	editable INTEGER,
	factoryValues VARCHAR(30000),
	fieldDbName VARCHAR(64),
	fieldId INTEGER,
	fieldName VARCHAR(200),
	localTime INTEGER,
	localTimeNotConverted INTEGER,
	maxLength INTEGER,
	maxValue VARCHAR(255),
	minValue VARCHAR(255),
	optionValues VARCHAR(2048),
	pattern VARCHAR(128),
	rights INTEGER,
	tableId INTEGER,
	valueSubType INTEGER,
	valueType INTEGER,
	visible INTEGER
);
CREATE GENERATOR GAVG_DEFDATABASE_CODE;
SET GENERATOR GAVG_DEFDATABASE_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_DEFDATABASE_NEW FOR "AVG_DefDatabase" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_DEFDATABASE_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_Messages">
CREATE TABLE "AVG_Messages" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_Data VARCHAR(8192),
	AVG_DataVersion INTEGER,
	AVG_MessageCode INTEGER,
	AVG_MessageType INTEGER,
	AVG_Priority INTEGER,
	AVG_ReceiverID INTEGER,
	AVG_ReceiverType INTEGER,
	AVG_ResponseID INTEGER,
	AVG_SenderID INTEGER,
	AVG_SenderName VARCHAR(64),
	AVG_SenderType INTEGER,
	AVG_TimeOfCompleting VARCHAR(20),
	AVG_TimeOfCreating VARCHAR(20),
	AVG_TimeOfExpiration VARCHAR(20),
	AVG_TimeOfLastAction VARCHAR(20),
	AVG_TimeOfReading VARCHAR(20)
);
CREATE GENERATOR GAVG_MESSAGES_CODE;
SET GENERATOR GAVG_MESSAGES_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_MESSAGES_NEW FOR "AVG_Messages" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_MESSAGES_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_Properties">
CREATE TABLE "AVG_Properties" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_Property VARCHAR(255),
	AVG_Value VARCHAR(8192)
);
CREATE GENERATOR GAVG_PROPERTIES_CODE;
SET GENERATOR GAVG_PROPERTIES_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_PROPERTIES_NEW FOR "AVG_Properties" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_PROPERTIES_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_ScanResults">
CREATE TABLE "AVG_ScanResults" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_Actions INTEGER,
	AVG_ActualContext INTEGER,
	AVG_AdvResultInfo VARCHAR(512),
	AVG_ArchiveLevel INTEGER,
	AVG_CompareMark VARCHAR(20),
	AVG_Curability INTEGER,
	AVG_DetectionFlags INTEGER,
	AVG_DetectionName VARCHAR(255),
	AVG_DetectionSeverity INTEGER,
	AVG_DetectionTimestamp VARCHAR(20),
	AVG_Index INTEGER,
	AVG_IsBootSector INTEGER,
	AVG_MaskOptions INTEGER,
	AVG_MaskParameters INTEGER,
	AVG_ObjectName VARCHAR(255),
	AVG_ObjectOriginalName VARCHAR(512),
	AVG_ObjectType INTEGER,
	AVG_ParentCode INTEGER,
	AVG_ParentContext INTEGER,
	AVG_PID INTEGER,
	AVG_Port INTEGER,
	AVG_ProcessName VARCHAR(512),
	AVG_ProtocolName INTEGER,
	AVG_PupChecksum VARCHAR(32) CHARACTER SET NONE,
	AVG_PupChecksumType INTEGER,
	AVG_PupFileSizeHigh INTEGER,
	AVG_PupFileSizeLow INTEGER,
	AVG_ResDetectionType INTEGER,
	AVG_ResultCreator INTEGER,
	AVG_ResultCreatorAtSign VARCHAR(512),
	AVG_ResultState INTEGER,
	AVG_ScanOptions INTEGER,
	AVG_SdkType INTEGER,
	AVG_SessionId INTEGER,
	AVG_Timestamp VARCHAR(20),
	AVG_TopmostContext INTEGER,
	AVG_TopmostIndex INTEGER,
	AVG_vvIndex INTEGER
);
CREATE GENERATOR GAVG_SCANRESULTS_CODE;
SET GENERATOR GAVG_SCANRESULTS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_SCANRESULTS_NEW FOR "AVG_ScanResults" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_SCANRESULTS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_ScanLogs">
CREATE TABLE "AVG_ScanLogs" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_CntActioned INTEGER,
	AVG_CompareMark VARCHAR(20),
	AVG_ConfirmTime VARCHAR(20),
	AVG_FoundInfections INTEGER,
	AVG_FoundPups INTEGER,
	AVG_FoundRootkits INTEGER,
	AVG_HealedInfections INTEGER,
	AVG_HealedInformations INTEGER,
	AVG_HealedPups INTEGER,
	AVG_HealedRootkits INTEGER,
	AVG_HealedWarnings INTEGER,
	AVG_Informations INTEGER,
	AVG_IsRunning INTEGER,
	AVG_LogFlags INTEGER,
	AVG_LogID INTEGER,
	AVG_LogState INTEGER,
	AVG_LogStateText VARCHAR(128),
	AVG_LogVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_ScanEnded VARCHAR(20),
	AVG_ScannedObjects INTEGER,
	AVG_ScannedRootkits INTEGER,
	AVG_ScanStarted VARCHAR(20),
	AVG_ScanType INTEGER,
	AVG_TestName VARCHAR(128),
	AVG_User VARCHAR(64),
	AVG_Warnings INTEGER
);
CREATE GENERATOR GAVG_SCANLOGS_CODE;
SET GENERATOR GAVG_SCANLOGS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_SCANLOGS_NEW FOR "AVG_ScanLogs" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_SCANLOGS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_Stations">
CREATE TABLE "AVG_Stations" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_BuildType INTEGER,
	AVG_ContactAfter INTEGER,
	AVG_ExpirationDate VARCHAR(20),
	AVG_GroupID INTEGER,
	AVG_InstallTime VARCHAR(20),
	AVG_IPAddress VARCHAR(50),
	AVG_IPv4 VARCHAR(16),
	AVG_IPv6 VARCHAR(50),
	AVG_LastCall VARCHAR(20),
	AVG_LastSynchro VARCHAR(20),
	AVG_LicenceNumber VARCHAR(64),
	AVG_ListenPort INTEGER,
	AVG_Logoff VARCHAR(20),
	AVG_Logon VARCHAR(20),
	AVG_MACAddress VARCHAR(18),
	AVG_StationDesc VARCHAR(250),
	AVG_StationDomain VARCHAR(64),
	AVG_StationName VARCHAR(64),
	AVG_StationType INTEGER,
	AVG_UserID VARCHAR(255),
	AVG_WinVersion VARCHAR(255)
);
CREATE GENERATOR GAVG_STATIONS_CODE;
SET GENERATOR GAVG_STATIONS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_STATIONS_NEW FOR "AVG_Stations" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_STATIONS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_Groups">
CREATE TABLE "AVG_Groups" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_GroupDescription VARCHAR(255),
	AVG_GroupName VARCHAR(64),
	AVG_SharedExcluded INTEGER
);
CREATE GENERATOR GAVG_GROUPS_CODE;
SET GENERATOR GAVG_GROUPS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_GROUPS_NEW FOR "AVG_Groups" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_GROUPS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_DefMaintenance">
CREATE TABLE "AVG_DefMaintenance" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	scriptName VARCHAR(64),
	scriptText VARCHAR(8192)
);
CREATE GENERATOR GAVG_DEFMAINTENANCE_CODE;
SET GENERATOR GAVG_DEFMAINTENANCE_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_DEFMAINTENANCE_NEW FOR "AVG_DefMaintenance" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_DEFMAINTENANCE_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_DefViews">
CREATE TABLE "AVG_DefViews" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	condition VARCHAR(8192),
	iconIdx INTEGER,
	joinType VARCHAR(8192),
	name VARCHAR(250),
	ncExcept VARCHAR(64),
	parent INTEGER,
	tables VARCHAR(8192),
	viewOrder INTEGER
);
CREATE GENERATOR GAVG_DEFVIEWS_CODE;
SET GENERATOR GAVG_DEFVIEWS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_DEFVIEWS_NEW FOR "AVG_DefViews" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_DEFVIEWS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_DefViewColumns">
CREATE TABLE "AVG_DefViewColumns" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	columnId INTEGER,
	columnOrder INTEGER,
	editable INTEGER,
	name VARCHAR(250),
	pageIdx INTEGER,
	parentView INTEGER,
	subType INTEGER,
	tableId INTEGER,
	viewType INTEGER,
	visible INTEGER,
	width INTEGER
);
CREATE GENERATOR GAVG_DEFVIEWCOLUMNS_CODE;
SET GENERATOR GAVG_DEFVIEWCOLUMNS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_DEFVIEWCOLUMNS_NEW FOR "AVG_DefViewColumns" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_DEFVIEWCOLUMNS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_DefViewFilters">
CREATE TABLE "AVG_DefViewFilters" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	filterCondition VARCHAR(4192),
	filterName VARCHAR(64),
	filterOrder INTEGER,
	parentView INTEGER
);
CREATE GENERATOR GAVG_DEFVIEWFILTERS_CODE;
SET GENERATOR GAVG_DEFVIEWFILTERS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_DEFVIEWFILTERS_NEW FOR "AVG_DefViewFilters" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_DEFVIEWFILTERS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_DefViewsConditions">
CREATE TABLE "AVG_DefViewsConditions" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	columnId INTEGER,
	operator1 INTEGER,
	operator2 INTEGER,
	tableId INTEGER,
	value1 VARCHAR(250),
	value2 VARCHAR(250),
	valueFixed INTEGER,
	valueInvisible INTEGER,
	valueType1 INTEGER
);
CREATE GENERATOR GAVG_DEFVIEWSCONDITIONS_CODE;
SET GENERATOR GAVG_DEFVIEWSCONDITIONS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_DEFVIEWSCONDITIONS_NEW FOR "AVG_DefViewsConditions" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_DEFVIEWSCONDITIONS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_EMTerm">
CREATE TABLE "AVG_EMTerm" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	BarrierSize INTEGER,
	Description VARCHAR(8192),
	FirstMatchedExecution VARCHAR(20),
	GenPeriod INTEGER,
	Grouped INTEGER,
	GrpLatest INTEGER,
	LastReportedValue VARCHAR(255),
	LastReportedValue2 VARCHAR(255),
	LastReportedValue2_64 VARCHAR(255),
	LastReportedValue_64 VARCHAR(255),
	Name VARCHAR(256),
	NextExecution VARCHAR(20),
	NotifyActive INTEGER,
	ReportText VARCHAR(8192),
	ReportTextPrefix VARCHAR(8192),
	ReportTextSuffix VARCHAR(8192),
	SQLQuery VARCHAR(8192),
	TermType INTEGER
);
CREATE GENERATOR GAVG_EMTERM_CODE;
SET GENERATOR GAVG_EMTERM_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_EMTERM_NEW FOR "AVG_EMTerm" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_EMTERM_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_EMTermCfg">
CREATE TABLE "AVG_EMTermCfg" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	ConfName VARCHAR(512),
	ConfValue VARCHAR(1024),
	DefaultValue VARCHAR(1024),
	Description VARCHAR(8192),
	RelTermCode INTEGER,
	UserName VARCHAR(512),
	ValueType INTEGER
);
CREATE GENERATOR GAVG_EMTERMCFG_CODE;
SET GENERATOR GAVG_EMTERMCFG_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_EMTERMCFG_NEW FOR "AVG_EMTermCfg" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_EMTERMCFG_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_EMTermCfgEnum">
CREATE TABLE "AVG_EMTermCfgEnum" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	ConfValue VARCHAR(512),
	RelTermCfgCode INTEGER,
	UserValue VARCHAR(512)
);
CREATE GENERATOR GAVG_EMTERMCFGENUM_CODE;
SET GENERATOR GAVG_EMTERMCFGENUM_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_EMTERMCFGENUM_NEW FOR "AVG_EMTermCfgEnum" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_EMTERMCFGENUM_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_EMTermColumns">
CREATE TABLE "AVG_EMTermColumns" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	ConfName VARCHAR(512),
	Description VARCHAR(1024),
	RelTermCode INTEGER,
	ValueType INTEGER
);
CREATE GENERATOR GAVG_EMTERMCOLUMNS_CODE;
SET GENERATOR GAVG_EMTERMCOLUMNS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_EMTERMCOLUMNS_NEW FOR "AVG_EMTermColumns" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_EMTERMCOLUMNS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_EMNotifyTrigger">
CREATE TABLE "AVG_EMNotifyTrigger" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	ConfType INTEGER,
	Name VARCHAR(64),
	RelTermCode INTEGER
);
CREATE GENERATOR GAVG_EMNOTIFYTRIGGER_CODE;
SET GENERATOR GAVG_EMNOTIFYTRIGGER_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_EMNOTIFYTRIGGER_NEW FOR "AVG_EMNotifyTrigger" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_EMNOTIFYTRIGGER_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_EMNotifyTriggerCfg">
CREATE TABLE "AVG_EMNotifyTriggerCfg" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	ConfName VARCHAR(512),
	ConfValue VARCHAR(2048),
	DefaultValue VARCHAR(1024),
	Description VARCHAR(8192),
	RelNotifyTriggerCode INTEGER,
	UserName VARCHAR(512),
	ValueType INTEGER
);
CREATE GENERATOR GAVG_EMNOTIFYTRIGGERCFG_CODE;
SET GENERATOR GAVG_EMNOTIFYTRIGGERCFG_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_EMNOTIFYTRIGGERCFG_NEW FOR "AVG_EMNotifyTriggerCfg" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_EMNOTIFYTRIGGERCFG_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="aspam">
CREATE TABLE "aspam" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	aspam__approved_ip_list VARCHAR(1024),
	aspam__auto_training_threshold VARCHAR(32),
	aspam__blocked_charset_list VARCHAR(1024),
	aspam__blocked_country_list VARCHAR(1024),
	aspam__blocked_ip_list VARCHAR(1024),
	aspam__enable_auto_upd8ecc72c2 INTEGER,
	aspam__enable_auto_upd32dea990 INTEGER,
	aspam__enable_direct_dns VARCHAR(32),
	aspam__enable_domain_cache INTEGER,
	aspam__enable_fileclea84a0cf1e INTEGER,
	aspam__enable_filemerge88d8f63 INTEGER,
	aspam__enable_fingerprda7eabfc INTEGER,
	aspam__enable_legitrep267a2995 INTEGER,
	aspam__enable_rbl_check INTEGER,
	aspam__enable_rules INTEGER,
	aspam__enable_spamcompiler_v5 INTEGER,
	aspam__enable_spf INTEGER,
	aspam__enable_stat_file INTEGER,
	aspam__enable_stat_fil7c9df90f INTEGER,
	aspam__enable_training_updates INTEGER,
	aspam__enable_word_training INTEGER,
	aspam__extended_rules INTEGER,
	aspam__extended_rules2 INTEGER,
	aspam__home_country_list VARCHAR(1024),
	aspam__home_language_list VARCHAR(1024),
	aspam__livefeed VARCHAR(32),
	aspam__max_word_entries INTEGER,
	aspam__min_training INTEGER,
	aspam__netcheck INTEGER,
	aspam__netcheck_threshold VARCHAR(32),
	aspam__proxy_host VARCHAR(256),
	aspam__proxy_userpwd VARCHAR(256),
	aspam__rbl_list VARCHAR(1024),
	aspam__rbl_max_ips INTEGER,
	aspam__rbl_multihit INTEGER,
	aspam__rbl_threshold VARCHAR(32),
	aspam__rbl_timeout INTEGER,
	aspam__regkey VARCHAR(256),
	aspam__retrieverules_list VARCHAR(1024),
	aspam__retrieve_incr_only INTEGER,
	aspam__ruleupdate INTEGER,
	aspam__sntimeout INTEGER,
	aspam__spam_threshold INTEGER,
	aspam__spoofed_sender_list VARCHAR(1024),
	aspam__training_write_buffer INTEGER,
	aspam__use_score_history INTEGER,
	aspam__use_score_offsets INTEGER,
	aspam___backup__dnsbl_list VARCHAR(32),
	aspam___backup__rbl_list VARCHAR(32)
);
CREATE GENERATOR GASPAM_CODE;
SET GENERATOR GASPAM_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TASPAM_NEW FOR "aspam" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GASPAM_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="aspmlist">
CREATE TABLE "aspmlist" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	aspmlist__blacklist BLOB SUB_TYPE 1,
	aspmlist__list_id INTEGER,
	aspmlist__whitelist BLOB SUB_TYPE 1
);
CREATE GENERATOR GASPMLIST_CODE;
SET GENERATOR GASPMLIST_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TASPMLIST_NEW FOR "aspmlist" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GASPMLIST_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="emssrv">
CREATE TABLE "emssrv" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	emssrv__automatic INTEGER,
	emssrv__enabled INTEGER,
	emssrv__host VARCHAR(32),
	emssrv__interface VARCHAR(32),
	emssrv__name VARCHAR(32),
	emssrv__pop__apop INTEGER,
	emssrv__pop__logon INTEGER,
	emssrv__port INTEGER,
	emssrv__redirport INTEGER,
	emssrv__smtp__bounce INTEGER,
	emssrv__smtp__forward INTEGER,
	emssrv__type INTEGER,
	emssrv__use_ssl INTEGER,
	emssrv__write_header INTEGER
);
CREATE GENERATOR GEMSSRV_CODE;
SET GENERATOR GEMSSRV_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TEMSSRV_NEW FOR "emssrv" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GEMSSRV_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="krnl">
CREATE TABLE "krnl" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	krnl__license__invalid9dba3fbc INTEGER,
	krnl__license__params__counter INTEGER,
	krnl__license__params_42f3156d INTEGER,
	krnl__license__params_b94aeb40 INTEGER,
	krnl__license__params_502e23b1 INTEGER,
	krnl__license__params_93014d2f VARCHAR(1024),
	krnl__license__params_53240ee9 INTEGER,
	krnl__license__params_cf627e65 INTEGER,
	krnl__license__params_dc0ee633 INTEGER,
	krnl__license__params_a55520c3 INTEGER,
	krnl__license__params_b89fed60 INTEGER,
	krnl__license__params_d5feb2b8 INTEGER,
	krnl__license__params_90df29fe INTEGER,
	krnl__license__params_e1b6c8a9 INTEGER,
	krnl__license__params_56a91252 INTEGER,
	krnl__license__params_c7d83c0b INTEGER,
	krnl__license__params_2bff7bfa INTEGER,
	krnl__license__params_bfe24553 INTEGER,
	krnl__license__params_572780a7 INTEGER,
	krnl__license__params_3fc73967 INTEGER,
	krnl__license__params_74f46d96 INTEGER,
	krnl__license__params_07674ba0 INTEGER,
	krnl__license__params_bc221d89 INTEGER,
	krnl__license__params_da408d39 INTEGER,
	krnl__license__params_a71b52ba INTEGER,
	krnl__license__params_dbf1c666 INTEGER,
	krnl__license__params_bf264acd INTEGER,
	krnl__license__params_8ac063c7 INTEGER,
	krnl__license__params_f287cad2 INTEGER,
	krnl__license__params_5e62e71b INTEGER,
	krnl__license__params_1a86b53c INTEGER,
	krnl__license__params_aa1f0459 INTEGER,
	krnl__license__params_77ea3c3c INTEGER,
	krnl__license__params_df427714 INTEGER,
	krnl__license__params_98312925 INTEGER,
	krnl__license__params_b9160fc0 INTEGER,
	krnl__license__params_bfdd075f INTEGER,
	krnl__license__params_ec6c2edf INTEGER,
	krnl__license__params_509c8515 INTEGER,
	krnl__license__params_b2a41f43 INTEGER,
	krnl__license__params_044a28df INTEGER,
	krnl__license__params_878cea55 INTEGER,
	krnl__license__params_1cf79ebe INTEGER,
	krnl__license__params__text1 VARCHAR(32),
	krnl__license__refusing_type INTEGER,
	krnl__license__state__e6a7131b INTEGER,
	krnl__license__state__aed33780 INTEGER,
	krnl__license__state__930ee4b4 VARCHAR(20),
	krnl__license__state__7af6602b VARCHAR(20),
	krnl__license__state__c2de806c VARCHAR(20),
	krnl__license__state__7b0166ac VARCHAR(20),
	krnl__license__state__addfed5b VARCHAR(20),
	krnl__license__state__status INTEGER,
	krnl__license__valid INTEGER,
	krnl__license__view__company VARCHAR(64),
	krnl__license__view__fd0cd6d51 VARCHAR(128),
	krnl__license__view__f255438c4 VARCHAR(128),
	krnl__license__view__number VARCHAR(128),
	krnl__license__view__n3252a434 VARCHAR(128),
	krnl__license__view__username VARCHAR(64),
	krnl__linkscanner__dailywait INTEGER,
	krnl__linkscanner__enabled INTEGER,
	krnl__linkscanner__engines INTEGER,
	krnl__linkscanner__ini4df254d4 INTEGER,
	krnl__linkscanner__prevwait INTEGER,
	krnl__linkscanner__reporting INTEGER,
	krnl__linkscanner__socb8a1e910 INTEGER,
	krnl__linkscanner__tb_2a056e24 INTEGER,
	krnl__linkscanner__tb_4daa588b INTEGER,
	krnl__linkscanner__tb_4a0cb228 VARCHAR(32),
	krnl__linkscanner__tb_e3221795 VARCHAR(32),
	krnl__linkscanner__tb_19933c88 VARCHAR(20),
	krnl__linkscanner__verdicts INTEGER,
	krnl__marketingwindow__bitmap INTEGER,
	krnl__marketingwindow_860b5a7f VARCHAR(32),
	krnl__marketingwindow__state INTEGER,
	krnl__networkScanner__enabled INTEGER,
	krnl__networkScanner__991ca92e INTEGER,
	krnl__networkScanner__2ff5a964 INTEGER,
	krnl__networkScanner__f52f2478 INTEGER,
	krnl__networkScanner__44fe6827 INTEGER,
	krnl__networkScanner__51719d03 INTEGER,
	krnl__networkScanner__8c7450d7 VARCHAR(1024),
	krnl__networkScanner__b5527eae VARCHAR(1024),
	krnl__networkScanner__19187abc INTEGER,
	krnl__networkScanner__e404535d INTEGER,
	krnl__networkScanner__8bded0c5 INTEGER,
	krnl__networkScanner__354fb61c INTEGER,
	krnl__networkScanner__a5f6ad51 INTEGER,
	krnl__networkScanner__e6ebf8cc INTEGER,
	krnl__networkScanner__f9236a5d INTEGER,
	krnl__networkScanner__04f6fe44 INTEGER,
	krnl__networkScanner__5953b8e9 INTEGER,
	krnl__networkScanner__aacb569f VARCHAR(1024),
	krnl__networkScanner__86f785e2 INTEGER,
	krnl__networkScanner__84d1fab3 INTEGER,
	krnl__networkScanner__5ada9d7e VARCHAR(1024),
	krnl__networkScanner__79ec0dd3 VARCHAR(1024),
	krnl__networkScanner__0332c061 INTEGER,
	krnl__networkScanner__ff84df62 INTEGER,
	krnl__networkScanner__89fdc632 VARCHAR(1024),
	krnl__networkScanner__40920a60 VARCHAR(1024),
	krnl__networkScanner__3cd64aed INTEGER,
	krnl__networkScanner__4c6b8ded INTEGER,
	krnl__networkScanner__b083c181 VARCHAR(1024),
	krnl__resident__allfiles INTEGER,
	krnl__resident__bootsect INTEGER,
	krnl__resident__cookies INTEGER,
	krnl__resident__detectpup INTEGER,
	krnl__resident__detectpup2 INTEGER,
	krnl__resident__enabled INTEGER,
	krnl__resident__excluded_dirs BLOB SUB_TYPE 1,
	krnl__resident__exclud56911a78 BLOB SUB_TYPE 1,
	krnl__resident__exclud153029fc BLOB SUB_TYPE 1,
	krnl__resident__excluda6fafaed BLOB SUB_TYPE 1,
	krnl__resident__excluded_files BLOB SUB_TYPE 1,
	krnl__resident__exclude7f6d03b BLOB SUB_TYPE 1,
	krnl__resident__exclud30c2ffa8 BLOB SUB_TYPE 1,
	krnl__resident__exclud3bfe0e5f BLOB SUB_TYPE 1,
	krnl__resident__exclud2f836f83 INTEGER,
	krnl__resident__extense2c6fd28 VARCHAR(256),
	krnl__resident__extensf0e976da VARCHAR(256),
	krnl__resident__heuristic INTEGER,
	krnl__resident__hiddenb1dc33f8 INTEGER,
	krnl__resident__macros INTEGER,
	krnl__resident__noextoff INTEGER,
	krnl__resident__onclose INTEGER,
	krnl__resident__onclos34b27d32 INTEGER,
	krnl__resident__onclos4d062384 INTEGER,
	krnl__resident__paranoid_mode INTEGER,
	krnl__resident__pup_exceptions VARCHAR(4096) CHARACTER SET NONE,
	krnl__resident__regist7270c1c3 INTEGER,
	krnl__resident__reportad956810 INTEGER,
	krnl__resident__running INTEGER,
	krnl__system__default_language INTEGER,
	krnl__version__major INTEGER,
	krnl__version__minor INTEGER,
	krnl__version__virusdb__date VARCHAR(20),
	krnl__version__virusdb__engine INTEGER,
	krnl__version__virusdb2b0c68b8 VARCHAR(64),
	krnl__version__virusdb__incavi INTEGER,
	krnl__version__virusdb__major INTEGER,
	krnl__version__virusdb__micro INTEGER,
	krnl__version__virusdb__minor INTEGER,
	krnl__version__virusdbef009569 INTEGER,
	krnl__version__virusdb31c4399d INTEGER,
	krnl__virusvault__auto5b2465e0 INTEGER,
	krnl__virusvault__autoc2790f2b INTEGER,
	krnl__virusvault__auto0c826abc INTEGER,
	krnl__virusvault__send__addr VARCHAR(128),
	krnl__virusvault__send__smtp VARCHAR(128),
	krnl__virusvault__vvsi60af2796 INTEGER,
	krnl__virusvault__vvsiae376176 INTEGER,
	krnl__virusvault__vvsi073dac6a INTEGER
);
CREATE GENERATOR GKRNL_CODE;
SET GENERATOR GKRNL_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TKRNL_NEW FOR "krnl" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GKRNL_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="mail">
CREATE TABLE "mail" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	mail__antispam__enable INTEGER,
	mail__antispam__level INTEGER,
	mail__antispam__marksubject INTEGER,
	mail__antispam__movetojunk INTEGER,
	mail__antispam__recip_white INTEGER,
	mail__antispam__report3d3f706e VARCHAR(128),
	mail__antispam__report8e50c408 VARCHAR(128),
	mail__antispam__text VARCHAR(128),
	mail__certification__attonly INTEGER,
	mail__certification__i86703a54 INTEGER,
	mail__certification__i3b58fc6b INTEGER,
	mail__certification__language INTEGER,
	mail__certification__o11dea357 INTEGER,
	mail__certification__oacf66568 INTEGER,
	mail__certification__text VARCHAR(4096),
	mail__charset__wincodepages VARCHAR(4096),
	mail__ems__conn__entry VARCHAR(512),
	mail__ems__conn__hangup INTEGER,
	mail__ems__conn__type INTEGER,
	mail__ems__id VARCHAR(64),
	mail__ems__log__dir VARCHAR(512),
	mail__ems__log__level INTEGER,
	mail__ems__log__size INTEGER,
	mail__ems__log__type INTEGER,
	mail__ems__progress__delay INTEGER,
	mail__ems__progress__show INTEGER,
	mail__ems__queue VARCHAR(512),
	mail__ems__smtp__forceesmtp INTEGER,
	mail__plugins__exchangeserver INTEGER,
	mail__statistics__phis03fb395a INTEGER,
	mail__statistics__scannedmails INTEGER,
	mail__statistics__spam16238292 INTEGER,
	mail__statistics__spamsfound INTEGER,
	mail__statistics__threatsfound INTEGER
);
CREATE GENERATOR GMAIL_CODE;
SET GENERATOR GMAIL_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TMAIL_NEW FOR "mail" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GMAIL_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="scan">
CREATE TABLE "scan" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	scan__AutomaticActions971f3fb4 INTEGER,
	scan__AutomaticActions776b993b INTEGER,
	scan__AutomaticStart__a27c5090 INTEGER,
	scan__DirOptions__Excla2b6b0bf VARCHAR(1024),
	scan__DirOptions__Exclc8030a5a VARCHAR(1024),
	scan__DirOptions__Extensions VARCHAR(1024),
	scan__DirOptions__Finiec1f4a79 VARCHAR(1024),
	scan__DirOptions__Incl649f5d25 VARCHAR(1024),
	scan__DirOptions__MaxRf7fafea1 INTEGER,
	scan__DirOptions__ScanAllFiles INTEGER,
	scan__DirOptions__Scan8fdb595e INTEGER,
	scan__DirOptions__Scanc2fb3cf9 INTEGER,
	scan__DirOptions__Scan2f8aa279 INTEGER,
	scan__DirOptions__Supp7eae935c INTEGER,
	scan__Info__DisplayName VARCHAR(128),
	scan__Info__Name VARCHAR(128),
	scan__Info__Type INTEGER,
	scan__mail__in__attonly INTEGER,
	scan__mail__in__certify INTEGER,
	scan__mail__in__check INTEGER,
	scan__mail__in__inline INTEGER,
	scan__mail__in__language INTEGER,
	scan__mail__in__text VARCHAR(1024),
	scan__mail__onvirus__m9f703d93 INTEGER,
	scan__mail__onvirus__text VARCHAR(128),
	scan__mail__onwarning_ac1ba8a0 INTEGER,
	scan__mail__out__attonly INTEGER,
	scan__mail__out__certify INTEGER,
	scan__mail__out__check INTEGER,
	scan__mail__out__inline INTEGER,
	scan__mail__out__language INTEGER,
	scan__mail__out__text VARCHAR(1024),
	scan__mail__strip__alldoc INTEGER,
	scan__mail__strip__alldoclist VARCHAR(1024),
	scan__mail__strip__allexe INTEGER,
	scan__mail__strip__allexelist VARCHAR(1024),
	scan__mail__strip__enable INTEGER,
	scan__mail__strip__list VARCHAR(1024),
	scan__Options__AllowReb5ff8c55 INTEGER,
	scan__Options__ArchiveLevel INTEGER,
	scan__Options__Conditi1d1e25a1 INTEGER,
	scan__Options__DefaultPriority INTEGER,
	scan__Options__DeleteS772a6297 INTEGER,
	scan__Options__DetectCookies INTEGER,
	scan__Options__DetectPup INTEGER,
	scan__Options__DetectPup2 INTEGER,
	scan__Options__DontUsebe3e328c INTEGER,
	scan__Options__EnableDb52eee05 INTEGER,
	scan__Options__Exceptib4929059 INTEGER,
	scan__Options__Excepti03899118 INTEGER,
	scan__Options__ForceSh8c20c30a INTEGER,
	scan__Options__Infecta2017ce5a VARCHAR(1024),
	scan__Options__MaxFileSize INTEGER,
	scan__Options__MaxNumba38a2698 INTEGER,
	scan__Options__MaxRecu7b22ea92 INTEGER,
	scan__Options__OptScanAllowed INTEGER,
	scan__Options__ParanoidMode INTEGER,
	scan__Options__PauseableByUser INTEGER,
	scan__Options__PauseTimeout INTEGER,
	scan__Options__PowerEve67bfa2a INTEGER,
	scan__Options__PupExceptions VARCHAR(1024),
	scan__Options__ReportAccc6eb4f INTEGER,
	scan__Options__ReportH473aa2f8 INTEGER,
	scan__Options__ReportL8a7e4af1 INTEGER,
	scan__Options__ReportMacros INTEGER,
	scan__Options__ReportOkResults INTEGER,
	scan__Options__ReportPd29ce30d INTEGER,
	scan__Options__ReportP3749898e INTEGER,
	scan__Options__ScanMediaFiles INTEGER,
	scan__Options__ScanMode INTEGER,
	scan__Options__ScanOnlbc667911 INTEGER,
	scan__Options__ScanProfile INTEGER,
	scan__Options__Shutdow3568f25c INTEGER,
	scan__Options__ShutdownType INTEGER,
	scan__Options__StopableByUser INTEGER,
	scan__Options__uidisplay INTEGER,
	scan__Options__uidisplaylvl INTEGER,
	scan__Options__UseHeuristics INTEGER,
	scan__Targets__FileSys75758fd0 INTEGER,
	scan__Targets__FileSysd0d1f761 INTEGER,
	scan__Targets__FileSys67e8766b INTEGER,
	scan__Targets__FileSys8cba026c VARCHAR(1024),
	scan__Targets__FileSysca7de045 INTEGER,
	scan__Targets__Processa4e2d912 INTEGER,
	scan__Targets__Registredc06c08 INTEGER,
	scan__Targets__Registr69422535 INTEGER,
	scan__Targets__RootKit2642199b INTEGER,
	scan__Targets__RootKit48d1c3dc INTEGER,
	scan__Targets__RootKit798c9d63 INTEGER,
	scan__Targets__RootKit6a75d82d INTEGER,
	scan__Targets__RootKitaee02f56 INTEGER,
	scan__Targets__RootKit799d7f3b INTEGER,
	scan__WinSysDir VARCHAR(1024)
);
CREATE GENERATOR GSCAN_CODE;
SET GENERATOR GSCAN_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TSCAN_NEW FOR "scan" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GSCAN_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="sched">
CREATE TABLE "sched" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	sched__Commgr__Type INTEGER,
	sched__DisplayName VARCHAR(128),
	sched__Repeat__BaseTime VARCHAR(20),
	sched__Repeat__Interval INTEGER,
	sched__Repeat__Type INTEGER,
	sched__Scan__BatterySave INTEGER,
	sched__Task__Disabled INTEGER,
	sched__Task__GamingMode INTEGER,
	sched__Task__MissedStartAction INTEGER,
	sched__Task__Name VARCHAR(128),
	sched__Task__RetVal INTEGER,
	sched__Task__ScanAfterUpdate INTEGER,
	sched__Task__StartType INTEGER,
	sched__Task__Type INTEGER,
	sched__Times__AddRandomSeconds INTEGER,
	sched__Times__DayOfMonth INTEGER,
	sched__Times__DayOfWeek INTEGER,
	sched__Times__GracePeriod INTEGER,
	sched__Times__LastTime VARCHAR(20),
	sched__Times__LastTimeSkipped VARCHAR(20),
	sched__Times__Random INTEGER,
	sched__Times__SelectedDays INTEGER,
	sched__Times__StartTime VARCHAR(20),
	sched__Update__Interne560a5da6 INTEGER,
	sched__Update__Interned858f2ec INTEGER,
	sched__Update__Path VARCHAR(32),
	sched__Update__Priority INTEGER,
	sched__Update__Source VARCHAR(32)
);
CREATE GENERATOR GSCHED_CODE;
SET GENERATOR GSCHED_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TSCHED_NEW FOR "sched" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GSCHED_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="update">
CREATE TABLE "update" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	update__AdminShortStateText VARCHAR(64),
	update__Counter404NotFound INTEGER,
	update__DefaultPriority INTEGER,
	update__detectProxy__port INTEGER,
	update__detectProxy__result INTEGER,
	update__detectProxy__url VARCHAR(64),
	update__DNS__maxage INTEGER,
	update__DNS__servers VARCHAR(1024),
	update__DNS__usedns INTEGER,
	update__ExecutedModifications INTEGER,
	update__FirstTimeConnebafefb93 VARCHAR(20),
	update__GuiState INTEGER,
	update__GuiStateText VARCHAR(64),
	update__IDString VARCHAR(64),
	update__Inet__AddUpdat232c18e8 INTEGER,
	update__Inet__aviIpList VARCHAR(1024),
	update__Inet__disconne8c926a37 INTEGER,
	update__Inet__disconnec0a784e1 INTEGER,
	update__Inet__Editable INTEGER,
	update__Inet__geoIP VARCHAR(64),
	update__Inet__lastWorkingIpUrl VARCHAR(250),
	update__Inet__lastWork7785b0ff VARCHAR(64),
	update__Inet__UpdateServerName VARCHAR(1024),
	update__Inet__UpdateSee4d813c4 VARCHAR(1024),
	update__Inet__UpdateServerURL VARCHAR(1024),
	update__Inet__UpdateSe1535452d VARCHAR(1024),
	update__LastResult INTEGER,
	update__LastRun VARCHAR(20),
	update__License__ChangeTime VARCHAR(20),
	update__License__Encoding INTEGER,
	update__License__LicenseType INTEGER,
	update__License__LicServerURL VARCHAR(1024),
	update__License__OldLicense VARCHAR(64),
	update__License__ProductType INTEGER,
	update__License__ReasonID INTEGER,
	update__License__ReasonInsN INTEGER,
	update__License__ReasonInsText VARCHAR(32),
	update__License__ReasonURL VARCHAR(64),
	update__License__Version VARCHAR(32),
	update__Options__Check8fb68d6b INTEGER,
	update__Options__Check75e99f1f INTEGER,
	update__Options__Concu2ec21e4a INTEGER,
	update__Options__Dialu3048e16f INTEGER,
	update__Options__Dialuf8c65edf INTEGER,
	update__Options__Dialu2733f07f VARCHAR(8192) CHARACTER SET NONE,
	update__Options__Dialube83575c VARCHAR(32),
	update__Options__Dialud4e37d1a VARCHAR(32),
	update__Options__Dialuebdcaddb VARCHAR(32),
	update__Options__Dialue5acbe23 INTEGER,
	update__Options__Dialu365eb944 INTEGER,
	update__Options__IpUpd34c31b95 INTEGER,
	update__Options__OldFiles INTEGER,
	update__Options__Proxy56fd68fc INTEGER,
	update__Options__Proxy27ea031f VARCHAR(128),
	update__Options__Proxycaf0d949 INTEGER,
	update__Options__Proxy__Login VARCHAR(64),
	update__Options__Proxy__Mode INTEGER,
	update__Options__Proxyfcde8585 VARCHAR(64),
	update__Options__Proxy__Port INTEGER,
	update__Options__Proxy__Server VARCHAR(64),
	update__Options__Proxy__Type INTEGER,
	update__Options__Proxy60dcc49b INTEGER,
	update__Options__Proxy__UserID VARCHAR(128),
	update__Options__Proxy4ae19996 VARCHAR(256),
	update__Options__ShowInetFaq INTEGER,
	update__Options__TimeC1e275f0b INTEGER,
	update__Options__TimeC6b792c87 INTEGER,
	update__PostUpdateScan7fcbe385 INTEGER,
	update__PostUpdate__Afb8db5499 VARCHAR(1024),
	update__PostUpdate__Af5d532a32 INTEGER,
	update__PostUpdate__Ex94f79ebb VARCHAR(1024),
	update__PostUpdate__Or717fe010 INTEGER,
	update__proc_terminate INTEGER,
	update__restart__condition INTEGER,
	update__restart__LastR00e30fce VARCHAR(20),
	update__restart__mode INTEGER,
	update__restart__postpone_list VARCHAR(1024),
	update__restart__postpd88f29ce VARCHAR(32),
	update__restart__TimeLimit INTEGER,
	update__Result INTEGER,
	update__SetupCabFilesVersion INTEGER,
	update__ShortStateText VARCHAR(128),
	update__State INTEGER,
	update__StateText VARCHAR(128),
	update__TimeToShowSchedError INTEGER,
	update__UpdatedPriority INTEGER,
	update__UseSystemRestorePoints INTEGER
);
CREATE GENERATOR GUPDATE_CODE;
SET GENERATOR GUPDATE_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TUPDATE_NEW FOR "update" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GUPDATE_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_ADMReportTexts">
CREATE TABLE "AVG_ADMReportTexts" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	LngTable VARCHAR(8192),
	TypeId VARCHAR(36)
);
CREATE GENERATOR GAVG_ADMREPORTTEXTS_CODE;
SET GENERATOR GAVG_ADMREPORTTEXTS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_ADMREPORTTEXTS_NEW FOR "AVG_ADMReportTexts" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_ADMREPORTTEXTS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_StationsStates">
CREATE TABLE "AVG_StationsStates" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AdminClient_State INTEGER,
	AdminClient_StateText VARCHAR(128),
	AM_State INTEGER,
	AM_StateText VARCHAR(128),
	Analysis_State INTEGER,
	Analysis_StateText VARCHAR(128),
	AntiSpam_LastRuleUpdate VARCHAR(20),
	AntiSpam_State INTEGER,
	AntiSpam_StateText VARCHAR(128),
	AntiSpam_Version VARCHAR(50),
	AntiSpy_ReleaseDate VARCHAR(20),
	AntiSpy_State INTEGER,
	AntiSpy_StateText VARCHAR(128),
	AntiSpy_Version VARCHAR(50),
	AntiVirusGroup_State INTEGER,
	AntiVirusGroup_StateText VARCHAR(128),
	Antivirus_ReleaseDate VARCHAR(20),
	Antivirus_State INTEGER,
	Antivirus_StateText VARCHAR(128),
	Antivirus_Version VARCHAR(50),
	AR_State INTEGER,
	AR_StateText VARCHAR(128),
	AVG_AvgVersion VARCHAR(50),
	AVG_StationID INTEGER,
	Core_Version VARCHAR(50),
	EmailProtectionGroup_State INTEGER,
	EmailProtectionGroup_StateText VARCHAR(128),
	EMS_BATPlugin VARCHAR(40),
	EMS_ExchangePlugin VARCHAR(40),
	EMS_State INTEGER,
	EMS_StateText VARCHAR(128),
	EMS_ThunderbirdPlugin VARCHAR(40),
	FW_ConfigVersion INTEGER,
	FW_State INTEGER,
	FW_StateText VARCHAR(128),
	IDP_State INTEGER,
	IDP_StateText VARCHAR(128),
	Languages VARCHAR(512),
	LastScanTime VARCHAR(20),
	License_State INTEGER,
	License_StateText VARCHAR(128),
	LinkScannerGroup_State INTEGER,
	LinkScannerGroup_StateText VARCHAR(128),
	LinkScanner_State INTEGER,
	LinkScanner_StateText VARCHAR(128),
	NeedRestart INTEGER,
	NeedRestartTime VARCHAR(20),
	NetworkScanner_State INTEGER,
	NetworkScanner_StateText VARCHAR(128),
	RS_State INTEGER,
	RS_StateText VARCHAR(128),
	SrvExchAntiSpam_State INTEGER,
	SrvExchAntiSpam_StateText VARCHAR(128),
	SrvExchRoutingTA_State INTEGER,
	SrvExchRoutingTA_StateText VARCHAR(128),
	SrvExchSmtpTA_State INTEGER,
	SrvExchSmtpTA_StateText VARCHAR(128),
	SrvExchVSAPI_State INTEGER,
	SrvExchVSAPI_StateText VARCHAR(128),
	SrvSharePoint_State INTEGER,
	SrvSharePoint_StateText VARCHAR(128),
	UpdateMgr_State INTEGER,
	UpdateMgr_StateText VARCHAR(128),
	UserNames VARCHAR(255)
);
CREATE GENERATOR GAVG_STATIONSSTATES_CODE;
SET GENERATOR GAVG_STATIONSSTATES_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_STATIONSSTATES_NEW FOR "AVG_StationsStates" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_STATIONSSTATES_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="except">
CREATE TABLE "except" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	except__admin_file_name VARCHAR(1024),
	except__checksum VARCHAR(32) CHARACTER SET NONE,
	except__file_name VARCHAR(1024),
	except__file_name_crc INTEGER,
	except__file_size_high INTEGER,
	except__file_size_low INTEGER,
	except__flags INTEGER,
	except__full_path_crc INTEGER,
	except__type INTEGER
);
CREATE GENERATOR GEXCEPT_CODE;
SET GENERATOR GEXCEPT_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TEXCEPT_NEW FOR "except" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GEXCEPT_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="fw">
CREATE TABLE "fw" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	fw__cfg__cfgobj BLOB,
	fw__cfg__control INTEGER,
	fw__cfg__idsblacklist BLOB,
	fw__cfg__status INTEGER,
	fw__cfg__wizardcfgobj BLOB
);
CREATE GENERATOR GFW_CODE;
SET GENERATOR GFW_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TFW_NEW FOR "fw" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GFW_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="setup">
CREATE TABLE "setup" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	setup__features__admin INTEGER,
	setup__features__alert_manager INTEGER,
	setup__features__antirootkit INTEGER,
	setup__features__antispam INTEGER,
	setup__features__bat_plugin INTEGER,
	setup__features__emc INTEGER,
	setup__features__exchabb2e3a6f INTEGER,
	setup__features__firewall INTEGER,
	setup__features__http_scanner INTEGER,
	setup__features__idp INTEGER,
	setup__features__languages VARCHAR(1024),
	setup__features__ntfs_01532744 INTEGER,
	setup__features__offic6751be59 INTEGER,
	setup__features__residf85f299f INTEGER,
	setup__features__safe_search INTEGER,
	setup__features__safe_surf INTEGER,
	setup__features__setti29d73081 INTEGER,
	setup__features__srv_a91b2cc14 INTEGER,
	setup__features__srv_a5bfffddd INTEGER,
	setup__features__srv_e9e808cba INTEGER,
	setup__features__srv_efb5f7107 INTEGER,
	setup__features__srv_e26f252af INTEGER,
	setup__features__system_tools INTEGER,
	setup__features__toolbar INTEGER,
	setup__install_type INTEGER,
	setup__managed_mode INTEGER
);
CREATE GENERATOR GSETUP_CODE;
SET GENERATOR GSETUP_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TSETUP_NEW FOR "setup" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GSETUP_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="updatecomps">
CREATE TABLE "updatecomps" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	updatecomps__BuildNumber INTEGER,
	updatecomps__Componentdeaf68ee VARCHAR(1024),
	updatecomps__Component74e78c23 VARCHAR(1024),
	updatecomps__ComponentsListVir VARCHAR(1024),
	updatecomps__PaidComponentList VARCHAR(1024),
	updatecomps__ProgramRestart INTEGER,
	updatecomps__StateInfob418f94f INTEGER,
	updatecomps__StateInfob2043c7f VARCHAR(1024),
	updatecomps__StateInfo578c42d4 INTEGER,
	updatecomps__StateInfo74ac2f54 VARCHAR(1024),
	updatecomps__StateInfo912451ff INTEGER,
	updatecomps__VirDbUpdated INTEGER,
	updatecomps__VirRestart INTEGER
);
CREATE GENERATOR GUPDATECOMPS_CODE;
SET GENERATOR GUPDATECOMPS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TUPDATECOMPS_NEW FOR "updatecomps" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GUPDATECOMPS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_Servers">
CREATE TABLE "AVG_Servers" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_BuildType INTEGER,
	AVG_IPAddress VARCHAR(50),
	AVG_IPv4 VARCHAR(16),
	AVG_IPv6 VARCHAR(50),
	AVG_LastCall VARCHAR(20),
	AVG_LastDbExport VARCHAR(20),
	AVG_LastDownloadTime VARCHAR(20),
	AVG_LastUpdateCheck VARCHAR(20),
	AVG_LastUpdateResult INTEGER,
	AVG_LastUploadTime VARCHAR(20),
	AVG_LicenseNumber VARCHAR(64),
	AVG_ListenPort INTEGER,
	AVG_MACAddress VARCHAR(18),
	AVG_ServerDomain VARCHAR(64),
	AVG_ServerName VARCHAR(64),
	AVG_StationType INTEGER,
	AVG_TodayDownloadedCount INTEGER,
	AVG_TodayDownloadedSize VARCHAR(20),
	AVG_TodayUploadedCount INTEGER,
	AVG_TodayUploadedSize VARCHAR(20)
);
CREATE GENERATOR GAVG_SERVERS_CODE;
SET GENERATOR GAVG_SERVERS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_SERVERS_NEW FOR "AVG_Servers" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_SERVERS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_Versions">
CREATE TABLE "AVG_Versions" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	BuildNumber INTEGER,
	DowloadUrl VARCHAR(256),
	MinClient VARCHAR(32),
	ProductName VARCHAR(64),
	ReleaseTime VARCHAR(20),
	Version VARCHAR(32),
	XmlTimestamp VARCHAR(20)
);
CREATE GENERATOR GAVG_VERSIONS_CODE;
SET GENERATOR GAVG_VERSIONS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_VERSIONS_NEW FOR "AVG_Versions" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_VERSIONS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="hlog">
CREATE TABLE "hlog" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	hlog__filename VARCHAR(32),
	hlog__maxfilesize INTEGER
);
CREATE GENERATOR GHLOG_CODE;
SET GENERATOR GHLOG_CODE TO 0;
<SQLBlock>
CREATE TRIGGER THLOG_NEW FOR "hlog" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GHLOG_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="user">
CREATE TABLE "user" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	user__components__ignore INTEGER,
	user__custom__expdlg_message VARCHAR(250),
	user__custom__expdlg_type INTEGER,
	user__firewall__notifi792efd77 INTEGER,
	user__free_forum_news INTEGER,
	user__free_forum_reg VARCHAR(32),
	user__gamingmode__enabled INTEGER,
	user__idp__notificatio8ae92dcb INTEGER,
	user__license_upgrade_e5069c0c INTEGER,
	user__ondemand__suppred94d72d5 INTEGER,
	user__pctuneup__notifib690d292 INTEGER,
	user__postpone__first_0fb18755 INTEGER,
	user__postpone__rebootaf119b3c INTEGER,
	user__postpone__upgrad79fb7f6f INTEGER,
	user__productusage__rea9476a00 INTEGER,
	user__residentshield__31547326 INTEGER,
	user__scan__trayicon_disabled INTEGER,
	user__srm__logseverity INTEGER,
	user__tray__icon_disabled INTEGER,
	user__tray__notify_comp INTEGER,
	user__tray__notify_fw INTEGER,
	user__tray__notify_fw_app_rule INTEGER,
	user__tray__notify_fw_profile INTEGER,
	user__tray__notify_global INTEGER,
	user__tray__notify_idp INTEGER,
	user__tray__notify_rs INTEGER,
	user__tray__notify_scan INTEGER,
	user__tray__notify_stat INTEGER,
	user__tray__notify_upd INTEGER,
	user__tray__user_inter058d7401 INTEGER,
	user__tray__user_inter6e6ff0c7 INTEGER,
	user__user_signup__changed INTEGER,
	user__user_signup__cho271ad4b5 INTEGER,
	user__user_signup__firstname VARCHAR(64),
	user__user_signup__full_name VARCHAR(32),
	user__user_signup__lastname VARCHAR(64),
	user__user_signup__title INTEGER,
	user__webshield__notification INTEGER,
	user__webshield__notif7811ff70 INTEGER
);
CREATE GENERATOR GUSER_CODE;
SET GENERATOR GUSER_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TUSER_NEW FOR "user" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GUSER_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="ameh">
CREATE TABLE "ameh" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	ameh__conv_str VARCHAR(4096),
	ameh__default_config VARCHAR(2048) CHARACTER SET NONE,
	ameh__description VARCHAR(128),
	ameh__guid VARCHAR(64),
	ameh__module_name VARCHAR(64),
	ameh__name VARCHAR(64),
	ameh__translate_attributes INTEGER,
	ameh__translate_language INTEGER,
	ameh__visible INTEGER
);
CREATE GENERATOR GAMEH_CODE;
SET GENERATOR GAMEH_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAMEH_NEW FOR "ameh" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAMEH_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_VirusVault">
CREATE TABLE "AVG_VirusVault" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_DetectionName VARCHAR(512),
	AVG_DetectionSeverity INTEGER,
	AVG_InsertTimeStamp VARCHAR(20),
	AVG_ObjectName VARCHAR(512),
	AVG_ObjectOriginalName VARCHAR(512),
	AVG_ObjectType INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_ScanResultIndex VARCHAR(512),
	AVG_VaultItemIndex INTEGER
);
CREATE GENERATOR GAVG_VIRUSVAULT_CODE;
SET GENERATOR GAVG_VIRUSVAULT_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_VIRUSVAULT_NEW FOR "AVG_VirusVault" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_VIRUSVAULT_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="admin">
CREATE TABLE "admin" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	admin__allowed_actionsf8585ad6 INTEGER,
	admin__allowed_actionsbaba6565 INTEGER,
	admin__allowed_actions2040876e INTEGER,
	admin__allowed_actions931b6ef2 INTEGER,
	admin__allowed_actions3ee0f921 INTEGER,
	admin__allowed_actions9ba9bc7e INTEGER,
	admin__allowed_actions3e928c55 INTEGER,
	admin__allowed_actions55516f1d INTEGER,
	admin__allowed_actions18b7c485 INTEGER,
	admin__allowed_actions5ea8205a INTEGER,
	admin__allowed_actionsa871fc8a INTEGER,
	admin__allowed_actions7ceee145 INTEGER,
	admin__allowed_actions7a5ce30e INTEGER,
	admin__allowed_actions5d1229b0 INTEGER,
	admin__allowed_actionsa4e1e590 INTEGER,
	admin__allowed_actionsd0067b2c INTEGER,
	admin__allowed_actions4c10646e INTEGER,
	admin__allowed_actions706b33bd INTEGER,
	admin__allowed_actions41918f02 INTEGER,
	admin__am_mail_offline75e8bac3 INTEGER,
	admin__am_mail_offlineeadcaad9 INTEGER,
	admin__am_mail_offline4d6037fb INTEGER,
	admin__database VARCHAR(250),
	admin__override_mandatd9fae4d2 INTEGER,
	admin__period_backlog_1d9eb744 INTEGER,
	admin__period_cfg_synchro INTEGER,
	admin__period_compsts_check INTEGER,
	admin__period_msg_withdraw INTEGER,
	admin__port_in INTEGER,
	admin__synchro_optionsc744ce28 INTEGER,
	admin__synchro_options7567a195 INTEGER
);
CREATE GENERATOR GADMIN_CODE;
SET GENERATOR GADMIN_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TADMIN_NEW FOR "admin" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GADMIN_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_AMEvents">
CREATE TABLE "AVG_AMEvents" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AMAttributes VARCHAR(4092) CHARACTER SET NONE,
	AMConfirmed INTEGER,
	AMDate VARCHAR(20),
	AMHostName VARCHAR(64),
	AMPID INTEGER,
	AMSeverity INTEGER,
	AMSource VARCHAR(64),
	AMType VARCHAR(64),
	AMUserName VARCHAR(64),
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER
);
CREATE GENERATOR GAVG_AMEVENTS_CODE;
SET GENERATOR GAVG_AMEVENTS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_AMEVENTS_NEW FOR "AVG_AMEvents" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_AMEVENTS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="amrules">
CREATE TABLE "amrules" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	amrules__actions VARCHAR(8192) CHARACTER SET NONE,
	amrules__conditions VARCHAR(4096),
	amrules__enabled INTEGER,
	amrules__name VARCHAR(128),
	amrules__visible INTEGER
);
CREATE GENERATOR GAMRULES_CODE;
SET GENERATOR GAMRULES_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAMRULES_NEW FOR "amrules" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAMRULES_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_Accounts">
CREATE TABLE "AVG_Accounts" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	Description VARCHAR(255),
	IsActive INTEGER,
	Login VARCHAR(128),
	PasswordHash VARCHAR(128),
	Permissions VARCHAR(255),
	SSOAccount VARCHAR(255)
);
CREATE GENERATOR GAVG_ACCOUNTS_CODE;
SET GENERATOR GAVG_ACCOUNTS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_ACCOUNTS_NEW FOR "AVG_Accounts" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_ACCOUNTS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_AccountsGroups">
CREATE TABLE "AVG_AccountsGroups" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AccountId INTEGER,
	GroupId INTEGER,
	Permission INTEGER
);
CREATE GENERATOR GAVG_ACCOUNTSGROUPS_CODE;
SET GENERATOR GAVG_ACCOUNTSGROUPS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_ACCOUNTSGROUPS_NEW FOR "AVG_AccountsGroups" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_ACCOUNTSGROUPS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="krnlall">
CREATE TABLE "krnlall" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	krnlall__initscan__passed INTEGER,
	krnlall__system__currea2e817c8 INTEGER
);
CREATE GENERATOR GKRNLALL_CODE;
SET GENERATOR GKRNLALL_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TKRNLALL_NEW FOR "krnlall" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GKRNLALL_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="malrep">
CREATE TABLE "malrep" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	malrep__enabled INTEGER,
	malrep__hidden_reports5517c702 INTEGER,
	malrep__hidden_reports5e9deaee INTEGER,
	malrep__includedcomponents INTEGER,
	malrep__lastreport VARCHAR(20),
	malrep__last_longtermreport VARCHAR(20),
	malrep__longterm_period INTEGER,
	malrep__mtrap__allowed INTEGER,
	malrep__mtrap__send INTEGER,
	malrep__prevUID INTEGER,
	malrep__priority INTEGER,
	malrep__reportedmalwaretypes INTEGER
);
CREATE GENERATOR GMALREP_CODE;
SET GENERATOR GMALREP_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TMALREP_NEW FOR "malrep" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GMALREP_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="oop">
CREATE TABLE "oop" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	oop__enableoopheal INTEGER,
	oop__enableoopscan INTEGER
);
CREATE GENERATOR GOOP_CODE;
SET GENERATOR GOOP_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TOOP_NEW FOR "oop" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GOOP_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="srmall">
CREATE TABLE "srmall" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	srmall__checkscanresults INTEGER
);
CREATE GENERATOR GSRMALL_CODE;
SET GENERATOR GSRMALL_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TSRMALL_NEW FOR "srmall" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GSRMALL_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="updateall">
CREATE TABLE "updateall" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	updateall__DiagHeaders VARCHAR(1024),
	updateall__License__LicChanged INTEGER,
	updateall__OFAP__Deleted VARCHAR(1024),
	updateall__OFAP__Enabled INTEGER,
	updateall__OFAP__ID VARCHAR(1024),
	updateall__OFAP__IDChanged INTEGER,
	updateall__ONAP__Deleted VARCHAR(1024),
	updateall__ONAP__Enabled INTEGER,
	updateall__ONAP__FailCount INTEGER,
	updateall__ONAP__ID VARCHAR(1024),
	updateall__ONAP__IDChanged INTEGER,
	updateall__RevertAvi__70903fdb VARCHAR(32),
	updateall__UpdateProce3f9a563c INTEGER,
	updateall__UpdateProce7343ffbc VARCHAR(32),
	updateall__UpdateProce6b9402ea VARCHAR(32),
	updateall__UpdateProcebc21e0d6 INTEGER,
	updateall__UpdateProce72d76b59 VARCHAR(32)
);
CREATE GENERATOR GUPDATEALL_CODE;
SET GENERATOR GUPDATEALL_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TUPDATEALL_NEW FOR "updateall" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GUPDATEALL_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="changecfgreg">
CREATE TABLE "changecfgreg" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	changecfgreg__cfgbackup VARCHAR(250) CHARACTER SET NONE,
	changecfgreg__cfgid VARCHAR(250) CHARACTER SET NONE,
	changecfgreg__enabledcfg INTEGER,
	changecfgreg__enabledreg INTEGER,
	changecfgreg__processeb9f954d4 INTEGER,
	changecfgreg__processec4636fd2 INTEGER,
	changecfgreg__processe36937e38 INTEGER,
	changecfgreg__processef42efe0b INTEGER,
	changecfgreg__regbackup VARCHAR(250) CHARACTER SET NONE,
	changecfgreg__regid VARCHAR(250) CHARACTER SET NONE
);
CREATE GENERATOR GCHANGECFGREG_CODE;
SET GENERATOR GCHANGECFGREG_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TCHANGECFGREG_NEW FOR "changecfgreg" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GCHANGECFGREG_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="userall">
CREATE TABLE "userall" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	userall__scan__first INTEGER,
	userall__scan__Last_Ex32f574d8 VARCHAR(1024),
	userall__scan__Last_Target VARCHAR(1024)
);
CREATE GENERATOR GUSERALL_CODE;
SET GENERATOR GUSERALL_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TUSERALL_NEW FOR "userall" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GUSERALL_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_FileStorage">
CREATE TABLE "AVG_FileStorage" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_CompressedSize INTEGER,
	AVG_Compression INTEGER,
	AVG_ExpirationTime VARCHAR(20),
	AVG_FileName VARCHAR(250),
	AVG_FileSize INTEGER,
	AVG_FileTime VARCHAR(20),
	AVG_GUID VARCHAR(255),
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_StoredSize INTEGER,
	AVG_Type VARCHAR(64)
);
CREATE GENERATOR GAVG_FILESTORAGE_CODE;
SET GENERATOR GAVG_FILESTORAGE_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_FILESTORAGE_NEW FOR "AVG_FileStorage" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_FILESTORAGE_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_QuarItems">
CREATE TABLE "AVG_QuarItems" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_Category VARCHAR(256),
	AVG_CategoryKey INTEGER,
	AVG_Date VARCHAR(20),
	AVG_Description VARCHAR(1024),
	AVG_DescriptionKey INTEGER,
	AVG_FileCount INTEGER,
	AVG_ID INTEGER,
	AVG_Level INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_PathName VARCHAR(512),
	AVG_ProcessCount INTEGER,
	AVG_RegistryCount INTEGER,
	AVG_RID VARCHAR(64),
	AVG_ShortName VARCHAR(256),
	AVG_User VARCHAR(64)
);
CREATE GENERATOR GAVG_QUARITEMS_CODE;
SET GENERATOR GAVG_QUARITEMS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_QUARITEMS_NEW FOR "AVG_QuarItems" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_QUARITEMS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_QuarComponents">
CREATE TABLE "AVG_QuarComponents" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_Characteristics VARCHAR(256),
	AVG_ComponentType INTEGER,
	AVG_ErrorMessage VARCHAR(512),
	AVG_MD5 VARCHAR(32),
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_ParentCode INTEGER,
	AVG_ParentID INTEGER,
	AVG_PathName VARCHAR(256),
	AVG_PID INTEGER,
	AVG_RegistryKeys VARCHAR(4098),
	AVG_ShortName VARCHAR(256),
	AVG_Suceeded INTEGER
);
CREATE GENERATOR GAVG_QUARCOMPONENTS_CODE;
SET GENERATOR GAVG_QUARCOMPONENTS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_QUARCOMPONENTS_NEW FOR "AVG_QuarComponents" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_QUARCOMPONENTS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="idp">
CREATE TABLE "idp" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	idp__allowed_items VARCHAR(250) CHARACTER SET NONE,
	idp__detection_timeout INTEGER,
	idp__enabled INTEGER,
	idp__log__agent__level INTEGER,
	idp__log__agent__max_fa3fce9d0 INTEGER,
	idp__log__agent__max_file_size VARCHAR(20),
	idp__log__sdk__level INTEGER,
	idp__log__sdk__max_file_count INTEGER,
	idp__log__sdk__max_file_size VARCHAR(20),
	idp__minimize_indicators INTEGER,
	idp__prompt INTEGER,
	idp__prompt_to_save INTEGER,
	idp__show_removal_details INTEGER,
	idp__show_removal_progress INTEGER,
	idp__submit_malware INTEGER,
	idp__suspend_on_detection INTEGER
);
CREATE GENERATOR GIDP_CODE;
SET GENERATOR GIDP_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TIDP_NEW FOR "idp" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GIDP_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="mailsrv">
CREATE TABLE "mailsrv" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	mailsrv__certification5de31b4a INTEGER,
	mailsrv__certificationad5a7de3 VARCHAR(32),
	mailsrv__enabled INTEGER,
	mailsrv__infection__action INTEGER,
	mailsrv__infection__mad1b92d38 INTEGER,
	mailsrv__infection__sud2f7313a VARCHAR(32),
	mailsrv__information__action INTEGER,
	mailsrv__information__1e041832 INTEGER,
	mailsrv__information__7eabd22e VARCHAR(32),
	mailsrv__language INTEGER,
	mailsrv__logs__size INTEGER,
	mailsrv__PUP__action INTEGER,
	mailsrv__PUP__marksubject INTEGER,
	mailsrv__PUP__subjectprefix VARCHAR(32),
	mailsrv__statistics__healed VARCHAR(20),
	mailsrv__statistics__scanned VARCHAR(20),
	mailsrv__statistics__s15f5fe37 VARCHAR(20),
	mailsrv__statistics__threats VARCHAR(20),
	mailsrv__warning__action INTEGER,
	mailsrv__warning__marksubject INTEGER,
	mailsrv__warning__subje159f62e VARCHAR(32)
);
CREATE GENERATOR GMAILSRV_CODE;
SET GENERATOR GMAILSRV_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TMAILSRV_NEW FOR "mailsrv" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GMAILSRV_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="mailsrvvsapi">
CREATE TABLE "mailsrvvsapi" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	mailsrvvsapi__attfilte15e8a239 INTEGER,
	mailsrvvsapi__enabled INTEGER,
	mailsrvvsapi__infectio9111d8c1 INTEGER,
	mailsrvvsapi__informata9e223d9 INTEGER,
	mailsrvvsapi__language INTEGER,
	mailsrvvsapi__logs__size INTEGER,
	mailsrvvsapi__PUP__action INTEGER,
	mailsrvvsapi__statistid86e928f VARCHAR(20),
	mailsrvvsapi__statistic2741545 VARCHAR(20),
	mailsrvvsapi__statistie5819df2 VARCHAR(20),
	mailsrvvsapi__statistidafe966b VARCHAR(20),
	mailsrvvsapi__statisti8252edf2 VARCHAR(20),
	mailsrvvsapi__statisti591d978e VARCHAR(20),
	mailsrvvsapi__statistics__pups VARCHAR(20),
	mailsrvvsapi__statisti926eb6c4 VARCHAR(20),
	mailsrvvsapi__statisti8553a205 VARCHAR(20),
	mailsrvvsapi__statisti1619f330 VARCHAR(20),
	mailsrvvsapi__statistiabad4c69 VARCHAR(20),
	mailsrvvsapi__VSAPI__backscan INTEGER,
	mailsrvvsapi__VSAPI__p43223c81 INTEGER,
	mailsrvvsapi__VSAPI__rtfscan INTEGER,
	mailsrvvsapi__VSAPI__s687c64ae INTEGER,
	mailsrvvsapi__VSAPI__s86b32ce1 INTEGER,
	mailsrvvsapi__VSAPI__t3d6822e1 INTEGER,
	mailsrvvsapi__warning__action INTEGER
);
CREATE GENERATOR GMAILSRVVSAPI_CODE;
SET GENERATOR GMAILSRVVSAPI_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TMAILSRVVSAPI_NEW FOR "mailsrvvsapi" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GMAILSRVVSAPI_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="spsrv">
CREATE TABLE "spsrv" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	spsrv__infection__action INTEGER,
	spsrv__information__action INTEGER,
	spsrv__logs__size INTEGER,
	spsrv__PUP__action INTEGER,
	spsrv__statistics__healed VARCHAR(20),
	spsrv__statistics__scanned VARCHAR(20),
	spsrv__statistics__sta3e660eff VARCHAR(20),
	spsrv__statistics__threats VARCHAR(20),
	spsrv__warning__action INTEGER
);
CREATE GENERATOR GSPSRV_CODE;
SET GENERATOR GSPSRV_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TSPSRV_NEW FOR "spsrv" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GSPSRV_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="idpallow">
CREATE TABLE "idpallow" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	idpallow__admin_file_name VARCHAR(1024),
	idpallow__checksum VARCHAR(32) CHARACTER SET NONE,
	idpallow__def_time VARCHAR(20),
	idpallow__file_name VARCHAR(1024),
	idpallow__flags INTEGER,
	idpallow__level INTEGER
);
CREATE GENERATOR GIDPALLOW_CODE;
SET GENERATOR GIDPALLOW_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TIDPALLOW_NEW FOR "idpallow" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GIDPALLOW_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="usergui">
CREATE TABLE "usergui" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	usergui__antispam__repa946843d INTEGER,
	usergui__antispam__repf56e4d1a INTEGER,
	usergui__lock_hwnd__tray INTEGER,
	usergui__lock_hwnd__ui INTEGER,
	usergui__renewal__last1948ca44 VARCHAR(20),
	usergui__renewal__nextc7b1b0fa VARCHAR(20),
	usergui__renewal__remi16b315d8 INTEGER,
	usergui__sound__enabled INTEGER
);
CREATE GENERATOR GUSERGUI_CODE;
SET GENERATOR GUSERGUI_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TUSERGUI_NEW FOR "usergui" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GUSERGUI_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="erd">
CREATE TABLE "erd" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	erd__appearance_step INTEGER,
	erd__coi__full INTEGER,
	erd__coi__sales INTEGER,
	erd__coi__trial INTEGER,
	erd__downgrade__allowed INTEGER,
	erd__end_yellow_period INTEGER,
	erd__first_appearance INTEGER,
	erd__remind_me_list VARCHAR(1024),
	erd__start_daily_appearance INTEGER
);
CREATE GENERATOR GERD_CODE;
SET GENERATOR GERD_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TERD_NEW FOR "erd" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GERD_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_UserRegistry">
CREATE TABLE "AVG_UserRegistry" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	regKey VARCHAR(250),
	regValue VARCHAR(2048),
	userId INTEGER,
	valueType INTEGER
);
CREATE GENERATOR GAVG_USERREGISTRY_CODE;
SET GENERATOR GAVG_USERREGISTRY_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_USERREGISTRY_NEW FOR "AVG_UserRegistry" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_USERREGISTRY_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="cachesrv">
CREATE TABLE "cachesrv" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	cachesrv__enabled INTEGER,
	cachesrv__enabledFilling INTEGER
);
CREATE GENERATOR GCACHESRV_CODE;
SET GENERATOR GCACHESRV_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TCACHESRV_NEW FOR "cachesrv" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GCACHESRV_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_EventHistory">
CREATE TABLE "AVG_EventHistory" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_Date VARCHAR(20),
	AVG_Description VARCHAR(2048),
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Source VARCHAR(250),
	AVG_User VARCHAR(250)
);
CREATE GENERATOR GAVG_EVENTHISTORY_CODE;
SET GENERATOR GAVG_EVENTHISTORY_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_EVENTHISTORY_NEW FOR "AVG_EventHistory" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_EVENTHISTORY_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_Installer">
CREATE TABLE "AVG_Installer" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_Date VARCHAR(20),
	AVG_GroupName VARCHAR(250),
	AVG_IniFileGuid VARCHAR(250),
	AVG_InstallationPaused INTEGER,
	AVG_InstallationVisible INTEGER,
	AVG_InstallResult INTEGER,
	AVG_InstallState INTEGER,
	AVG_License VARCHAR(64),
	AVG_LogDir VARCHAR(250),
	AVG_Name VARCHAR(250),
	AVG_QuitIfInstalled INTEGER,
	AVG_SetupFileGuid VARCHAR(250),
	AVG_SetupFileGuid64 VARCHAR(250),
	AVG_SetupFileName VARCHAR(255),
	AVG_SetupFileName64 VARCHAR(255),
	AVG_SetupFileRemoveAfterDays INTEGER,
	AVG_SetupFileSource INTEGER,
	AVG_TargetPath VARCHAR(512)
);
CREATE GENERATOR GAVG_INSTALLER_CODE;
SET GENERATOR GAVG_INSTALLER_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_INSTALLER_NEW FOR "AVG_Installer" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_INSTALLER_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="AVG_InstallStations">
CREATE TABLE "AVG_InstallStations" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_AvgVersion VARCHAR(64),
	AVG_Credentials VARCHAR(4000) CHARACTER SET NONE,
	AVG_GroupName VARCHAR(250),
	AVG_InstallerId INTEGER,
	AVG_InstallTime VARCHAR(20),
	AVG_IpAddress VARCHAR(50),
	AVG_Result INTEGER,
	AVG_State INTEGER,
	AVG_StateIcon INTEGER,
	AVG_StationName VARCHAR(64)
);
CREATE GENERATOR GAVG_INSTALLSTATIONS_CODE;
SET GENERATOR GAVG_INSTALLSTATIONS_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TAVG_INSTALLSTATIONS_NEW FOR "AVG_InstallStations" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GAVG_INSTALLSTATIONS_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="rsexcludes">
CREATE TABLE "rsexcludes" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	rsexcludes__enabled INTEGER,
	rsexcludes__name VARCHAR(2048),
	rsexcludes__rspaths VARCHAR(4096),
	rsexcludes__type INTEGER
);
CREATE GENERATOR GRSEXCLUDES_CODE;
SET GENERATOR GRSEXCLUDES_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TRSEXCLUDES_NEW FOR "rsexcludes" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GRSEXCLUDES_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="csl">
CREATE TABLE "csl" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	csl__heartbeat__isSubmd1c0a2da INTEGER,
	csl__heartbeat__lastHed0ecfc14 INTEGER,
	csl__heartbeat__lastHe6fb3562e VARCHAR(20),
	csl__heartbeat__nextCh8826c8a5 INTEGER,
	csl__heartbeat__nextHe82d81b2d INTEGER,
	csl__heartbeat__nextSe9301c1b6 INTEGER,
	csl__heartbeat__nextUpf5a563f9 INTEGER,
	csl__heartbeat__nextWhbad3c75d INTEGER,
	csl__heartbeat__onlinebaca8a6f INTEGER,
	csl__iavichjg__sha256 VARCHAR(250) CHARACTER SET NONE,
	csl__reporting__enabled INTEGER,
	csl__requestSpec__quer289b596a INTEGER,
	csl__requestSpec__quer9dca4692 INTEGER,
	csl__requestSpec__quer13080908 INTEGER,
	csl__requestSpec__quer25710005 INTEGER,
	csl__requestSpec__quer417694d1 INTEGER,
	csl__requestSpec__updaee9bad92 INTEGER,
	csl__requestSpec__upda8a9c3946 INTEGER,
	csl__scan__detectionSeverity INTEGER,
	csl__scan__filterCookies INTEGER,
	csl__scan__timeout INTEGER,
	csl__servers__heartbeat VARCHAR(1024),
	csl__servers__onlineVe72af2e81 VARCHAR(1024),
	csl__servers__whitelisting VARCHAR(1024),
	csl__srm__detectionSeverity INTEGER,
	csl__srm__filterCookies INTEGER,
	csl__srm__timeout INTEGER
);
CREATE GENERATOR GCSL_CODE;
SET GENERATOR GCSL_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TCSL_NEW FOR "csl" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GCSL_CODE,1);
END;
</SQLBlock>

</Table>
<Table name="emssrv9">
CREATE TABLE "emssrv9" (
	AVG_Code INTEGER NOT NULL UNIQUE,
	AVG_RecVersion INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Version VARCHAR(16),
	AVG_CompareMark VARCHAR(20),
	AVG_TimeStamp VARCHAR(20),
	AVG_AdminCode INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_FactoryId INTEGER,
	emssrv__automatic INTEGER,
	emssrv__enabled INTEGER,
	emssrv__host VARCHAR(32),
	emssrv__interface VARCHAR(32),
	emssrv__name VARCHAR(32),
	emssrv__pop__apop INTEGER,
	emssrv__pop__logon INTEGER,
	emssrv__port INTEGER,
	emssrv__redirport INTEGER,
	emssrv__smtp__bounce INTEGER,
	emssrv__smtp__forward INTEGER,
	emssrv__type INTEGER,
	emssrv__use_ssl INTEGER,
	emssrv__write_header INTEGER
);
CREATE GENERATOR GEMSSRV9_CODE;
SET GENERATOR GEMSSRV9_CODE TO 0;
<SQLBlock>
CREATE TRIGGER TEMSSRV9_NEW FOR "emssrv9" BEFORE INSERT POSITION 0 AS
BEGIN
NEW.AVG_CODE = GEN_ID(GEMSSRV9_CODE,1);
END;
</SQLBlock>

</Table>

<Index name="AVG_Messages">
CREATE INDEX AVG_Messages_Receiver_Idx ON "AVG_Messages"(AVG_ReceiverType, AVG_ReceiverID);
</Index>

<Index name="AVG_ScanResults">
CREATE INDEX AVG_ScanResults_Parent_Idx ON "AVG_ScanResults"(AVG_ParentCode);
</Index>

<Index name="AVG_ScanLogs">
CREATE INDEX AVG_ScanLogs_Owner_Idx ON "AVG_ScanLogs"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="AVG_Stations">
CREATE INDEX AVG_Stations_IP_Idx ON "AVG_Stations"(AVG_IPAddress, AVG_StationType);
</Index>

<Index name="AVG_Stations">
CREATE INDEX AVG_Stations_MAC_Idx ON "AVG_Stations"(AVG_MACAddress, AVG_StationType);
</Index>

<Index name="AVG_Stations">
CREATE INDEX AVG_Stations_Name_Idx ON "AVG_Stations"(AVG_StationName, AVG_StationType);
</Index>

<Index name="AVG_Stations">
CREATE INDEX AVG_Stations_NameDomain_Idx ON "AVG_Stations"(AVG_StationName, AVG_StationDomain, AVG_StationType);
</Index>

<Index name="aspam">
CREATE INDEX aspam_Owner_Idx ON "aspam"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="aspmlist">
CREATE INDEX aspmlist_Owner_Idx ON "aspmlist"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="emssrv">
CREATE INDEX emssrv_Owner_Idx ON "emssrv"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="krnl">
CREATE INDEX krnl_Owner_Idx ON "krnl"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="mail">
CREATE INDEX mail_Owner_Idx ON "mail"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="scan">
CREATE INDEX scan_Owner_Idx ON "scan"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="sched">
CREATE INDEX sched_Owner_Idx ON "sched"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="update">
CREATE INDEX update_Owner_Idx ON "update"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="AVG_StationsStates">
CREATE INDEX AVG_StationsStates_StationIdx ON "AVG_StationsStates"(AVG_StationID);
</Index>

<Index name="except">
CREATE INDEX except_Owner_Idx ON "except"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="fw">
CREATE INDEX fw_Owner_Idx ON "fw"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="setup">
CREATE INDEX setup_Owner_Idx ON "setup"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="updatecomps">
CREATE INDEX updatecomps_Owner_Idx ON "updatecomps"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="hlog">
CREATE INDEX hlog_Owner_Idx ON "hlog"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="user">
CREATE INDEX user_Owner_Idx ON "user"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="ameh">
CREATE INDEX ameh_Owner_Idx ON "ameh"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="AVG_VirusVault">
CREATE INDEX AVG_VirusVault_Owner_Idx ON "AVG_VirusVault"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="admin">
CREATE INDEX admin_Owner_Idx ON "admin"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="AVG_AMEvents">
CREATE INDEX AVG_AMEvents_Owner_Idx ON "AVG_AMEvents"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="amrules">
CREATE INDEX amrules_Owner_Idx ON "amrules"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="AVG_AccountsGroups">
CREATE INDEX AVG_AccountsGroups_AID_Idx ON "AVG_AccountsGroups"(AccountId);
</Index>

<Index name="krnlall">
CREATE INDEX krnlall_Owner_Idx ON "krnlall"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="malrep">
CREATE INDEX malrep_Owner_Idx ON "malrep"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="oop">
CREATE INDEX oop_Owner_Idx ON "oop"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="srmall">
CREATE INDEX srmall_Owner_Idx ON "srmall"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="updateall">
CREATE INDEX updateall_Owner_Idx ON "updateall"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="changecfgreg">
CREATE INDEX changecfgreg_Owner_Idx ON "changecfgreg"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="userall">
CREATE INDEX userall_Owner_Idx ON "userall"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="idp">
CREATE INDEX idp_Owner_Idx ON "idp"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="mailsrv">
CREATE INDEX mailsrv_Owner_Idx ON "mailsrv"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="mailsrvvsapi">
CREATE INDEX mailsrvvsapi_Owner_Idx ON "mailsrvvsapi"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="spsrv">
CREATE INDEX spsrv_Owner_Idx ON "spsrv"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="idpallow">
CREATE INDEX idpallow_Owner_Idx ON "idpallow"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="usergui">
CREATE INDEX usergui_Owner_Idx ON "usergui"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="erd">
CREATE INDEX erd_Owner_Idx ON "erd"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="cachesrv">
CREATE INDEX cachesrv_Owner_Idx ON "cachesrv"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="AVG_EventHistory">
CREATE INDEX AVG_EventHistory_Owner_Idx ON "AVG_EventHistory"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="rsexcludes">
CREATE INDEX rsexcludes_Owner_Idx ON "rsexcludes"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="csl">
CREATE INDEX csl_Owner_Idx ON "csl"(AVG_OwnerType, AVG_OwnerID);
</Index>

<Index name="emssrv9">
CREATE INDEX emssrv9_Owner_Idx ON "emssrv9"(AVG_OwnerType, AVG_OwnerID);
</Index>
<Trigger name="AVG_ADMRepType">

</Trigger>
<Trigger name="AVG_ADMRepTplFiles">

</Trigger>
<Trigger name="AVG_ADMRepTypeConf">

</Trigger>
<Trigger name="AVG_ADMRepShedule">

</Trigger>
<Trigger name="AVG_ADMRepSheduleConf">

</Trigger>
<Trigger name="AVG_ADMRepReport">

</Trigger>
<Trigger name="AVG_DefTables">

</Trigger>
<Trigger name="AVG_DefDatabase">

</Trigger>
<Trigger name="AVG_Messages">

</Trigger>
<Trigger name="AVG_Properties">

</Trigger>
<Trigger name="AVG_ScanResults">

</Trigger>
<Trigger name="AVG_ScanLogs">

</Trigger>
<Trigger name="AVG_Stations">

</Trigger>
<Trigger name="AVG_Groups">

</Trigger>
<Trigger name="AVG_DefMaintenance">

</Trigger>
<Trigger name="AVG_DefViews">

</Trigger>
<Trigger name="AVG_DefViewColumns">

</Trigger>
<Trigger name="AVG_DefViewFilters">

</Trigger>
<Trigger name="AVG_DefViewsConditions">

</Trigger>
<Trigger name="AVG_EMTerm">

</Trigger>
<Trigger name="AVG_EMTermCfg">

</Trigger>
<Trigger name="AVG_EMTermCfgEnum">

</Trigger>
<Trigger name="AVG_EMTermColumns">

</Trigger>
<Trigger name="AVG_EMNotifyTrigger">

</Trigger>
<Trigger name="AVG_EMNotifyTriggerCfg">

</Trigger>
<Trigger name="aspam">

</Trigger>
<Trigger name="aspmlist">

</Trigger>
<Trigger name="emssrv">

</Trigger>
<Trigger name="krnl">

</Trigger>
<Trigger name="mail">

</Trigger>
<Trigger name="scan">

</Trigger>
<Trigger name="sched">

</Trigger>
<Trigger name="update">

</Trigger>
<Trigger name="AVG_ADMReportTexts">

</Trigger>
<Trigger name="AVG_StationsStates">

</Trigger>
<Trigger name="except">

</Trigger>
<Trigger name="fw">

</Trigger>
<Trigger name="setup">

</Trigger>
<Trigger name="updatecomps">

</Trigger>
<Trigger name="AVG_Servers">

</Trigger>
<Trigger name="AVG_Versions">

</Trigger>
<Trigger name="hlog">

</Trigger>
<Trigger name="user">

</Trigger>
<Trigger name="ameh">

</Trigger>
<Trigger name="AVG_VirusVault">

</Trigger>
<Trigger name="admin">

</Trigger>
<Trigger name="AVG_AMEvents">

</Trigger>
<Trigger name="amrules">

</Trigger>
<Trigger name="AVG_Accounts">

</Trigger>
<Trigger name="AVG_AccountsGroups">

</Trigger>
<Trigger name="krnlall">

</Trigger>
<Trigger name="malrep">

</Trigger>
<Trigger name="oop">

</Trigger>
<Trigger name="srmall">

</Trigger>
<Trigger name="updateall">

</Trigger>
<Trigger name="changecfgreg">

</Trigger>
<Trigger name="userall">

</Trigger>
<Trigger name="AVG_FileStorage">

</Trigger>
<Trigger name="AVG_QuarItems">

</Trigger>
<Trigger name="AVG_QuarComponents">

</Trigger>
<Trigger name="idp">

</Trigger>
<Trigger name="mailsrv">

</Trigger>
<Trigger name="mailsrvvsapi">

</Trigger>
<Trigger name="spsrv">

</Trigger>
<Trigger name="idpallow">

</Trigger>
<Trigger name="usergui">

</Trigger>
<Trigger name="erd">

</Trigger>
<Trigger name="AVG_UserRegistry">

</Trigger>
<Trigger name="cachesrv">

</Trigger>
<Trigger name="AVG_EventHistory">

</Trigger>
<Trigger name="AVG_Installer">

</Trigger>
<Trigger name="AVG_InstallStations">

</Trigger>
<Trigger name="rsexcludes">

</Trigger>
<Trigger name="csl">

</Trigger>
<Trigger name="emssrv9">

</Trigger>
<StoredProcedure name="AVG_ADMRepType">

</StoredProcedure>
<StoredProcedure name="AVG_ADMRepTplFiles">

</StoredProcedure>
<StoredProcedure name="AVG_ADMRepTypeConf">

</StoredProcedure>
<StoredProcedure name="AVG_ADMRepShedule">

</StoredProcedure>
<StoredProcedure name="AVG_ADMRepSheduleConf">

</StoredProcedure>
<StoredProcedure name="AVG_ADMRepReport">

</StoredProcedure>
<StoredProcedure name="AVG_DefTables">

</StoredProcedure>
<StoredProcedure name="AVG_DefDatabase">

</StoredProcedure>
<StoredProcedure name="AVG_Messages">

</StoredProcedure>
<StoredProcedure name="AVG_Properties">

</StoredProcedure>
<StoredProcedure name="AVG_ScanResults">

<SQLBlock>
CREATE PROCEDURE AVG_ScanResultsCMP (
	AVG_ParentCode INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_Index
	FROM "AVG_ScanResults"
	WHERE (AVG_ParentCode = :AVG_ParentCode)
	INTO
	:AVG_Code, :AVG_CompareMark, :ID
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="AVG_ScanLogs">

<SQLBlock>
CREATE PROCEDURE AVG_ScanLogsCMP (
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_LogID
	FROM "AVG_ScanLogs"
	WHERE ((AVG_OwnerType = :AVG_OwnerType) AND (AVG_OwnerID = :AVG_OwnerID))
	INTO
	:AVG_Code, :AVG_CompareMark, :ID
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="AVG_Stations">

</StoredProcedure>
<StoredProcedure name="AVG_Groups">

</StoredProcedure>
<StoredProcedure name="AVG_DefMaintenance">

</StoredProcedure>
<StoredProcedure name="AVG_DefViews">

</StoredProcedure>
<StoredProcedure name="AVG_DefViewColumns">

</StoredProcedure>
<StoredProcedure name="AVG_DefViewFilters">

</StoredProcedure>
<StoredProcedure name="AVG_DefViewsConditions">

</StoredProcedure>
<StoredProcedure name="AVG_EMTerm">

</StoredProcedure>
<StoredProcedure name="AVG_EMTermCfg">

</StoredProcedure>
<StoredProcedure name="AVG_EMTermCfgEnum">

</StoredProcedure>
<StoredProcedure name="AVG_EMTermColumns">

</StoredProcedure>
<StoredProcedure name="AVG_EMNotifyTrigger">

</StoredProcedure>
<StoredProcedure name="AVG_EMNotifyTriggerCfg">

</StoredProcedure>
<StoredProcedure name="aspam">

<SQLBlock>
CREATE PROCEDURE aspamCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "aspam"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="aspmlist">

<SQLBlock>
CREATE PROCEDURE aspmlistCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "aspmlist"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="emssrv">

<SQLBlock>
CREATE PROCEDURE emssrvCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID VARCHAR(32),
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, emssrv__name, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "emssrv"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="krnl">

<SQLBlock>
CREATE PROCEDURE krnlCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "krnl"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="mail">

<SQLBlock>
CREATE PROCEDURE mailCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "mail"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="scan">

<SQLBlock>
CREATE PROCEDURE scanCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID VARCHAR(128),
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, scan__Info__Name, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "scan"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="sched">

<SQLBlock>
CREATE PROCEDURE schedCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID VARCHAR(128),
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, sched__Task__Name, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "sched"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="update">

<SQLBlock>
CREATE PROCEDURE updateCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "update"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="AVG_ADMReportTexts">

</StoredProcedure>
<StoredProcedure name="AVG_StationsStates">

</StoredProcedure>
<StoredProcedure name="except">

<SQLBlock>
CREATE PROCEDURE exceptCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID VARCHAR(1024),
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20),
	ID2 VARCHAR(32) CHARACTER SET NONE )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, except__file_name, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp, except__checksum
	FROM "except"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp, :ID2
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="fw">

<SQLBlock>
CREATE PROCEDURE fwCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "fw"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="setup">

<SQLBlock>
CREATE PROCEDURE setupCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "setup"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="updatecomps">

<SQLBlock>
CREATE PROCEDURE updatecompsCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "updatecomps"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="AVG_Servers">

</StoredProcedure>
<StoredProcedure name="AVG_Versions">

</StoredProcedure>
<StoredProcedure name="hlog">

<SQLBlock>
CREATE PROCEDURE hlogCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID VARCHAR(32),
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, hlog__filename, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "hlog"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="user">

<SQLBlock>
CREATE PROCEDURE userCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "user"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="ameh">

<SQLBlock>
CREATE PROCEDURE amehCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "ameh"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="AVG_VirusVault">

</StoredProcedure>
<StoredProcedure name="admin">

<SQLBlock>
CREATE PROCEDURE adminCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "admin"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="AVG_AMEvents">

</StoredProcedure>
<StoredProcedure name="amrules">

<SQLBlock>
CREATE PROCEDURE amrulesCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID VARCHAR(128),
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, amrules__name, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "amrules"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="AVG_Accounts">

</StoredProcedure>
<StoredProcedure name="AVG_AccountsGroups">

</StoredProcedure>
<StoredProcedure name="krnlall">

<SQLBlock>
CREATE PROCEDURE krnlallCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "krnlall"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="malrep">

<SQLBlock>
CREATE PROCEDURE malrepCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "malrep"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="oop">

<SQLBlock>
CREATE PROCEDURE oopCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "oop"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="srmall">

<SQLBlock>
CREATE PROCEDURE srmallCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "srmall"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="updateall">

<SQLBlock>
CREATE PROCEDURE updateallCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "updateall"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="changecfgreg">

<SQLBlock>
CREATE PROCEDURE changecfgregCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "changecfgreg"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="userall">

<SQLBlock>
CREATE PROCEDURE userallCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "userall"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="AVG_FileStorage">

</StoredProcedure>
<StoredProcedure name="AVG_QuarItems">

</StoredProcedure>
<StoredProcedure name="AVG_QuarComponents">

</StoredProcedure>
<StoredProcedure name="idp">

<SQLBlock>
CREATE PROCEDURE idpCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "idp"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="mailsrv">

<SQLBlock>
CREATE PROCEDURE mailsrvCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "mailsrv"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="mailsrvvsapi">

<SQLBlock>
CREATE PROCEDURE mailsrvvsapiCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "mailsrvvsapi"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="spsrv">

<SQLBlock>
CREATE PROCEDURE spsrvCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "spsrv"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="idpallow">

<SQLBlock>
CREATE PROCEDURE idpallowCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID VARCHAR(1024),
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20),
	ID2 VARCHAR(32) CHARACTER SET NONE )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, idpallow__file_name, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp, idpallow__checksum
	FROM "idpallow"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp, :ID2
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="usergui">

<SQLBlock>
CREATE PROCEDURE userguiCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "usergui"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="erd">

<SQLBlock>
CREATE PROCEDURE erdCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "erd"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="AVG_UserRegistry">

</StoredProcedure>
<StoredProcedure name="cachesrv">

<SQLBlock>
CREATE PROCEDURE cachesrvCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "cachesrv"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="AVG_EventHistory">

</StoredProcedure>
<StoredProcedure name="AVG_Installer">

</StoredProcedure>
<StoredProcedure name="AVG_InstallStations">

</StoredProcedure>
<StoredProcedure name="rsexcludes">

<SQLBlock>
CREATE PROCEDURE rsexcludesCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID VARCHAR(2048),
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, rsexcludes__name, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "rsexcludes"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="csl">

<SQLBlock>
CREATE PROCEDURE cslCMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID INTEGER,
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, AVG_FactoryId, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "csl"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>
<StoredProcedure name="emssrv9">

<SQLBlock>
CREATE PROCEDURE emssrv9CMP (
	AVG_OwnerID1 INTEGER,
	AVG_OwnerType1 INTEGER,
	AVG_OwnerID2 INTEGER,
	AVG_OwnerType2 INTEGER,
	AVG_OwnerID3 INTEGER,
	AVG_OwnerType3 INTEGER
	) RETURNS (
	AVG_Code INTEGER,
	AVG_CompareMark VARCHAR(20),
	ID VARCHAR(32),
	AVG_AdminCode INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_TimeStamp VARCHAR(20) )
AS
BEGIN
	FOR SELECT
	AVG_Code, AVG_CompareMark, emssrv__name, AVG_AdminCode, AVG_OwnerID, AVG_OwnerType, AVG_TimeStamp
	FROM "emssrv9"
	WHERE ( ((AVG_OwnerType = :AVG_OwnerType1) AND (AVG_OwnerID = :AVG_OwnerID1)) OR ((AVG_OwnerType = :AVG_OwnerType2) AND (AVG_OwnerID = :AVG_OwnerID2)) OR ((AVG_OwnerType = :AVG_OwnerType3) AND (AVG_OwnerID = :AVG_OwnerID3)) )
	INTO
	:AVG_Code, :AVG_CompareMark, :ID, :AVG_AdminCode, :AVG_OwnerID, :AVG_OwnerType, :AVG_TimeStamp
	DO SUSPEND;
END;
</SQLBlock>

</StoredProcedure>

<CommonDatabaseData>

<DatabaseViews>

CREATE VIEW "view_avgadmin"(
 AVG_Property,
 AVG_Value,
 AVG_Code
) AS SELECT
 "AVG_Properties".AVG_Property,
 "AVG_Properties".AVG_Value,
 "AVG_Properties".AVG_Code
 FROM "AVG_Properties"
 WHERE AVG_Property <> 'AdminConsoleLock';

<SQLBlock>
CREATE PROCEDURE view_avgadmin_PROC
	RETURNS (
	AVG_Property VARCHAR(255),
	AVG_Value VARCHAR(8192),
	AVG_Code INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_Property,
	AVG_Value,
	AVG_Code
	FROM "view_avgadmin"
	INTO
	:AVG_Property,
	:AVG_Value,
	:AVG_Code
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_avgadmin_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_avgadmin"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_win_stations"(
 VImg_Online,
 VImg_Infected,
 VImg_Restart,
 AVG_Code,
 AVG_StationName,
 AVG_StationDomain,
 AVG_StationDesc,
 AVG_GroupID,
 AVG_GroupName,
 AVG_LastCall,
 AVG_UnhealedInfections,
 AVG_UnhealedPups,
 AVG_UnhealedRootkits,
 AVG_TotalInfections,
 AVG_TotalPups,
 AVG_TotalRootkits,
 AVG_BuildType,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_WinVersion,
 AVG_LastSynchro,
 LastScanTime,
 NeedRestart,
 AVG_ExpirationDate,
 AVG_AvgVersion,
 Core_Version,
 Antivirus_Version,
 Antivirus_ReleaseDate,
 AntiSpam_Version,
 AntiSpam_LastRuleUpdate,
 AntiVirusGroup_StateText,
 EmailProtectionGroup_StateText,
 LinkScannerGroup_StateText,
 AM_StateText,
 AdminClient_StateText,
 AR_StateText,
 FW_StateText,
 FW_State,
 FW_ConfigVersion,
 License_StateText,
 IDP_StateText,
 UpdateMgr_StateText,
 Analysis_StateText,
 AR_State,
 AVG_Logon,
 AVG_Logoff,
 AVG_LicenceNumber,
 AM_StateTextObs,
 AntiSpam_StateTextObs,
 AntiSpy_StateTextObs,
 Antivirus_StateTextObs,
 AdminClient_StateTextObs,
 AR_StateTextObs,
 EMS_StateTextObs,
 EMS_ExchangePluginObs,
 EMS_BATPluginObs,
 EMS_ThunderbirdPluginObs,
 FW_StateTextObs,
 License_StateTextObs,
 LinkScanner_StateTextObs,
 NetworkScanner_StateTextObs,
 RS_StateTextObs,
 IDP_StateTextObs,
 UpdateMgr_StateTextObs,
 Analysis_StateTextObs,
 UserNames
) AS SELECT
 0,
 0,
 0,
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Stations".AVG_StationDesc,
 "AVG_Stations".AVG_GroupID,
 "AVG_Groups".AVG_GroupName,
 "AVG_Stations".AVG_LastCall,
 SUM("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits - "AVG_ScanLogs".AVG_HealedRootkits),
 SUM("AVG_ScanLogs".AVG_FoundInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits),
 "AVG_Stations".AVG_BuildType,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_WinVersion,
 "AVG_Stations".AVG_LastSynchro,
 "AVG_StationsStates".LastScanTime,
 "AVG_StationsStates".NeedRestart,
 "AVG_Stations".AVG_ExpirationDate,
 "AVG_StationsStates".AVG_AvgVersion,
 "AVG_StationsStates".Core_Version,
 "AVG_StationsStates".Antivirus_Version,
 "AVG_StationsStates".Antivirus_ReleaseDate,
 "AVG_StationsStates".AntiSpam_Version,
 "AVG_StationsStates".AntiSpam_LastRuleUpdate,
 "AVG_StationsStates".AntiVirusGroup_StateText,
 "AVG_StationsStates".EmailProtectionGroup_StateText,
 "AVG_StationsStates".LinkScannerGroup_StateText,
 "AVG_StationsStates".AM_StateText,
 "AVG_StationsStates".AdminClient_StateText,
 "AVG_StationsStates".AR_StateText,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".FW_State,
 "AVG_StationsStates".FW_ConfigVersion,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".IDP_StateText,
 "AVG_StationsStates".UpdateMgr_StateText,
 "AVG_StationsStates".Analysis_StateText,
 "AVG_StationsStates".AR_State,
 "AVG_Stations".AVG_Logon,
 "AVG_Stations".AVG_Logoff,
 "AVG_Stations".AVG_LicenceNumber,
 "AVG_StationsStates".AM_StateText,
 "AVG_StationsStates".AntiSpam_StateText,
 "AVG_StationsStates".AntiSpy_StateText,
 "AVG_StationsStates".Antivirus_StateText,
 "AVG_StationsStates".AdminClient_StateText,
 "AVG_StationsStates".AR_StateText,
 "AVG_StationsStates".EMS_StateText,
 "AVG_StationsStates".EMS_ExchangePlugin,
 "AVG_StationsStates".EMS_BATPlugin,
 "AVG_StationsStates".EMS_ThunderbirdPlugin,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".LinkScanner_StateText,
 "AVG_StationsStates".NetworkScanner_StateText,
 "AVG_StationsStates".RS_StateText,
 "AVG_StationsStates".IDP_StateText,
 "AVG_StationsStates".UpdateMgr_StateText,
 "AVG_StationsStates".Analysis_StateText,
 "AVG_StationsStates".UserNames
 FROM "AVG_Stations" LEFT JOIN "AVG_Groups" ON ("AVG_Stations".AVG_GroupID="AVG_Groups".AVG_Code) LEFT JOIN "AVG_StationsStates" ON ("AVG_Stations".AVG_Code="AVG_StationsStates".AVG_StationID) LEFT JOIN "AVG_ScanLogs" ON ("AVG_Stations".AVG_Code="AVG_ScanLogs".AVG_OwnerID AND ( "AVG_ScanLogs".AVG_ConfirmTime IS NULL OR "AVG_ScanLogs".AVG_ConfirmTime = '' ))
 WHERE ( "AVG_Stations".AVG_StationType = 0 AND ("AVG_ScanLogs".AVG_OwnerType IS NULL OR "AVG_ScanLogs".AVG_OwnerType = 0) )
 GROUP BY "AVG_Stations".AVG_Code,"AVG_Stations".AVG_StationName,"AVG_Stations".AVG_StationDomain,"AVG_Stations".AVG_StationDesc,"AVG_Stations".AVG_GroupID,"AVG_Groups".AVG_GroupName,"AVG_Stations".AVG_LastCall,"AVG_Stations".AVG_BuildType,"AVG_Stations".AVG_IPAddress,"AVG_Stations".AVG_MACAddress,"AVG_Stations".AVG_WinVersion,"AVG_Stations".AVG_LastSynchro,"AVG_StationsStates".LastScanTime,"AVG_StationsStates".NeedRestart,"AVG_Stations".AVG_ExpirationDate,"AVG_StationsStates".AVG_AvgVersion,"AVG_StationsStates".Core_Version,"AVG_StationsStates".Antivirus_Version,"AVG_StationsStates".Antivirus_ReleaseDate,"AVG_StationsStates".AntiSpam_Version,"AVG_StationsStates".AntiSpam_LastRuleUpdate,"AVG_StationsStates".AntiVirusGroup_StateText,"AVG_StationsStates".EmailProtectionGroup_StateText,"AVG_StationsStates".LinkScannerGroup_StateText,"AVG_StationsStates".AM_StateText,"AVG_StationsStates".AdminClient_StateText,"AVG_StationsStates".AR_StateText,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".FW_State,"AVG_StationsStates".FW_ConfigVersion,"AVG_StationsStates".License_StateText,"AVG_StationsStates".IDP_StateText,"AVG_StationsStates".UpdateMgr_StateText,"AVG_StationsStates".Analysis_StateText,"AVG_StationsStates".AR_State,"AVG_Stations".AVG_Logon,"AVG_Stations".AVG_Logoff,"AVG_Stations".AVG_LicenceNumber,"AVG_StationsStates".AM_StateText,"AVG_StationsStates".AntiSpam_StateText,"AVG_StationsStates".AntiSpy_StateText,"AVG_StationsStates".Antivirus_StateText,"AVG_StationsStates".AdminClient_StateText,"AVG_StationsStates".AR_StateText,"AVG_StationsStates".EMS_StateText,"AVG_StationsStates".EMS_ExchangePlugin,"AVG_StationsStates".EMS_BATPlugin,"AVG_StationsStates".EMS_ThunderbirdPlugin,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".License_StateText,"AVG_StationsStates".LinkScanner_StateText,"AVG_StationsStates".NetworkScanner_StateText,"AVG_StationsStates".RS_StateText,"AVG_StationsStates".IDP_StateText,"AVG_StationsStates".UpdateMgr_StateText,"AVG_StationsStates".Analysis_StateText,"AVG_StationsStates".UserNames;

<SQLBlock>
CREATE PROCEDURE view_win_stations_PROC ( 
	bflt1 INTEGER,
	bflt_desc INTEGER,
	bflt_dmn INTEGER,
	bflt_ip INTEGER,
	bflt_os INTEGER,
	bflt_infected INTEGER,
	bflt_stool INTEGER,
	bflt_rst INTEGER,
	bhid_avgver INTEGER,
	bhid_corever INTEGER,
	bhid_nocomm INTEGER,
	flt1_AVG_STATIONNAME VARCHAR(64),
	flt1_AVG_STATIONNAME_L VARCHAR(512),
	flt_desc_AVG_STATIONDESC VARCHAR(64),
	flt_desc_AVG_STATIONDESC_L VARCHAR(512),
	flt_dmn_AVG_STATION_DOMAIN VARCHAR(64),
	flt_dmn_AVG_STATION_DOMAIN_L VARCHAR(512),
	flt_ip_AVG_STATION_IP VARCHAR(64),
	flt_ip_AVG_STATION_IP_L VARCHAR(512),
	flt_os_AVG_STATION_OS VARCHAR(64),
	flt_os_AVG_STATION_OS_L VARCHAR(512),
	hid_avgver_AVG_VER VARCHAR(64),
	hid_avgver_AVG_VER_L VARCHAR(512),
	hid_corever_CORE_VER VARCHAR(64),
	hid_corever_CORE_VER_L VARCHAR(512),
	hid_nocomm_LAST_CALL VARCHAR(64),
	hid_nocomm_LAST_CALL_L VARCHAR(512) )
	RETURNS (
	VImg_Online INTEGER,
	VImg_Infected INTEGER,
	VImg_Restart INTEGER,
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_StationDomain VARCHAR(64),
	AVG_StationDesc VARCHAR(250),
	AVG_GroupID INTEGER,
	AVG_GroupName VARCHAR(64),
	AVG_LastCall VARCHAR(20),
	AVG_UnhealedInfections INTEGER,
	AVG_UnhealedPups INTEGER,
	AVG_UnhealedRootkits INTEGER,
	AVG_TotalInfections INTEGER,
	AVG_TotalPups INTEGER,
	AVG_TotalRootkits INTEGER,
	AVG_BuildType INTEGER,
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_WinVersion VARCHAR(255),
	AVG_LastSynchro VARCHAR(20),
	LastScanTime VARCHAR(20),
	NeedRestart INTEGER,
	AVG_ExpirationDate VARCHAR(20),
	AVG_AvgVersion VARCHAR(50),
	Core_Version VARCHAR(50),
	Antivirus_Version VARCHAR(50),
	Antivirus_ReleaseDate VARCHAR(20),
	AntiSpam_Version VARCHAR(50),
	AntiSpam_LastRuleUpdate VARCHAR(20),
	AntiVirusGroup_StateText VARCHAR(128),
	EmailProtectionGroup_StateText VARCHAR(128),
	LinkScannerGroup_StateText VARCHAR(128),
	AM_StateText VARCHAR(128),
	AdminClient_StateText VARCHAR(128),
	AR_StateText VARCHAR(128),
	FW_StateText VARCHAR(128),
	FW_State INTEGER,
	FW_ConfigVersion INTEGER,
	License_StateText VARCHAR(128),
	IDP_StateText VARCHAR(128),
	UpdateMgr_StateText VARCHAR(128),
	Analysis_StateText VARCHAR(128),
	AR_State INTEGER,
	AVG_Logon VARCHAR(20),
	AVG_Logoff VARCHAR(20),
	AVG_LicenceNumber VARCHAR(64),
	AM_StateTextObs VARCHAR(128),
	AntiSpam_StateTextObs VARCHAR(128),
	AntiSpy_StateTextObs VARCHAR(128),
	Antivirus_StateTextObs VARCHAR(128),
	AdminClient_StateTextObs VARCHAR(128),
	AR_StateTextObs VARCHAR(128),
	EMS_StateTextObs VARCHAR(128),
	EMS_ExchangePluginObs VARCHAR(40),
	EMS_BATPluginObs VARCHAR(40),
	EMS_ThunderbirdPluginObs VARCHAR(40),
	FW_StateTextObs VARCHAR(128),
	License_StateTextObs VARCHAR(128),
	LinkScanner_StateTextObs VARCHAR(128),
	NetworkScanner_StateTextObs VARCHAR(128),
	RS_StateTextObs VARCHAR(128),
	IDP_StateTextObs VARCHAR(128),
	UpdateMgr_StateTextObs VARCHAR(128),
	Analysis_StateTextObs VARCHAR(128),
	UserNames VARCHAR(255))
AS BEGIN
	FOR SELECT 
	VImg_Online,
	VImg_Infected,
	VImg_Restart,
	AVG_Code,
	AVG_StationName,
	AVG_StationDomain,
	AVG_StationDesc,
	AVG_GroupID,
	AVG_GroupName,
	AVG_LastCall,
	AVG_UnhealedInfections,
	AVG_UnhealedPups,
	AVG_UnhealedRootkits,
	AVG_TotalInfections,
	AVG_TotalPups,
	AVG_TotalRootkits,
	AVG_BuildType,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_WinVersion,
	AVG_LastSynchro,
	LastScanTime,
	NeedRestart,
	AVG_ExpirationDate,
	AVG_AvgVersion,
	Core_Version,
	Antivirus_Version,
	Antivirus_ReleaseDate,
	AntiSpam_Version,
	AntiSpam_LastRuleUpdate,
	AntiVirusGroup_StateText,
	EmailProtectionGroup_StateText,
	LinkScannerGroup_StateText,
	AM_StateText,
	AdminClient_StateText,
	AR_StateText,
	FW_StateText,
	FW_State,
	FW_ConfigVersion,
	License_StateText,
	IDP_StateText,
	UpdateMgr_StateText,
	Analysis_StateText,
	AR_State,
	AVG_Logon,
	AVG_Logoff,
	AVG_LicenceNumber,
	AM_StateTextObs,
	AntiSpam_StateTextObs,
	AntiSpy_StateTextObs,
	Antivirus_StateTextObs,
	AdminClient_StateTextObs,
	AR_StateTextObs,
	EMS_StateTextObs,
	EMS_ExchangePluginObs,
	EMS_BATPluginObs,
	EMS_ThunderbirdPluginObs,
	FW_StateTextObs,
	License_StateTextObs,
	LinkScanner_StateTextObs,
	NetworkScanner_StateTextObs,
	RS_StateTextObs,
	IDP_StateTextObs,
	UpdateMgr_StateTextObs,
	Analysis_StateTextObs,
	UserNames
	FROM "view_win_stations"
	WHERE
	((:bflt1=0)OR((:bflt1=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt1_AVG_STATIONNAME)))) AND
	((:bflt_desc=0)OR((:bflt_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_desc_AVG_STATIONDESC)))) AND
	((:bflt_dmn=0)OR((:bflt_dmn=1)AND(UPPER(AVG_StationDomain) LIKE UPPER(:flt_dmn_AVG_STATION_DOMAIN)))) AND
	((:bflt_infected=0)OR((:bflt_infected=1)AND((AVG_UnhealedInfections > 0) OR (AVG_UnhealedPups > 0) OR (AVG_UnhealedRootkits > 0)))) AND
	((:bflt_ip=0)OR((:bflt_ip=1)AND(UPPER(AVG_IPAddress) LIKE UPPER(:flt_ip_AVG_STATION_IP)))) AND
	((:bflt_os=0)OR((:bflt_os=1)AND(UPPER(AVG_WinVersion) LIKE UPPER(:flt_os_AVG_STATION_OS)))) AND
	((:bflt_rst=0)OR((:bflt_rst=1)AND(NeedRestart = '1'))) AND
	((:bflt_stool=0)OR((:bflt_stool=1)AND(AVG_LastCall = ''))) AND
	((:bhid_avgver=0)OR((:bhid_avgver=1)AND(AVG_AvgVersion < :hid_avgver_AVG_VER))) AND
	((:bhid_corever=0)OR((:bhid_corever=1)AND(Core_Version < :hid_corever_CORE_VER))) AND
	((:bhid_nocomm=0)OR((:bhid_nocomm=1)AND(AVG_LastCall < :hid_nocomm_LAST_CALL)))
	INTO
	:VImg_Online,
	:VImg_Infected,
	:VImg_Restart,
	:AVG_Code,
	:AVG_StationName,
	:AVG_StationDomain,
	:AVG_StationDesc,
	:AVG_GroupID,
	:AVG_GroupName,
	:AVG_LastCall,
	:AVG_UnhealedInfections,
	:AVG_UnhealedPups,
	:AVG_UnhealedRootkits,
	:AVG_TotalInfections,
	:AVG_TotalPups,
	:AVG_TotalRootkits,
	:AVG_BuildType,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_WinVersion,
	:AVG_LastSynchro,
	:LastScanTime,
	:NeedRestart,
	:AVG_ExpirationDate,
	:AVG_AvgVersion,
	:Core_Version,
	:Antivirus_Version,
	:Antivirus_ReleaseDate,
	:AntiSpam_Version,
	:AntiSpam_LastRuleUpdate,
	:AntiVirusGroup_StateText,
	:EmailProtectionGroup_StateText,
	:LinkScannerGroup_StateText,
	:AM_StateText,
	:AdminClient_StateText,
	:AR_StateText,
	:FW_StateText,
	:FW_State,
	:FW_ConfigVersion,
	:License_StateText,
	:IDP_StateText,
	:UpdateMgr_StateText,
	:Analysis_StateText,
	:AR_State,
	:AVG_Logon,
	:AVG_Logoff,
	:AVG_LicenceNumber,
	:AM_StateTextObs,
	:AntiSpam_StateTextObs,
	:AntiSpy_StateTextObs,
	:Antivirus_StateTextObs,
	:AdminClient_StateTextObs,
	:AR_StateTextObs,
	:EMS_StateTextObs,
	:EMS_ExchangePluginObs,
	:EMS_BATPluginObs,
	:EMS_ThunderbirdPluginObs,
	:FW_StateTextObs,
	:License_StateTextObs,
	:LinkScanner_StateTextObs,
	:NetworkScanner_StateTextObs,
	:RS_StateTextObs,
	:IDP_StateTextObs,
	:UpdateMgr_StateTextObs,
	:Analysis_StateTextObs,
	:UserNames
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_win_stations_C_PROC ( 
	bflt1 INTEGER,
	bflt_desc INTEGER,
	bflt_dmn INTEGER,
	bflt_ip INTEGER,
	bflt_os INTEGER,
	bflt_infected INTEGER,
	bflt_stool INTEGER,
	bflt_rst INTEGER,
	bhid_avgver INTEGER,
	bhid_corever INTEGER,
	bhid_nocomm INTEGER,
	flt1_AVG_STATIONNAME VARCHAR(64),
	flt1_AVG_STATIONNAME_L VARCHAR(512),
	flt_desc_AVG_STATIONDESC VARCHAR(64),
	flt_desc_AVG_STATIONDESC_L VARCHAR(512),
	flt_dmn_AVG_STATION_DOMAIN VARCHAR(64),
	flt_dmn_AVG_STATION_DOMAIN_L VARCHAR(512),
	flt_ip_AVG_STATION_IP VARCHAR(64),
	flt_ip_AVG_STATION_IP_L VARCHAR(512),
	flt_os_AVG_STATION_OS VARCHAR(64),
	flt_os_AVG_STATION_OS_L VARCHAR(512),
	hid_avgver_AVG_VER VARCHAR(64),
	hid_avgver_AVG_VER_L VARCHAR(512),
	hid_corever_CORE_VER VARCHAR(64),
	hid_corever_CORE_VER_L VARCHAR(512),
	hid_nocomm_LAST_CALL VARCHAR(64),
	hid_nocomm_LAST_CALL_L VARCHAR(512) )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_win_stations"
	WHERE
	((:bflt1=0)OR((:bflt1=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt1_AVG_STATIONNAME)))) AND
	((:bflt_desc=0)OR((:bflt_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_desc_AVG_STATIONDESC)))) AND
	((:bflt_dmn=0)OR((:bflt_dmn=1)AND(UPPER(AVG_StationDomain) LIKE UPPER(:flt_dmn_AVG_STATION_DOMAIN)))) AND
	((:bflt_infected=0)OR((:bflt_infected=1)AND((AVG_UnhealedInfections > 0) OR (AVG_UnhealedPups > 0) OR (AVG_UnhealedRootkits > 0)))) AND
	((:bflt_ip=0)OR((:bflt_ip=1)AND(UPPER(AVG_IPAddress) LIKE UPPER(:flt_ip_AVG_STATION_IP)))) AND
	((:bflt_os=0)OR((:bflt_os=1)AND(UPPER(AVG_WinVersion) LIKE UPPER(:flt_os_AVG_STATION_OS)))) AND
	((:bflt_rst=0)OR((:bflt_rst=1)AND(NeedRestart = '1'))) AND
	((:bflt_stool=0)OR((:bflt_stool=1)AND(AVG_LastCall = ''))) AND
	((:bhid_avgver=0)OR((:bhid_avgver=1)AND(AVG_AvgVersion < :hid_avgver_AVG_VER))) AND
	((:bhid_corever=0)OR((:bhid_corever=1)AND(Core_Version < :hid_corever_CORE_VER))) AND
	((:bhid_nocomm=0)OR((:bhid_nocomm=1)AND(AVG_LastCall < :hid_nocomm_LAST_CALL)))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_non_compliant"(
 VImg_Online,
 VImg_Infected,
 VImg_Restart,
 AVG_Code,
 AVG_StationName,
 AVG_StationDomain,
 AVG_StationDesc,
 AVG_GroupID,
 AVG_GroupName,
 AVG_LastCall,
 AVG_UnhealedInfections,
 AVG_UnhealedPups,
 AVG_UnhealedRootkits,
 AVG_TotalInfections,
 AVG_TotalPups,
 AVG_TotalRootkits,
 AVG_BuildType,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_WinVersion,
 AVG_LastSynchro,
 LastScanTime,
 NeedRestart,
 AVG_ExpirationDate,
 AVG_AvgVersion,
 Core_Version,
 Antivirus_Version,
 Antivirus_ReleaseDate,
 AntiSpam_Version,
 AntiSpam_LastRuleUpdate,
 AntiVirusGroup_StateText,
 EmailProtectionGroup_StateText,
 LinkScannerGroup_StateText,
 AM_StateText,
 AdminClient_StateText,
 AR_StateText,
 FW_StateText,
 FW_State,
 FW_ConfigVersion,
 License_StateText,
 IDP_StateText,
 UpdateMgr_StateText,
 Analysis_StateText,
 AR_State,
 AVG_Logon,
 AVG_Logoff,
 AVG_LicenceNumber,
 AM_StateTextObs,
 AntiSpam_StateTextObs,
 AntiSpy_StateTextObs,
 Antivirus_StateTextObs,
 AdminClient_StateTextObs,
 AR_StateTextObs,
 EMS_StateTextObs,
 EMS_ExchangePluginObs,
 EMS_BATPluginObs,
 EMS_ThunderbirdPluginObs,
 FW_StateTextObs,
 License_StateTextObs,
 LinkScanner_StateTextObs,
 NetworkScanner_StateTextObs,
 RS_StateTextObs,
 IDP_StateTextObs,
 UpdateMgr_StateTextObs,
 Analysis_StateTextObs,
 UserNames
) AS SELECT
 0,
 0,
 0,
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Stations".AVG_StationDesc,
 "AVG_Stations".AVG_GroupID,
 "AVG_Groups".AVG_GroupName,
 "AVG_Stations".AVG_LastCall,
 SUM("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits - "AVG_ScanLogs".AVG_HealedRootkits),
 SUM("AVG_ScanLogs".AVG_FoundInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits),
 "AVG_Stations".AVG_BuildType,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_WinVersion,
 "AVG_Stations".AVG_LastSynchro,
 "AVG_StationsStates".LastScanTime,
 "AVG_StationsStates".NeedRestart,
 "AVG_Stations".AVG_ExpirationDate,
 "AVG_StationsStates".AVG_AvgVersion,
 "AVG_StationsStates".Core_Version,
 "AVG_StationsStates".Antivirus_Version,
 "AVG_StationsStates".Antivirus_ReleaseDate,
 "AVG_StationsStates".AntiSpam_Version,
 "AVG_StationsStates".AntiSpam_LastRuleUpdate,
 "AVG_StationsStates".AntiVirusGroup_StateText,
 "AVG_StationsStates".EmailProtectionGroup_StateText,
 "AVG_StationsStates".LinkScannerGroup_StateText,
 "AVG_StationsStates".AM_StateText,
 "AVG_StationsStates".AdminClient_StateText,
 "AVG_StationsStates".AR_StateText,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".FW_State,
 "AVG_StationsStates".FW_ConfigVersion,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".IDP_StateText,
 "AVG_StationsStates".UpdateMgr_StateText,
 "AVG_StationsStates".Analysis_StateText,
 "AVG_StationsStates".AR_State,
 "AVG_Stations".AVG_Logon,
 "AVG_Stations".AVG_Logoff,
 "AVG_Stations".AVG_LicenceNumber,
 "AVG_StationsStates".AM_StateText,
 "AVG_StationsStates".AntiSpam_StateText,
 "AVG_StationsStates".AntiSpy_StateText,
 "AVG_StationsStates".Antivirus_StateText,
 "AVG_StationsStates".AdminClient_StateText,
 "AVG_StationsStates".AR_StateText,
 "AVG_StationsStates".EMS_StateText,
 "AVG_StationsStates".EMS_ExchangePlugin,
 "AVG_StationsStates".EMS_BATPlugin,
 "AVG_StationsStates".EMS_ThunderbirdPlugin,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".LinkScanner_StateText,
 "AVG_StationsStates".NetworkScanner_StateText,
 "AVG_StationsStates".RS_StateText,
 "AVG_StationsStates".IDP_StateText,
 "AVG_StationsStates".UpdateMgr_StateText,
 "AVG_StationsStates".Analysis_StateText,
 "AVG_StationsStates".UserNames
 FROM "AVG_Stations" LEFT JOIN "AVG_Groups" ON ("AVG_Stations".AVG_GroupID="AVG_Groups".AVG_Code) LEFT JOIN "AVG_StationsStates" ON ("AVG_Stations".AVG_Code="AVG_StationsStates".AVG_StationID) LEFT JOIN "AVG_ScanLogs" ON ("AVG_Stations".AVG_Code="AVG_ScanLogs".AVG_OwnerID AND ( "AVG_ScanLogs".AVG_ConfirmTime IS NULL OR "AVG_ScanLogs".AVG_ConfirmTime = '' ))
 WHERE ( "AVG_Stations".AVG_StationType = 0 AND ("AVG_ScanLogs".AVG_OwnerType IS NULL OR "AVG_ScanLogs".AVG_OwnerType = 0) )
 GROUP BY "AVG_Stations".AVG_Code,"AVG_Stations".AVG_StationName,"AVG_Stations".AVG_StationDomain,"AVG_Stations".AVG_StationDesc,"AVG_Stations".AVG_GroupID,"AVG_Groups".AVG_GroupName,"AVG_Stations".AVG_LastCall,"AVG_Stations".AVG_BuildType,"AVG_Stations".AVG_IPAddress,"AVG_Stations".AVG_MACAddress,"AVG_Stations".AVG_WinVersion,"AVG_Stations".AVG_LastSynchro,"AVG_StationsStates".LastScanTime,"AVG_StationsStates".NeedRestart,"AVG_Stations".AVG_ExpirationDate,"AVG_StationsStates".AVG_AvgVersion,"AVG_StationsStates".Core_Version,"AVG_StationsStates".Antivirus_Version,"AVG_StationsStates".Antivirus_ReleaseDate,"AVG_StationsStates".AntiSpam_Version,"AVG_StationsStates".AntiSpam_LastRuleUpdate,"AVG_StationsStates".AntiVirusGroup_StateText,"AVG_StationsStates".EmailProtectionGroup_StateText,"AVG_StationsStates".LinkScannerGroup_StateText,"AVG_StationsStates".AM_StateText,"AVG_StationsStates".AdminClient_StateText,"AVG_StationsStates".AR_StateText,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".FW_State,"AVG_StationsStates".FW_ConfigVersion,"AVG_StationsStates".License_StateText,"AVG_StationsStates".IDP_StateText,"AVG_StationsStates".UpdateMgr_StateText,"AVG_StationsStates".Analysis_StateText,"AVG_StationsStates".AR_State,"AVG_Stations".AVG_Logon,"AVG_Stations".AVG_Logoff,"AVG_Stations".AVG_LicenceNumber,"AVG_StationsStates".AM_StateText,"AVG_StationsStates".AntiSpam_StateText,"AVG_StationsStates".AntiSpy_StateText,"AVG_StationsStates".Antivirus_StateText,"AVG_StationsStates".AdminClient_StateText,"AVG_StationsStates".AR_StateText,"AVG_StationsStates".EMS_StateText,"AVG_StationsStates".EMS_ExchangePlugin,"AVG_StationsStates".EMS_BATPlugin,"AVG_StationsStates".EMS_ThunderbirdPlugin,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".License_StateText,"AVG_StationsStates".LinkScanner_StateText,"AVG_StationsStates".NetworkScanner_StateText,"AVG_StationsStates".RS_StateText,"AVG_StationsStates".IDP_StateText,"AVG_StationsStates".UpdateMgr_StateText,"AVG_StationsStates".Analysis_StateText,"AVG_StationsStates".UserNames;

<SQLBlock>
CREATE PROCEDURE view_non_compliant_PROC ( 
	bflt1 INTEGER,
	bflt_desc INTEGER,
	bflt_dmn INTEGER,
	bflt_ip INTEGER,
	bflt_os INTEGER,
	bflt_infected INTEGER,
	bflt_stool INTEGER,
	bflt_rst INTEGER,
	flt1_AVG_STATIONNAME VARCHAR(64),
	flt1_AVG_STATIONNAME_L VARCHAR(512),
	flt_desc_AVG_STATIONDESC VARCHAR(64),
	flt_desc_AVG_STATIONDESC_L VARCHAR(512),
	flt_dmn_AVG_STATION_DOMAIN VARCHAR(64),
	flt_dmn_AVG_STATION_DOMAIN_L VARCHAR(512),
	flt_ip_AVG_STATION_IP VARCHAR(64),
	flt_ip_AVG_STATION_IP_L VARCHAR(512),
	flt_os_AVG_STATION_OS VARCHAR(64),
	flt_os_AVG_STATION_OS_L VARCHAR(512) )
	RETURNS (
	VImg_Online INTEGER,
	VImg_Infected INTEGER,
	VImg_Restart INTEGER,
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_StationDomain VARCHAR(64),
	AVG_StationDesc VARCHAR(250),
	AVG_GroupID INTEGER,
	AVG_GroupName VARCHAR(64),
	AVG_LastCall VARCHAR(20),
	AVG_UnhealedInfections INTEGER,
	AVG_UnhealedPups INTEGER,
	AVG_UnhealedRootkits INTEGER,
	AVG_TotalInfections INTEGER,
	AVG_TotalPups INTEGER,
	AVG_TotalRootkits INTEGER,
	AVG_BuildType INTEGER,
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_WinVersion VARCHAR(255),
	AVG_LastSynchro VARCHAR(20),
	LastScanTime VARCHAR(20),
	NeedRestart INTEGER,
	AVG_ExpirationDate VARCHAR(20),
	AVG_AvgVersion VARCHAR(50),
	Core_Version VARCHAR(50),
	Antivirus_Version VARCHAR(50),
	Antivirus_ReleaseDate VARCHAR(20),
	AntiSpam_Version VARCHAR(50),
	AntiSpam_LastRuleUpdate VARCHAR(20),
	AntiVirusGroup_StateText VARCHAR(128),
	EmailProtectionGroup_StateText VARCHAR(128),
	LinkScannerGroup_StateText VARCHAR(128),
	AM_StateText VARCHAR(128),
	AdminClient_StateText VARCHAR(128),
	AR_StateText VARCHAR(128),
	FW_StateText VARCHAR(128),
	FW_State INTEGER,
	FW_ConfigVersion INTEGER,
	License_StateText VARCHAR(128),
	IDP_StateText VARCHAR(128),
	UpdateMgr_StateText VARCHAR(128),
	Analysis_StateText VARCHAR(128),
	AR_State INTEGER,
	AVG_Logon VARCHAR(20),
	AVG_Logoff VARCHAR(20),
	AVG_LicenceNumber VARCHAR(64),
	AM_StateTextObs VARCHAR(128),
	AntiSpam_StateTextObs VARCHAR(128),
	AntiSpy_StateTextObs VARCHAR(128),
	Antivirus_StateTextObs VARCHAR(128),
	AdminClient_StateTextObs VARCHAR(128),
	AR_StateTextObs VARCHAR(128),
	EMS_StateTextObs VARCHAR(128),
	EMS_ExchangePluginObs VARCHAR(40),
	EMS_BATPluginObs VARCHAR(40),
	EMS_ThunderbirdPluginObs VARCHAR(40),
	FW_StateTextObs VARCHAR(128),
	License_StateTextObs VARCHAR(128),
	LinkScanner_StateTextObs VARCHAR(128),
	NetworkScanner_StateTextObs VARCHAR(128),
	RS_StateTextObs VARCHAR(128),
	IDP_StateTextObs VARCHAR(128),
	UpdateMgr_StateTextObs VARCHAR(128),
	Analysis_StateTextObs VARCHAR(128),
	UserNames VARCHAR(255))
AS BEGIN
	FOR SELECT 
	VImg_Online,
	VImg_Infected,
	VImg_Restart,
	AVG_Code,
	AVG_StationName,
	AVG_StationDomain,
	AVG_StationDesc,
	AVG_GroupID,
	AVG_GroupName,
	AVG_LastCall,
	AVG_UnhealedInfections,
	AVG_UnhealedPups,
	AVG_UnhealedRootkits,
	AVG_TotalInfections,
	AVG_TotalPups,
	AVG_TotalRootkits,
	AVG_BuildType,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_WinVersion,
	AVG_LastSynchro,
	LastScanTime,
	NeedRestart,
	AVG_ExpirationDate,
	AVG_AvgVersion,
	Core_Version,
	Antivirus_Version,
	Antivirus_ReleaseDate,
	AntiSpam_Version,
	AntiSpam_LastRuleUpdate,
	AntiVirusGroup_StateText,
	EmailProtectionGroup_StateText,
	LinkScannerGroup_StateText,
	AM_StateText,
	AdminClient_StateText,
	AR_StateText,
	FW_StateText,
	FW_State,
	FW_ConfigVersion,
	License_StateText,
	IDP_StateText,
	UpdateMgr_StateText,
	Analysis_StateText,
	AR_State,
	AVG_Logon,
	AVG_Logoff,
	AVG_LicenceNumber,
	AM_StateTextObs,
	AntiSpam_StateTextObs,
	AntiSpy_StateTextObs,
	Antivirus_StateTextObs,
	AdminClient_StateTextObs,
	AR_StateTextObs,
	EMS_StateTextObs,
	EMS_ExchangePluginObs,
	EMS_BATPluginObs,
	EMS_ThunderbirdPluginObs,
	FW_StateTextObs,
	License_StateTextObs,
	LinkScanner_StateTextObs,
	NetworkScanner_StateTextObs,
	RS_StateTextObs,
	IDP_StateTextObs,
	UpdateMgr_StateTextObs,
	Analysis_StateTextObs,
	UserNames
	FROM "view_non_compliant"
	WHERE
	((:bflt1=0)OR((:bflt1=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt1_AVG_STATIONNAME)))) AND
	((:bflt_desc=0)OR((:bflt_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_desc_AVG_STATIONDESC)))) AND
	((:bflt_dmn=0)OR((:bflt_dmn=1)AND(UPPER(AVG_StationDomain) LIKE UPPER(:flt_dmn_AVG_STATION_DOMAIN)))) AND
	((:bflt_infected=0)OR((:bflt_infected=1)AND((AVG_UnhealedInfections > 0) OR (AVG_UnhealedPups > 0) OR (AVG_UnhealedRootkits > 0)))) AND
	((:bflt_ip=0)OR((:bflt_ip=1)AND(UPPER(AVG_IPAddress) LIKE UPPER(:flt_ip_AVG_STATION_IP)))) AND
	((:bflt_os=0)OR((:bflt_os=1)AND(UPPER(AVG_WinVersion) LIKE UPPER(:flt_os_AVG_STATION_OS)))) AND
	((:bflt_rst=0)OR((:bflt_rst=1)AND(NeedRestart = '1'))) AND
	((:bflt_stool=0)OR((:bflt_stool=1)AND(AVG_LastCall = '')))
	INTO
	:VImg_Online,
	:VImg_Infected,
	:VImg_Restart,
	:AVG_Code,
	:AVG_StationName,
	:AVG_StationDomain,
	:AVG_StationDesc,
	:AVG_GroupID,
	:AVG_GroupName,
	:AVG_LastCall,
	:AVG_UnhealedInfections,
	:AVG_UnhealedPups,
	:AVG_UnhealedRootkits,
	:AVG_TotalInfections,
	:AVG_TotalPups,
	:AVG_TotalRootkits,
	:AVG_BuildType,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_WinVersion,
	:AVG_LastSynchro,
	:LastScanTime,
	:NeedRestart,
	:AVG_ExpirationDate,
	:AVG_AvgVersion,
	:Core_Version,
	:Antivirus_Version,
	:Antivirus_ReleaseDate,
	:AntiSpam_Version,
	:AntiSpam_LastRuleUpdate,
	:AntiVirusGroup_StateText,
	:EmailProtectionGroup_StateText,
	:LinkScannerGroup_StateText,
	:AM_StateText,
	:AdminClient_StateText,
	:AR_StateText,
	:FW_StateText,
	:FW_State,
	:FW_ConfigVersion,
	:License_StateText,
	:IDP_StateText,
	:UpdateMgr_StateText,
	:Analysis_StateText,
	:AR_State,
	:AVG_Logon,
	:AVG_Logoff,
	:AVG_LicenceNumber,
	:AM_StateTextObs,
	:AntiSpam_StateTextObs,
	:AntiSpy_StateTextObs,
	:Antivirus_StateTextObs,
	:AdminClient_StateTextObs,
	:AR_StateTextObs,
	:EMS_StateTextObs,
	:EMS_ExchangePluginObs,
	:EMS_BATPluginObs,
	:EMS_ThunderbirdPluginObs,
	:FW_StateTextObs,
	:License_StateTextObs,
	:LinkScanner_StateTextObs,
	:NetworkScanner_StateTextObs,
	:RS_StateTextObs,
	:IDP_StateTextObs,
	:UpdateMgr_StateTextObs,
	:Analysis_StateTextObs,
	:UserNames
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_non_compliant_C_PROC ( 
	bflt1 INTEGER,
	bflt_desc INTEGER,
	bflt_dmn INTEGER,
	bflt_ip INTEGER,
	bflt_os INTEGER,
	bflt_infected INTEGER,
	bflt_stool INTEGER,
	bflt_rst INTEGER,
	flt1_AVG_STATIONNAME VARCHAR(64),
	flt1_AVG_STATIONNAME_L VARCHAR(512),
	flt_desc_AVG_STATIONDESC VARCHAR(64),
	flt_desc_AVG_STATIONDESC_L VARCHAR(512),
	flt_dmn_AVG_STATION_DOMAIN VARCHAR(64),
	flt_dmn_AVG_STATION_DOMAIN_L VARCHAR(512),
	flt_ip_AVG_STATION_IP VARCHAR(64),
	flt_ip_AVG_STATION_IP_L VARCHAR(512),
	flt_os_AVG_STATION_OS VARCHAR(64),
	flt_os_AVG_STATION_OS_L VARCHAR(512) )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_non_compliant"
	WHERE
	((:bflt1=0)OR((:bflt1=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt1_AVG_STATIONNAME)))) AND
	((:bflt_desc=0)OR((:bflt_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_desc_AVG_STATIONDESC)))) AND
	((:bflt_dmn=0)OR((:bflt_dmn=1)AND(UPPER(AVG_StationDomain) LIKE UPPER(:flt_dmn_AVG_STATION_DOMAIN)))) AND
	((:bflt_infected=0)OR((:bflt_infected=1)AND((AVG_UnhealedInfections > 0) OR (AVG_UnhealedPups > 0) OR (AVG_UnhealedRootkits > 0)))) AND
	((:bflt_ip=0)OR((:bflt_ip=1)AND(UPPER(AVG_IPAddress) LIKE UPPER(:flt_ip_AVG_STATION_IP)))) AND
	((:bflt_os=0)OR((:bflt_os=1)AND(UPPER(AVG_WinVersion) LIKE UPPER(:flt_os_AVG_STATION_OS)))) AND
	((:bflt_rst=0)OR((:bflt_rst=1)AND(NeedRestart = '1'))) AND
	((:bflt_stool=0)OR((:bflt_stool=1)AND(AVG_LastCall = '')))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_firewalls"(
 VImg_Online,
 VImg_Infected,
 VImg_Restart,
 AVG_Code,
 AVG_StationName,
 AVG_StationDomain,
 AVG_StationDesc,
 AVG_GroupID,
 AVG_GroupName,
 AVG_LastCall,
 AVG_UnhealedInfections,
 AVG_UnhealedPups,
 AVG_UnhealedRootkits,
 AVG_TotalInfections,
 AVG_TotalPups,
 AVG_TotalRootkits,
 AVG_BuildType,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_WinVersion,
 AVG_LastSynchro,
 LastScanTime,
 NeedRestart,
 AVG_ExpirationDate,
 AVG_AvgVersion,
 Core_Version,
 Antivirus_Version,
 Antivirus_ReleaseDate,
 AntiSpam_Version,
 AntiSpam_LastRuleUpdate,
 AntiVirusGroup_StateText,
 EmailProtectionGroup_StateText,
 LinkScannerGroup_StateText,
 AM_StateText,
 AdminClient_StateText,
 AR_StateText,
 FW_StateText,
 FW_State,
 FW_ConfigVersion,
 License_StateText,
 IDP_StateText,
 UpdateMgr_StateText,
 Analysis_StateText,
 AR_State,
 AVG_Logon,
 AVG_Logoff,
 AVG_LicenceNumber,
 AM_StateTextObs,
 AntiSpam_StateTextObs,
 AntiSpy_StateTextObs,
 Antivirus_StateTextObs,
 AdminClient_StateTextObs,
 AR_StateTextObs,
 EMS_StateTextObs,
 EMS_ExchangePluginObs,
 EMS_BATPluginObs,
 EMS_ThunderbirdPluginObs,
 FW_StateTextObs,
 License_StateTextObs,
 LinkScanner_StateTextObs,
 NetworkScanner_StateTextObs,
 RS_StateTextObs,
 IDP_StateTextObs,
 UpdateMgr_StateTextObs,
 Analysis_StateTextObs,
 UserNames
) AS SELECT
 0,
 0,
 0,
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Stations".AVG_StationDesc,
 "AVG_Stations".AVG_GroupID,
 "AVG_Groups".AVG_GroupName,
 "AVG_Stations".AVG_LastCall,
 SUM("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits - "AVG_ScanLogs".AVG_HealedRootkits),
 SUM("AVG_ScanLogs".AVG_FoundInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits),
 "AVG_Stations".AVG_BuildType,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_WinVersion,
 "AVG_Stations".AVG_LastSynchro,
 "AVG_StationsStates".LastScanTime,
 "AVG_StationsStates".NeedRestart,
 "AVG_Stations".AVG_ExpirationDate,
 "AVG_StationsStates".AVG_AvgVersion,
 "AVG_StationsStates".Core_Version,
 "AVG_StationsStates".Antivirus_Version,
 "AVG_StationsStates".Antivirus_ReleaseDate,
 "AVG_StationsStates".AntiSpam_Version,
 "AVG_StationsStates".AntiSpam_LastRuleUpdate,
 "AVG_StationsStates".AntiVirusGroup_StateText,
 "AVG_StationsStates".EmailProtectionGroup_StateText,
 "AVG_StationsStates".LinkScannerGroup_StateText,
 "AVG_StationsStates".AM_StateText,
 "AVG_StationsStates".AdminClient_StateText,
 "AVG_StationsStates".AR_StateText,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".FW_State,
 "AVG_StationsStates".FW_ConfigVersion,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".IDP_StateText,
 "AVG_StationsStates".UpdateMgr_StateText,
 "AVG_StationsStates".Analysis_StateText,
 "AVG_StationsStates".AR_State,
 "AVG_Stations".AVG_Logon,
 "AVG_Stations".AVG_Logoff,
 "AVG_Stations".AVG_LicenceNumber,
 "AVG_StationsStates".AM_StateText,
 "AVG_StationsStates".AntiSpam_StateText,
 "AVG_StationsStates".AntiSpy_StateText,
 "AVG_StationsStates".Antivirus_StateText,
 "AVG_StationsStates".AdminClient_StateText,
 "AVG_StationsStates".AR_StateText,
 "AVG_StationsStates".EMS_StateText,
 "AVG_StationsStates".EMS_ExchangePlugin,
 "AVG_StationsStates".EMS_BATPlugin,
 "AVG_StationsStates".EMS_ThunderbirdPlugin,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".LinkScanner_StateText,
 "AVG_StationsStates".NetworkScanner_StateText,
 "AVG_StationsStates".RS_StateText,
 "AVG_StationsStates".IDP_StateText,
 "AVG_StationsStates".UpdateMgr_StateText,
 "AVG_StationsStates".Analysis_StateText,
 "AVG_StationsStates".UserNames
 FROM "AVG_Stations" LEFT JOIN "AVG_Groups" ON ("AVG_Stations".AVG_GroupID="AVG_Groups".AVG_Code) LEFT JOIN "AVG_StationsStates" ON ("AVG_Stations".AVG_Code="AVG_StationsStates".AVG_StationID) LEFT JOIN "setup" ON ("AVG_Stations".AVG_Code="setup".AVG_OwnerID) LEFT JOIN "AVG_ScanLogs" ON ("AVG_Stations".AVG_Code="AVG_ScanLogs".AVG_OwnerID AND ( "AVG_ScanLogs".AVG_ConfirmTime IS NULL OR "AVG_ScanLogs".AVG_ConfirmTime = '' ))
 WHERE ( "setup".setup__features__firewall IS NOT NULL ) AND ( "setup".setup__features__firewall > 0 ) AND ( "setup".AVG_OwnerType = 0 )AND( "AVG_Stations".AVG_StationType = 0) AND ( ( "AVG_ScanLogs".AVG_OwnerType IS NULL) OR ("AVG_ScanLogs".AVG_OwnerType = 0 ) )
 GROUP BY "AVG_Stations".AVG_Code,"AVG_Stations".AVG_StationName,"AVG_Stations".AVG_StationDomain,"AVG_Stations".AVG_StationDesc,"AVG_Stations".AVG_GroupID,"AVG_Groups".AVG_GroupName,"AVG_Stations".AVG_LastCall,"AVG_Stations".AVG_BuildType,"AVG_Stations".AVG_IPAddress,"AVG_Stations".AVG_MACAddress,"AVG_Stations".AVG_WinVersion,"AVG_Stations".AVG_LastSynchro,"AVG_StationsStates".LastScanTime,"AVG_StationsStates".NeedRestart,"AVG_Stations".AVG_ExpirationDate,"AVG_StationsStates".AVG_AvgVersion,"AVG_StationsStates".Core_Version,"AVG_StationsStates".Antivirus_Version,"AVG_StationsStates".Antivirus_ReleaseDate,"AVG_StationsStates".AntiSpam_Version,"AVG_StationsStates".AntiSpam_LastRuleUpdate,"AVG_StationsStates".AntiVirusGroup_StateText,"AVG_StationsStates".EmailProtectionGroup_StateText,"AVG_StationsStates".LinkScannerGroup_StateText,"AVG_StationsStates".AM_StateText,"AVG_StationsStates".AdminClient_StateText,"AVG_StationsStates".AR_StateText,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".FW_State,"AVG_StationsStates".FW_ConfigVersion,"AVG_StationsStates".License_StateText,"AVG_StationsStates".IDP_StateText,"AVG_StationsStates".UpdateMgr_StateText,"AVG_StationsStates".Analysis_StateText,"AVG_StationsStates".AR_State,"AVG_Stations".AVG_Logon,"AVG_Stations".AVG_Logoff,"AVG_Stations".AVG_LicenceNumber,"AVG_StationsStates".AM_StateText,"AVG_StationsStates".AntiSpam_StateText,"AVG_StationsStates".AntiSpy_StateText,"AVG_StationsStates".Antivirus_StateText,"AVG_StationsStates".AdminClient_StateText,"AVG_StationsStates".AR_StateText,"AVG_StationsStates".EMS_StateText,"AVG_StationsStates".EMS_ExchangePlugin,"AVG_StationsStates".EMS_BATPlugin,"AVG_StationsStates".EMS_ThunderbirdPlugin,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".License_StateText,"AVG_StationsStates".LinkScanner_StateText,"AVG_StationsStates".NetworkScanner_StateText,"AVG_StationsStates".RS_StateText,"AVG_StationsStates".IDP_StateText,"AVG_StationsStates".UpdateMgr_StateText,"AVG_StationsStates".Analysis_StateText,"AVG_StationsStates".UserNames;

<SQLBlock>
CREATE PROCEDURE view_firewalls_PROC ( 
	bflt1 INTEGER,
	bflt_desc INTEGER,
	bflt_dmn INTEGER,
	bflt_ip INTEGER,
	bflt_os INTEGER,
	bflt_infected INTEGER,
	bflt_stool INTEGER,
	bflt_rst INTEGER,
	flt1_AVG_STATIONNAME VARCHAR(64),
	flt1_AVG_STATIONNAME_L VARCHAR(512),
	flt_desc_AVG_STATIONDESC VARCHAR(64),
	flt_desc_AVG_STATIONDESC_L VARCHAR(512),
	flt_dmn_AVG_STATION_DOMAIN VARCHAR(64),
	flt_dmn_AVG_STATION_DOMAIN_L VARCHAR(512),
	flt_ip_AVG_STATION_IP VARCHAR(64),
	flt_ip_AVG_STATION_IP_L VARCHAR(512),
	flt_os_AVG_STATION_OS VARCHAR(64),
	flt_os_AVG_STATION_OS_L VARCHAR(512) )
	RETURNS (
	VImg_Online INTEGER,
	VImg_Infected INTEGER,
	VImg_Restart INTEGER,
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_StationDomain VARCHAR(64),
	AVG_StationDesc VARCHAR(250),
	AVG_GroupID INTEGER,
	AVG_GroupName VARCHAR(64),
	AVG_LastCall VARCHAR(20),
	AVG_UnhealedInfections INTEGER,
	AVG_UnhealedPups INTEGER,
	AVG_UnhealedRootkits INTEGER,
	AVG_TotalInfections INTEGER,
	AVG_TotalPups INTEGER,
	AVG_TotalRootkits INTEGER,
	AVG_BuildType INTEGER,
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_WinVersion VARCHAR(255),
	AVG_LastSynchro VARCHAR(20),
	LastScanTime VARCHAR(20),
	NeedRestart INTEGER,
	AVG_ExpirationDate VARCHAR(20),
	AVG_AvgVersion VARCHAR(50),
	Core_Version VARCHAR(50),
	Antivirus_Version VARCHAR(50),
	Antivirus_ReleaseDate VARCHAR(20),
	AntiSpam_Version VARCHAR(50),
	AntiSpam_LastRuleUpdate VARCHAR(20),
	AntiVirusGroup_StateText VARCHAR(128),
	EmailProtectionGroup_StateText VARCHAR(128),
	LinkScannerGroup_StateText VARCHAR(128),
	AM_StateText VARCHAR(128),
	AdminClient_StateText VARCHAR(128),
	AR_StateText VARCHAR(128),
	FW_StateText VARCHAR(128),
	FW_State INTEGER,
	FW_ConfigVersion INTEGER,
	License_StateText VARCHAR(128),
	IDP_StateText VARCHAR(128),
	UpdateMgr_StateText VARCHAR(128),
	Analysis_StateText VARCHAR(128),
	AR_State INTEGER,
	AVG_Logon VARCHAR(20),
	AVG_Logoff VARCHAR(20),
	AVG_LicenceNumber VARCHAR(64),
	AM_StateTextObs VARCHAR(128),
	AntiSpam_StateTextObs VARCHAR(128),
	AntiSpy_StateTextObs VARCHAR(128),
	Antivirus_StateTextObs VARCHAR(128),
	AdminClient_StateTextObs VARCHAR(128),
	AR_StateTextObs VARCHAR(128),
	EMS_StateTextObs VARCHAR(128),
	EMS_ExchangePluginObs VARCHAR(40),
	EMS_BATPluginObs VARCHAR(40),
	EMS_ThunderbirdPluginObs VARCHAR(40),
	FW_StateTextObs VARCHAR(128),
	License_StateTextObs VARCHAR(128),
	LinkScanner_StateTextObs VARCHAR(128),
	NetworkScanner_StateTextObs VARCHAR(128),
	RS_StateTextObs VARCHAR(128),
	IDP_StateTextObs VARCHAR(128),
	UpdateMgr_StateTextObs VARCHAR(128),
	Analysis_StateTextObs VARCHAR(128),
	UserNames VARCHAR(255))
AS BEGIN
	FOR SELECT 
	VImg_Online,
	VImg_Infected,
	VImg_Restart,
	AVG_Code,
	AVG_StationName,
	AVG_StationDomain,
	AVG_StationDesc,
	AVG_GroupID,
	AVG_GroupName,
	AVG_LastCall,
	AVG_UnhealedInfections,
	AVG_UnhealedPups,
	AVG_UnhealedRootkits,
	AVG_TotalInfections,
	AVG_TotalPups,
	AVG_TotalRootkits,
	AVG_BuildType,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_WinVersion,
	AVG_LastSynchro,
	LastScanTime,
	NeedRestart,
	AVG_ExpirationDate,
	AVG_AvgVersion,
	Core_Version,
	Antivirus_Version,
	Antivirus_ReleaseDate,
	AntiSpam_Version,
	AntiSpam_LastRuleUpdate,
	AntiVirusGroup_StateText,
	EmailProtectionGroup_StateText,
	LinkScannerGroup_StateText,
	AM_StateText,
	AdminClient_StateText,
	AR_StateText,
	FW_StateText,
	FW_State,
	FW_ConfigVersion,
	License_StateText,
	IDP_StateText,
	UpdateMgr_StateText,
	Analysis_StateText,
	AR_State,
	AVG_Logon,
	AVG_Logoff,
	AVG_LicenceNumber,
	AM_StateTextObs,
	AntiSpam_StateTextObs,
	AntiSpy_StateTextObs,
	Antivirus_StateTextObs,
	AdminClient_StateTextObs,
	AR_StateTextObs,
	EMS_StateTextObs,
	EMS_ExchangePluginObs,
	EMS_BATPluginObs,
	EMS_ThunderbirdPluginObs,
	FW_StateTextObs,
	License_StateTextObs,
	LinkScanner_StateTextObs,
	NetworkScanner_StateTextObs,
	RS_StateTextObs,
	IDP_StateTextObs,
	UpdateMgr_StateTextObs,
	Analysis_StateTextObs,
	UserNames
	FROM "view_firewalls"
	WHERE
	((:bflt1=0)OR((:bflt1=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt1_AVG_STATIONNAME)))) AND
	((:bflt_desc=0)OR((:bflt_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_desc_AVG_STATIONDESC)))) AND
	((:bflt_dmn=0)OR((:bflt_dmn=1)AND(UPPER(AVG_StationDomain) LIKE UPPER(:flt_dmn_AVG_STATION_DOMAIN)))) AND
	((:bflt_infected=0)OR((:bflt_infected=1)AND((AVG_UnhealedInfections > 0) OR (AVG_UnhealedPups > 0) OR (AVG_UnhealedRootkits > 0)))) AND
	((:bflt_ip=0)OR((:bflt_ip=1)AND(UPPER(AVG_IPAddress) LIKE UPPER(:flt_ip_AVG_STATION_IP)))) AND
	((:bflt_os=0)OR((:bflt_os=1)AND(UPPER(AVG_WinVersion) LIKE UPPER(:flt_os_AVG_STATION_OS)))) AND
	((:bflt_rst=0)OR((:bflt_rst=1)AND(NeedRestart = '1'))) AND
	((:bflt_stool=0)OR((:bflt_stool=1)AND(AVG_LastCall = '')))
	INTO
	:VImg_Online,
	:VImg_Infected,
	:VImg_Restart,
	:AVG_Code,
	:AVG_StationName,
	:AVG_StationDomain,
	:AVG_StationDesc,
	:AVG_GroupID,
	:AVG_GroupName,
	:AVG_LastCall,
	:AVG_UnhealedInfections,
	:AVG_UnhealedPups,
	:AVG_UnhealedRootkits,
	:AVG_TotalInfections,
	:AVG_TotalPups,
	:AVG_TotalRootkits,
	:AVG_BuildType,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_WinVersion,
	:AVG_LastSynchro,
	:LastScanTime,
	:NeedRestart,
	:AVG_ExpirationDate,
	:AVG_AvgVersion,
	:Core_Version,
	:Antivirus_Version,
	:Antivirus_ReleaseDate,
	:AntiSpam_Version,
	:AntiSpam_LastRuleUpdate,
	:AntiVirusGroup_StateText,
	:EmailProtectionGroup_StateText,
	:LinkScannerGroup_StateText,
	:AM_StateText,
	:AdminClient_StateText,
	:AR_StateText,
	:FW_StateText,
	:FW_State,
	:FW_ConfigVersion,
	:License_StateText,
	:IDP_StateText,
	:UpdateMgr_StateText,
	:Analysis_StateText,
	:AR_State,
	:AVG_Logon,
	:AVG_Logoff,
	:AVG_LicenceNumber,
	:AM_StateTextObs,
	:AntiSpam_StateTextObs,
	:AntiSpy_StateTextObs,
	:Antivirus_StateTextObs,
	:AdminClient_StateTextObs,
	:AR_StateTextObs,
	:EMS_StateTextObs,
	:EMS_ExchangePluginObs,
	:EMS_BATPluginObs,
	:EMS_ThunderbirdPluginObs,
	:FW_StateTextObs,
	:License_StateTextObs,
	:LinkScanner_StateTextObs,
	:NetworkScanner_StateTextObs,
	:RS_StateTextObs,
	:IDP_StateTextObs,
	:UpdateMgr_StateTextObs,
	:Analysis_StateTextObs,
	:UserNames
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_firewalls_C_PROC ( 
	bflt1 INTEGER,
	bflt_desc INTEGER,
	bflt_dmn INTEGER,
	bflt_ip INTEGER,
	bflt_os INTEGER,
	bflt_infected INTEGER,
	bflt_stool INTEGER,
	bflt_rst INTEGER,
	flt1_AVG_STATIONNAME VARCHAR(64),
	flt1_AVG_STATIONNAME_L VARCHAR(512),
	flt_desc_AVG_STATIONDESC VARCHAR(64),
	flt_desc_AVG_STATIONDESC_L VARCHAR(512),
	flt_dmn_AVG_STATION_DOMAIN VARCHAR(64),
	flt_dmn_AVG_STATION_DOMAIN_L VARCHAR(512),
	flt_ip_AVG_STATION_IP VARCHAR(64),
	flt_ip_AVG_STATION_IP_L VARCHAR(512),
	flt_os_AVG_STATION_OS VARCHAR(64),
	flt_os_AVG_STATION_OS_L VARCHAR(512) )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_firewalls"
	WHERE
	((:bflt1=0)OR((:bflt1=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt1_AVG_STATIONNAME)))) AND
	((:bflt_desc=0)OR((:bflt_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_desc_AVG_STATIONDESC)))) AND
	((:bflt_dmn=0)OR((:bflt_dmn=1)AND(UPPER(AVG_StationDomain) LIKE UPPER(:flt_dmn_AVG_STATION_DOMAIN)))) AND
	((:bflt_infected=0)OR((:bflt_infected=1)AND((AVG_UnhealedInfections > 0) OR (AVG_UnhealedPups > 0) OR (AVG_UnhealedRootkits > 0)))) AND
	((:bflt_ip=0)OR((:bflt_ip=1)AND(UPPER(AVG_IPAddress) LIKE UPPER(:flt_ip_AVG_STATION_IP)))) AND
	((:bflt_os=0)OR((:bflt_os=1)AND(UPPER(AVG_WinVersion) LIKE UPPER(:flt_os_AVG_STATION_OS)))) AND
	((:bflt_rst=0)OR((:bflt_rst=1)AND(NeedRestart = '1'))) AND
	((:bflt_stool=0)OR((:bflt_stool=1)AND(AVG_LastCall = '')))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_win_groups"(
 VImg_Online,
 VImg_Infected,
 VImg_Restart,
 AVG_Code,
 AVG_StationName,
 AVG_StationDomain,
 AVG_StationDesc,
 AVG_GroupID,
 AVG_GroupName,
 AVG_LastCall,
 AVG_UnhealedInfections,
 AVG_UnhealedPups,
 AVG_UnhealedRootkits,
 AVG_TotalInfections,
 AVG_TotalPups,
 AVG_TotalRootkits,
 AVG_BuildType,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_WinVersion,
 AVG_LastSynchro,
 LastScanTime,
 NeedRestart,
 AVG_ExpirationDate,
 AVG_AvgVersion,
 Core_Version,
 Antivirus_Version,
 Antivirus_ReleaseDate,
 AntiSpam_Version,
 AntiSpam_LastRuleUpdate,
 AntiVirusGroup_StateText,
 EmailProtectionGroup_StateText,
 LinkScannerGroup_StateText,
 AM_StateText,
 AdminClient_StateText,
 AR_StateText,
 FW_StateText,
 FW_State,
 FW_ConfigVersion,
 License_StateText,
 IDP_StateText,
 UpdateMgr_StateText,
 Analysis_StateText,
 AR_State,
 AVG_Logon,
 AVG_Logoff,
 AVG_LicenceNumber,
 AM_StateTextObs,
 AntiSpam_StateTextObs,
 AntiSpy_StateTextObs,
 Antivirus_StateTextObs,
 AdminClient_StateTextObs,
 AR_StateTextObs,
 EMS_StateTextObs,
 EMS_ExchangePluginObs,
 EMS_BATPluginObs,
 EMS_ThunderbirdPluginObs,
 FW_StateTextObs,
 License_StateTextObs,
 LinkScanner_StateTextObs,
 NetworkScanner_StateTextObs,
 RS_StateTextObs,
 IDP_StateTextObs,
 UpdateMgr_StateTextObs,
 Analysis_StateTextObs,
 UserNames
) AS SELECT
 0,
 0,
 0,
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Stations".AVG_StationDesc,
 "AVG_Stations".AVG_GroupID,
 "AVG_Groups".AVG_GroupName,
 "AVG_Stations".AVG_LastCall,
 SUM("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits - "AVG_ScanLogs".AVG_HealedRootkits),
 SUM("AVG_ScanLogs".AVG_FoundInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits),
 "AVG_Stations".AVG_BuildType,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_WinVersion,
 "AVG_Stations".AVG_LastSynchro,
 "AVG_StationsStates".LastScanTime,
 "AVG_StationsStates".NeedRestart,
 "AVG_Stations".AVG_ExpirationDate,
 "AVG_StationsStates".AVG_AvgVersion,
 "AVG_StationsStates".Core_Version,
 "AVG_StationsStates".Antivirus_Version,
 "AVG_StationsStates".Antivirus_ReleaseDate,
 "AVG_StationsStates".AntiSpam_Version,
 "AVG_StationsStates".AntiSpam_LastRuleUpdate,
 "AVG_StationsStates".AntiVirusGroup_StateText,
 "AVG_StationsStates".EmailProtectionGroup_StateText,
 "AVG_StationsStates".LinkScannerGroup_StateText,
 "AVG_StationsStates".AM_StateText,
 "AVG_StationsStates".AdminClient_StateText,
 "AVG_StationsStates".AR_StateText,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".FW_State,
 "AVG_StationsStates".FW_ConfigVersion,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".IDP_StateText,
 "AVG_StationsStates".UpdateMgr_StateText,
 "AVG_StationsStates".Analysis_StateText,
 "AVG_StationsStates".AR_State,
 "AVG_Stations".AVG_Logon,
 "AVG_Stations".AVG_Logoff,
 "AVG_Stations".AVG_LicenceNumber,
 "AVG_StationsStates".AM_StateText,
 "AVG_StationsStates".AntiSpam_StateText,
 "AVG_StationsStates".AntiSpy_StateText,
 "AVG_StationsStates".Antivirus_StateText,
 "AVG_StationsStates".AdminClient_StateText,
 "AVG_StationsStates".AR_StateText,
 "AVG_StationsStates".EMS_StateText,
 "AVG_StationsStates".EMS_ExchangePlugin,
 "AVG_StationsStates".EMS_BATPlugin,
 "AVG_StationsStates".EMS_ThunderbirdPlugin,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".LinkScanner_StateText,
 "AVG_StationsStates".NetworkScanner_StateText,
 "AVG_StationsStates".RS_StateText,
 "AVG_StationsStates".IDP_StateText,
 "AVG_StationsStates".UpdateMgr_StateText,
 "AVG_StationsStates".Analysis_StateText,
 "AVG_StationsStates".UserNames
 FROM "AVG_Stations" LEFT JOIN "AVG_Groups" ON ("AVG_Stations".AVG_GroupID="AVG_Groups".AVG_Code) LEFT JOIN "AVG_StationsStates" ON ("AVG_Stations".AVG_Code="AVG_StationsStates".AVG_StationID) LEFT JOIN "AVG_ScanLogs" ON ("AVG_Stations".AVG_Code="AVG_ScanLogs".AVG_OwnerID AND ( "AVG_ScanLogs".AVG_ConfirmTime IS NULL OR "AVG_ScanLogs".AVG_ConfirmTime = '' ))
 WHERE ( "AVG_Stations".AVG_StationType = 0 AND ("AVG_ScanLogs".AVG_OwnerType IS NULL OR "AVG_ScanLogs".AVG_OwnerType = 0) )
 GROUP BY "AVG_Stations".AVG_Code,"AVG_Stations".AVG_StationName,"AVG_Stations".AVG_StationDomain,"AVG_Stations".AVG_StationDesc,"AVG_Stations".AVG_GroupID,"AVG_Groups".AVG_GroupName,"AVG_Stations".AVG_LastCall,"AVG_Stations".AVG_BuildType,"AVG_Stations".AVG_IPAddress,"AVG_Stations".AVG_MACAddress,"AVG_Stations".AVG_WinVersion,"AVG_Stations".AVG_LastSynchro,"AVG_StationsStates".LastScanTime,"AVG_StationsStates".NeedRestart,"AVG_Stations".AVG_ExpirationDate,"AVG_StationsStates".AVG_AvgVersion,"AVG_StationsStates".Core_Version,"AVG_StationsStates".Antivirus_Version,"AVG_StationsStates".Antivirus_ReleaseDate,"AVG_StationsStates".AntiSpam_Version,"AVG_StationsStates".AntiSpam_LastRuleUpdate,"AVG_StationsStates".AntiVirusGroup_StateText,"AVG_StationsStates".EmailProtectionGroup_StateText,"AVG_StationsStates".LinkScannerGroup_StateText,"AVG_StationsStates".AM_StateText,"AVG_StationsStates".AdminClient_StateText,"AVG_StationsStates".AR_StateText,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".FW_State,"AVG_StationsStates".FW_ConfigVersion,"AVG_StationsStates".License_StateText,"AVG_StationsStates".IDP_StateText,"AVG_StationsStates".UpdateMgr_StateText,"AVG_StationsStates".Analysis_StateText,"AVG_StationsStates".AR_State,"AVG_Stations".AVG_Logon,"AVG_Stations".AVG_Logoff,"AVG_Stations".AVG_LicenceNumber,"AVG_StationsStates".AM_StateText,"AVG_StationsStates".AntiSpam_StateText,"AVG_StationsStates".AntiSpy_StateText,"AVG_StationsStates".Antivirus_StateText,"AVG_StationsStates".AdminClient_StateText,"AVG_StationsStates".AR_StateText,"AVG_StationsStates".EMS_StateText,"AVG_StationsStates".EMS_ExchangePlugin,"AVG_StationsStates".EMS_BATPlugin,"AVG_StationsStates".EMS_ThunderbirdPlugin,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".License_StateText,"AVG_StationsStates".LinkScanner_StateText,"AVG_StationsStates".NetworkScanner_StateText,"AVG_StationsStates".RS_StateText,"AVG_StationsStates".IDP_StateText,"AVG_StationsStates".UpdateMgr_StateText,"AVG_StationsStates".Analysis_StateText,"AVG_StationsStates".UserNames;

<SQLBlock>
CREATE PROCEDURE view_win_groups_PROC ( 
	RowFilter INTEGER,
	bflt1 INTEGER,
	bflt_desc INTEGER,
	bflt_dmn INTEGER,
	bflt_ip INTEGER,
	bflt_os INTEGER,
	bflt_infected INTEGER,
	bflt_stool INTEGER,
	bflt_rst INTEGER,
	flt1_AVG_STATIONNAME VARCHAR(64),
	flt1_AVG_STATIONNAME_L VARCHAR(512),
	flt_desc_AVG_STATIONDESC VARCHAR(64),
	flt_desc_AVG_STATIONDESC_L VARCHAR(512),
	flt_dmn_AVG_STATION_DOMAIN VARCHAR(64),
	flt_dmn_AVG_STATION_DOMAIN_L VARCHAR(512),
	flt_ip_AVG_STATION_IP VARCHAR(64),
	flt_ip_AVG_STATION_IP_L VARCHAR(512),
	flt_os_AVG_STATION_OS VARCHAR(64),
	flt_os_AVG_STATION_OS_L VARCHAR(512) )
	RETURNS (
	VImg_Online INTEGER,
	VImg_Infected INTEGER,
	VImg_Restart INTEGER,
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_StationDomain VARCHAR(64),
	AVG_StationDesc VARCHAR(250),
	AVG_GroupID INTEGER,
	AVG_GroupName VARCHAR(64),
	AVG_LastCall VARCHAR(20),
	AVG_UnhealedInfections INTEGER,
	AVG_UnhealedPups INTEGER,
	AVG_UnhealedRootkits INTEGER,
	AVG_TotalInfections INTEGER,
	AVG_TotalPups INTEGER,
	AVG_TotalRootkits INTEGER,
	AVG_BuildType INTEGER,
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_WinVersion VARCHAR(255),
	AVG_LastSynchro VARCHAR(20),
	LastScanTime VARCHAR(20),
	NeedRestart INTEGER,
	AVG_ExpirationDate VARCHAR(20),
	AVG_AvgVersion VARCHAR(50),
	Core_Version VARCHAR(50),
	Antivirus_Version VARCHAR(50),
	Antivirus_ReleaseDate VARCHAR(20),
	AntiSpam_Version VARCHAR(50),
	AntiSpam_LastRuleUpdate VARCHAR(20),
	AntiVirusGroup_StateText VARCHAR(128),
	EmailProtectionGroup_StateText VARCHAR(128),
	LinkScannerGroup_StateText VARCHAR(128),
	AM_StateText VARCHAR(128),
	AdminClient_StateText VARCHAR(128),
	AR_StateText VARCHAR(128),
	FW_StateText VARCHAR(128),
	FW_State INTEGER,
	FW_ConfigVersion INTEGER,
	License_StateText VARCHAR(128),
	IDP_StateText VARCHAR(128),
	UpdateMgr_StateText VARCHAR(128),
	Analysis_StateText VARCHAR(128),
	AR_State INTEGER,
	AVG_Logon VARCHAR(20),
	AVG_Logoff VARCHAR(20),
	AVG_LicenceNumber VARCHAR(64),
	AM_StateTextObs VARCHAR(128),
	AntiSpam_StateTextObs VARCHAR(128),
	AntiSpy_StateTextObs VARCHAR(128),
	Antivirus_StateTextObs VARCHAR(128),
	AdminClient_StateTextObs VARCHAR(128),
	AR_StateTextObs VARCHAR(128),
	EMS_StateTextObs VARCHAR(128),
	EMS_ExchangePluginObs VARCHAR(40),
	EMS_BATPluginObs VARCHAR(40),
	EMS_ThunderbirdPluginObs VARCHAR(40),
	FW_StateTextObs VARCHAR(128),
	License_StateTextObs VARCHAR(128),
	LinkScanner_StateTextObs VARCHAR(128),
	NetworkScanner_StateTextObs VARCHAR(128),
	RS_StateTextObs VARCHAR(128),
	IDP_StateTextObs VARCHAR(128),
	UpdateMgr_StateTextObs VARCHAR(128),
	Analysis_StateTextObs VARCHAR(128),
	UserNames VARCHAR(255))
AS BEGIN
	FOR SELECT 
	VImg_Online,
	VImg_Infected,
	VImg_Restart,
	AVG_Code,
	AVG_StationName,
	AVG_StationDomain,
	AVG_StationDesc,
	AVG_GroupID,
	AVG_GroupName,
	AVG_LastCall,
	AVG_UnhealedInfections,
	AVG_UnhealedPups,
	AVG_UnhealedRootkits,
	AVG_TotalInfections,
	AVG_TotalPups,
	AVG_TotalRootkits,
	AVG_BuildType,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_WinVersion,
	AVG_LastSynchro,
	LastScanTime,
	NeedRestart,
	AVG_ExpirationDate,
	AVG_AvgVersion,
	Core_Version,
	Antivirus_Version,
	Antivirus_ReleaseDate,
	AntiSpam_Version,
	AntiSpam_LastRuleUpdate,
	AntiVirusGroup_StateText,
	EmailProtectionGroup_StateText,
	LinkScannerGroup_StateText,
	AM_StateText,
	AdminClient_StateText,
	AR_StateText,
	FW_StateText,
	FW_State,
	FW_ConfigVersion,
	License_StateText,
	IDP_StateText,
	UpdateMgr_StateText,
	Analysis_StateText,
	AR_State,
	AVG_Logon,
	AVG_Logoff,
	AVG_LicenceNumber,
	AM_StateTextObs,
	AntiSpam_StateTextObs,
	AntiSpy_StateTextObs,
	Antivirus_StateTextObs,
	AdminClient_StateTextObs,
	AR_StateTextObs,
	EMS_StateTextObs,
	EMS_ExchangePluginObs,
	EMS_BATPluginObs,
	EMS_ThunderbirdPluginObs,
	FW_StateTextObs,
	License_StateTextObs,
	LinkScanner_StateTextObs,
	NetworkScanner_StateTextObs,
	RS_StateTextObs,
	IDP_StateTextObs,
	UpdateMgr_StateTextObs,
	Analysis_StateTextObs,
	UserNames
	FROM "view_win_groups"
	WHERE
	((:bflt1=0)OR((:bflt1=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt1_AVG_STATIONNAME)))) AND
	((:bflt_desc=0)OR((:bflt_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_desc_AVG_STATIONDESC)))) AND
	((:bflt_dmn=0)OR((:bflt_dmn=1)AND(UPPER(AVG_StationDomain) LIKE UPPER(:flt_dmn_AVG_STATION_DOMAIN)))) AND
	((:bflt_infected=0)OR((:bflt_infected=1)AND((AVG_UnhealedInfections > 0) OR (AVG_UnhealedPups > 0) OR (AVG_UnhealedRootkits > 0)))) AND
	((:bflt_ip=0)OR((:bflt_ip=1)AND(UPPER(AVG_IPAddress) LIKE UPPER(:flt_ip_AVG_STATION_IP)))) AND
	((:bflt_os=0)OR((:bflt_os=1)AND(UPPER(AVG_WinVersion) LIKE UPPER(:flt_os_AVG_STATION_OS)))) AND
	((:bflt_rst=0)OR((:bflt_rst=1)AND(NeedRestart = '1'))) AND
	((:bflt_stool=0)OR((:bflt_stool=1)AND(AVG_LastCall = ''))) AND
	AVG_GroupID = :RowFilter
	INTO
	:VImg_Online,
	:VImg_Infected,
	:VImg_Restart,
	:AVG_Code,
	:AVG_StationName,
	:AVG_StationDomain,
	:AVG_StationDesc,
	:AVG_GroupID,
	:AVG_GroupName,
	:AVG_LastCall,
	:AVG_UnhealedInfections,
	:AVG_UnhealedPups,
	:AVG_UnhealedRootkits,
	:AVG_TotalInfections,
	:AVG_TotalPups,
	:AVG_TotalRootkits,
	:AVG_BuildType,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_WinVersion,
	:AVG_LastSynchro,
	:LastScanTime,
	:NeedRestart,
	:AVG_ExpirationDate,
	:AVG_AvgVersion,
	:Core_Version,
	:Antivirus_Version,
	:Antivirus_ReleaseDate,
	:AntiSpam_Version,
	:AntiSpam_LastRuleUpdate,
	:AntiVirusGroup_StateText,
	:EmailProtectionGroup_StateText,
	:LinkScannerGroup_StateText,
	:AM_StateText,
	:AdminClient_StateText,
	:AR_StateText,
	:FW_StateText,
	:FW_State,
	:FW_ConfigVersion,
	:License_StateText,
	:IDP_StateText,
	:UpdateMgr_StateText,
	:Analysis_StateText,
	:AR_State,
	:AVG_Logon,
	:AVG_Logoff,
	:AVG_LicenceNumber,
	:AM_StateTextObs,
	:AntiSpam_StateTextObs,
	:AntiSpy_StateTextObs,
	:Antivirus_StateTextObs,
	:AdminClient_StateTextObs,
	:AR_StateTextObs,
	:EMS_StateTextObs,
	:EMS_ExchangePluginObs,
	:EMS_BATPluginObs,
	:EMS_ThunderbirdPluginObs,
	:FW_StateTextObs,
	:License_StateTextObs,
	:LinkScanner_StateTextObs,
	:NetworkScanner_StateTextObs,
	:RS_StateTextObs,
	:IDP_StateTextObs,
	:UpdateMgr_StateTextObs,
	:Analysis_StateTextObs,
	:UserNames
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_win_groups_C_PROC ( 
	RowFilter INTEGER,
	bflt1 INTEGER,
	bflt_desc INTEGER,
	bflt_dmn INTEGER,
	bflt_ip INTEGER,
	bflt_os INTEGER,
	bflt_infected INTEGER,
	bflt_stool INTEGER,
	bflt_rst INTEGER,
	flt1_AVG_STATIONNAME VARCHAR(64),
	flt1_AVG_STATIONNAME_L VARCHAR(512),
	flt_desc_AVG_STATIONDESC VARCHAR(64),
	flt_desc_AVG_STATIONDESC_L VARCHAR(512),
	flt_dmn_AVG_STATION_DOMAIN VARCHAR(64),
	flt_dmn_AVG_STATION_DOMAIN_L VARCHAR(512),
	flt_ip_AVG_STATION_IP VARCHAR(64),
	flt_ip_AVG_STATION_IP_L VARCHAR(512),
	flt_os_AVG_STATION_OS VARCHAR(64),
	flt_os_AVG_STATION_OS_L VARCHAR(512) )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_win_groups"
	WHERE
	((:bflt1=0)OR((:bflt1=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt1_AVG_STATIONNAME)))) AND
	((:bflt_desc=0)OR((:bflt_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_desc_AVG_STATIONDESC)))) AND
	((:bflt_dmn=0)OR((:bflt_dmn=1)AND(UPPER(AVG_StationDomain) LIKE UPPER(:flt_dmn_AVG_STATION_DOMAIN)))) AND
	((:bflt_infected=0)OR((:bflt_infected=1)AND((AVG_UnhealedInfections > 0) OR (AVG_UnhealedPups > 0) OR (AVG_UnhealedRootkits > 0)))) AND
	((:bflt_ip=0)OR((:bflt_ip=1)AND(UPPER(AVG_IPAddress) LIKE UPPER(:flt_ip_AVG_STATION_IP)))) AND
	((:bflt_os=0)OR((:bflt_os=1)AND(UPPER(AVG_WinVersion) LIKE UPPER(:flt_os_AVG_STATION_OS)))) AND
	((:bflt_rst=0)OR((:bflt_rst=1)AND(NeedRestart = '1'))) AND
	((:bflt_stool=0)OR((:bflt_stool=1)AND(AVG_LastCall = ''))) AND
	AVG_GroupID = :RowFilter
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_servers"(
 AVG_Code,
 AVG_ServerName,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_StationType,
 AVG_SortCode
) AS SELECT
 "AVG_Servers".AVG_Code,
 "AVG_Servers".AVG_ServerName,
 "AVG_Servers".AVG_IPAddress,
 "AVG_Servers".AVG_MACAddress,
 "AVG_Servers".AVG_StationType,
 AVG_Code*100 + AVG_StationType
 FROM "AVG_Servers"
 UNION SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName AS AVG_ServerName,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_StationType,
 AVG_Code*100 + AVG_StationType
 FROM "AVG_Stations"
 WHERE AVG_StationType=7;

<SQLBlock>
CREATE PROCEDURE view_servers_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_ServerName VARCHAR(64),
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_StationType INTEGER,
	AVG_SortCode INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_ServerName,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_StationType,
	AVG_SortCode
	FROM "view_servers"
	INTO
	:AVG_Code,
	:AVG_ServerName,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_StationType,
	:AVG_SortCode
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_servers_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_servers"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_update_servers"(
 AVG_Code,
 AVG_ServerName,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_ListenPort,
 AVG_LastCall,
 AVG_TodayDownloadedCount,
 AVG_TodayUploadedCount,
 AVG_TodayDownloadedSize,
 AVG_TodayUploadedSize
) AS SELECT
 "AVG_Servers".AVG_Code,
 "AVG_Servers".AVG_ServerName,
 "AVG_Servers".AVG_IPAddress,
 "AVG_Servers".AVG_MACAddress,
 "AVG_Servers".AVG_ListenPort,
 "AVG_Servers".AVG_LastCall,
 "AVG_Servers".AVG_TodayDownloadedCount,
 "AVG_Servers".AVG_TodayUploadedCount,
 "AVG_Servers".AVG_TodayDownloadedSize,
 "AVG_Servers".AVG_TodayUploadedSize
 FROM "AVG_Servers";

<SQLBlock>
CREATE PROCEDURE view_update_servers_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_ServerName VARCHAR(64),
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_ListenPort INTEGER,
	AVG_LastCall VARCHAR(20),
	AVG_TodayDownloadedCount INTEGER,
	AVG_TodayUploadedCount INTEGER,
	AVG_TodayDownloadedSize VARCHAR(20),
	AVG_TodayUploadedSize VARCHAR(20))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_ServerName,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_ListenPort,
	AVG_LastCall,
	AVG_TodayDownloadedCount,
	AVG_TodayUploadedCount,
	AVG_TodayDownloadedSize,
	AVG_TodayUploadedSize
	FROM "view_update_servers"
	INTO
	:AVG_Code,
	:AVG_ServerName,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_ListenPort,
	:AVG_LastCall,
	:AVG_TodayDownloadedCount,
	:AVG_TodayUploadedCount,
	:AVG_TodayDownloadedSize,
	:AVG_TodayUploadedSize
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_update_servers_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_update_servers"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_exchange_servers"(
 VImg_Online,
 VImg_Infected,
 VImg_Restart,
 AVG_Code,
 AVG_StationName,
 AVG_StationDomain,
 AVG_StationDesc,
 AVG_LastCall,
 AVG_UnhealedInfections,
 AVG_UnhealedPups,
 AVG_UnhealedRootkits,
 AVG_TotalInfections,
 AVG_TotalPups,
 AVG_TotalRootkits,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_WinVersion,
 AVG_LastSynchro,
 LastScanTime,
 NeedRestart,
 AVG_AvgVersion,
 Antivirus_Version,
 Antivirus_ReleaseDate,
 AntiVirusGroup_StateText,
 AM_StateText,
 AdminClient_StateText,
 AR_StateText,
 License_StateText,
 UpdateMgr_StateText,
 SrvExchAntiSpam_StateText,
 SrvExchRoutingTA_StateText,
 SrvExchSmtpTA_StateText,
 SrvExchVSAPI_StateText,
 SrvSharePoint_StateText,
 AR_State,
 AVG_Logon,
 AVG_Logoff,
 setup_EXCH_SMTPTA,
 setup_EXCH_ROUTING,
 setup_EXCH_VSAPI,
 setup_EXCH_ANTISPAM,
 setup_SHAREPOINT,
 AVG_LicenceNumber,
 AM_StateTextObs,
 AntiSpy_StateTextObs,
 Antivirus_StateTextObs,
 AdminClient_StateTextObs,
 AR_StateTextObs,
 License_StateTextObs,
 RS_StateTextObs,
 UpdateMgr_StateTextObs,
 SrvExchAntiSpam_StateTextObs,
 SrvExchRoutingTA_StateTextObs,
 SrvExchSmtpTA_StateTextObs,
 SrvExchVSAPI_StateTextObs,
 SrvSharePoint_StateTextObs
) AS SELECT
 0,
 0,
 0,
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Stations".AVG_StationDesc,
 "AVG_Stations".AVG_LastCall,
 SUM("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits - "AVG_ScanLogs".AVG_HealedRootkits),
 SUM("AVG_ScanLogs".AVG_FoundInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits),
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_WinVersion,
 "AVG_Stations".AVG_LastSynchro,
 "AVG_StationsStates".LastScanTime,
 "AVG_StationsStates".NeedRestart,
 "AVG_StationsStates".AVG_AvgVersion,
 "AVG_StationsStates".Antivirus_Version,
 "AVG_StationsStates".Antivirus_ReleaseDate,
 "AVG_StationsStates".AntiVirusGroup_StateText,
 "AVG_StationsStates".AM_StateText,
 "AVG_StationsStates".AdminClient_StateText,
 "AVG_StationsStates".AR_StateText,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".UpdateMgr_StateText,
 "AVG_StationsStates".SrvExchAntiSpam_StateText,
 "AVG_StationsStates".SrvExchRoutingTA_StateText,
 "AVG_StationsStates".SrvExchSmtpTA_StateText,
 "AVG_StationsStates".SrvExchVSAPI_StateText,
 "AVG_StationsStates".SrvSharePoint_StateText,
 "AVG_StationsStates".AR_State,
 "AVG_Stations".AVG_Logon,
 "AVG_Stations".AVG_Logoff,
 ("setup".setup__features__srv_efb5f7107),
 ("setup".setup__features__srv_e9e808cba),
 ("setup".setup__features__srv_e26f252af),
 ("setup".setup__features__srv_a91b2cc14),
 ("setup".setup__features__srv_a5bfffddd),
 "AVG_Stations".AVG_LicenceNumber,
 "AVG_StationsStates".AM_StateText,
 "AVG_StationsStates".AntiSpy_StateText,
 "AVG_StationsStates".Antivirus_StateText,
 "AVG_StationsStates".AdminClient_StateText,
 "AVG_StationsStates".AR_StateText,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".RS_StateText,
 "AVG_StationsStates".UpdateMgr_StateText,
 "AVG_StationsStates".SrvExchAntiSpam_StateText,
 "AVG_StationsStates".SrvExchRoutingTA_StateText,
 "AVG_StationsStates".SrvExchSmtpTA_StateText,
 "AVG_StationsStates".SrvExchVSAPI_StateText,
 "AVG_StationsStates".SrvSharePoint_StateText
 FROM "AVG_Stations" LEFT JOIN "AVG_StationsStates" ON ("AVG_Stations".AVG_Code="AVG_StationsStates".AVG_StationID) LEFT JOIN "AVG_ScanLogs" ON ("AVG_Stations".AVG_Code="AVG_ScanLogs".AVG_OwnerID AND ( "AVG_ScanLogs".AVG_ConfirmTime IS NULL OR "AVG_ScanLogs".AVG_ConfirmTime = '' )) LEFT JOIN "setup" ON ("AVG_Stations".AVG_Code="setup".AVG_OwnerID AND "AVG_Stations".AVG_StationType="setup".AVG_OwnerType)
 WHERE ( "AVG_Stations".AVG_StationType = 7 AND ("AVG_ScanLogs".AVG_OwnerType IS NULL OR "AVG_ScanLogs".AVG_OwnerType = 7) )
 GROUP BY "AVG_Stations".AVG_Code,"AVG_Stations".AVG_StationName,"AVG_Stations".AVG_StationDomain,"AVG_Stations".AVG_StationDesc,"AVG_Stations".AVG_LastCall,"AVG_Stations".AVG_IPAddress,"AVG_Stations".AVG_MACAddress,"AVG_Stations".AVG_WinVersion,"AVG_Stations".AVG_LastSynchro,"AVG_StationsStates".LastScanTime,"AVG_StationsStates".NeedRestart,"AVG_StationsStates".AVG_AvgVersion,"AVG_StationsStates".Antivirus_Version,"AVG_StationsStates".Antivirus_ReleaseDate,"AVG_StationsStates".AntiVirusGroup_StateText,"AVG_StationsStates".AM_StateText,"AVG_StationsStates".AdminClient_StateText,"AVG_StationsStates".AR_StateText,"AVG_StationsStates".License_StateText,"AVG_StationsStates".UpdateMgr_StateText,"AVG_StationsStates".SrvExchAntiSpam_StateText,"AVG_StationsStates".SrvExchRoutingTA_StateText,"AVG_StationsStates".SrvExchSmtpTA_StateText,"AVG_StationsStates".SrvExchVSAPI_StateText,"AVG_StationsStates".SrvSharePoint_StateText,"AVG_StationsStates".AR_State,"AVG_Stations".AVG_Logon,"AVG_Stations".AVG_Logoff,("setup".setup__features__srv_efb5f7107),("setup".setup__features__srv_e9e808cba),("setup".setup__features__srv_e26f252af),("setup".setup__features__srv_a91b2cc14),("setup".setup__features__srv_a5bfffddd),"AVG_Stations".AVG_LicenceNumber,"AVG_StationsStates".AM_StateText,"AVG_StationsStates".AntiSpy_StateText,"AVG_StationsStates".Antivirus_StateText,"AVG_StationsStates".AdminClient_StateText,"AVG_StationsStates".AR_StateText,"AVG_StationsStates".License_StateText,"AVG_StationsStates".RS_StateText,"AVG_StationsStates".UpdateMgr_StateText,"AVG_StationsStates".SrvExchAntiSpam_StateText,"AVG_StationsStates".SrvExchRoutingTA_StateText,"AVG_StationsStates".SrvExchSmtpTA_StateText,"AVG_StationsStates".SrvExchVSAPI_StateText,"AVG_StationsStates".SrvSharePoint_StateText;

<SQLBlock>
CREATE PROCEDURE view_exchange_servers_PROC ( 
	bflt1 INTEGER,
	bflt_desc INTEGER,
	bflt_dmn INTEGER,
	bflt_ip INTEGER,
	bflt_os INTEGER,
	bflt_infected INTEGER,
	bflt_stool INTEGER,
	bflt_rst INTEGER,
	flt1_AVG_STATIONNAME VARCHAR(64),
	flt1_AVG_STATIONNAME_L VARCHAR(512),
	flt_desc_AVG_STATIONDESC VARCHAR(64),
	flt_desc_AVG_STATIONDESC_L VARCHAR(512),
	flt_dmn_AVG_STATION_DOMAIN VARCHAR(64),
	flt_dmn_AVG_STATION_DOMAIN_L VARCHAR(512),
	flt_ip_AVG_STATION_IP VARCHAR(64),
	flt_ip_AVG_STATION_IP_L VARCHAR(512),
	flt_os_AVG_STATION_OS VARCHAR(64),
	flt_os_AVG_STATION_OS_L VARCHAR(512) )
	RETURNS (
	VImg_Online INTEGER,
	VImg_Infected INTEGER,
	VImg_Restart INTEGER,
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_StationDomain VARCHAR(64),
	AVG_StationDesc VARCHAR(250),
	AVG_LastCall VARCHAR(20),
	AVG_UnhealedInfections INTEGER,
	AVG_UnhealedPups INTEGER,
	AVG_UnhealedRootkits INTEGER,
	AVG_TotalInfections INTEGER,
	AVG_TotalPups INTEGER,
	AVG_TotalRootkits INTEGER,
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_WinVersion VARCHAR(255),
	AVG_LastSynchro VARCHAR(20),
	LastScanTime VARCHAR(20),
	NeedRestart INTEGER,
	AVG_AvgVersion VARCHAR(50),
	Antivirus_Version VARCHAR(50),
	Antivirus_ReleaseDate VARCHAR(20),
	AntiVirusGroup_StateText VARCHAR(128),
	AM_StateText VARCHAR(128),
	AdminClient_StateText VARCHAR(128),
	AR_StateText VARCHAR(128),
	License_StateText VARCHAR(128),
	UpdateMgr_StateText VARCHAR(128),
	SrvExchAntiSpam_StateText VARCHAR(128),
	SrvExchRoutingTA_StateText VARCHAR(128),
	SrvExchSmtpTA_StateText VARCHAR(128),
	SrvExchVSAPI_StateText VARCHAR(128),
	SrvSharePoint_StateText VARCHAR(128),
	AR_State INTEGER,
	AVG_Logon VARCHAR(20),
	AVG_Logoff VARCHAR(20),
	setup_EXCH_SMTPTA INTEGER,
	setup_EXCH_ROUTING INTEGER,
	setup_EXCH_VSAPI INTEGER,
	setup_EXCH_ANTISPAM INTEGER,
	setup_SHAREPOINT INTEGER,
	AVG_LicenceNumber VARCHAR(64),
	AM_StateTextObs VARCHAR(128),
	AntiSpy_StateTextObs VARCHAR(128),
	Antivirus_StateTextObs VARCHAR(128),
	AdminClient_StateTextObs VARCHAR(128),
	AR_StateTextObs VARCHAR(128),
	License_StateTextObs VARCHAR(128),
	RS_StateTextObs VARCHAR(128),
	UpdateMgr_StateTextObs VARCHAR(128),
	SrvExchAntiSpam_StateTextObs VARCHAR(128),
	SrvExchRoutingTA_StateTextObs VARCHAR(128),
	SrvExchSmtpTA_StateTextObs VARCHAR(128),
	SrvExchVSAPI_StateTextObs VARCHAR(128),
	SrvSharePoint_StateTextObs VARCHAR(128))
AS BEGIN
	FOR SELECT 
	VImg_Online,
	VImg_Infected,
	VImg_Restart,
	AVG_Code,
	AVG_StationName,
	AVG_StationDomain,
	AVG_StationDesc,
	AVG_LastCall,
	AVG_UnhealedInfections,
	AVG_UnhealedPups,
	AVG_UnhealedRootkits,
	AVG_TotalInfections,
	AVG_TotalPups,
	AVG_TotalRootkits,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_WinVersion,
	AVG_LastSynchro,
	LastScanTime,
	NeedRestart,
	AVG_AvgVersion,
	Antivirus_Version,
	Antivirus_ReleaseDate,
	AntiVirusGroup_StateText,
	AM_StateText,
	AdminClient_StateText,
	AR_StateText,
	License_StateText,
	UpdateMgr_StateText,
	SrvExchAntiSpam_StateText,
	SrvExchRoutingTA_StateText,
	SrvExchSmtpTA_StateText,
	SrvExchVSAPI_StateText,
	SrvSharePoint_StateText,
	AR_State,
	AVG_Logon,
	AVG_Logoff,
	setup_EXCH_SMTPTA,
	setup_EXCH_ROUTING,
	setup_EXCH_VSAPI,
	setup_EXCH_ANTISPAM,
	setup_SHAREPOINT,
	AVG_LicenceNumber,
	AM_StateTextObs,
	AntiSpy_StateTextObs,
	Antivirus_StateTextObs,
	AdminClient_StateTextObs,
	AR_StateTextObs,
	License_StateTextObs,
	RS_StateTextObs,
	UpdateMgr_StateTextObs,
	SrvExchAntiSpam_StateTextObs,
	SrvExchRoutingTA_StateTextObs,
	SrvExchSmtpTA_StateTextObs,
	SrvExchVSAPI_StateTextObs,
	SrvSharePoint_StateTextObs
	FROM "view_exchange_servers"
	WHERE
	((:bflt1=0)OR((:bflt1=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt1_AVG_STATIONNAME)))) AND
	((:bflt_desc=0)OR((:bflt_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_desc_AVG_STATIONDESC)))) AND
	((:bflt_dmn=0)OR((:bflt_dmn=1)AND(UPPER(AVG_StationDomain) LIKE UPPER(:flt_dmn_AVG_STATION_DOMAIN)))) AND
	((:bflt_infected=0)OR((:bflt_infected=1)AND((AVG_UnhealedInfections > 0) OR (AVG_UnhealedPups > 0) OR (AVG_UnhealedRootkits > 0)))) AND
	((:bflt_ip=0)OR((:bflt_ip=1)AND(UPPER(AVG_IPAddress) LIKE UPPER(:flt_ip_AVG_STATION_IP)))) AND
	((:bflt_os=0)OR((:bflt_os=1)AND(UPPER(AVG_WinVersion) LIKE UPPER(:flt_os_AVG_STATION_OS)))) AND
	((:bflt_rst=0)OR((:bflt_rst=1)AND(NeedRestart = '1'))) AND
	((:bflt_stool=0)OR((:bflt_stool=1)AND(AVG_LastCall = '')))
	INTO
	:VImg_Online,
	:VImg_Infected,
	:VImg_Restart,
	:AVG_Code,
	:AVG_StationName,
	:AVG_StationDomain,
	:AVG_StationDesc,
	:AVG_LastCall,
	:AVG_UnhealedInfections,
	:AVG_UnhealedPups,
	:AVG_UnhealedRootkits,
	:AVG_TotalInfections,
	:AVG_TotalPups,
	:AVG_TotalRootkits,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_WinVersion,
	:AVG_LastSynchro,
	:LastScanTime,
	:NeedRestart,
	:AVG_AvgVersion,
	:Antivirus_Version,
	:Antivirus_ReleaseDate,
	:AntiVirusGroup_StateText,
	:AM_StateText,
	:AdminClient_StateText,
	:AR_StateText,
	:License_StateText,
	:UpdateMgr_StateText,
	:SrvExchAntiSpam_StateText,
	:SrvExchRoutingTA_StateText,
	:SrvExchSmtpTA_StateText,
	:SrvExchVSAPI_StateText,
	:SrvSharePoint_StateText,
	:AR_State,
	:AVG_Logon,
	:AVG_Logoff,
	:setup_EXCH_SMTPTA,
	:setup_EXCH_ROUTING,
	:setup_EXCH_VSAPI,
	:setup_EXCH_ANTISPAM,
	:setup_SHAREPOINT,
	:AVG_LicenceNumber,
	:AM_StateTextObs,
	:AntiSpy_StateTextObs,
	:Antivirus_StateTextObs,
	:AdminClient_StateTextObs,
	:AR_StateTextObs,
	:License_StateTextObs,
	:RS_StateTextObs,
	:UpdateMgr_StateTextObs,
	:SrvExchAntiSpam_StateTextObs,
	:SrvExchRoutingTA_StateTextObs,
	:SrvExchSmtpTA_StateTextObs,
	:SrvExchVSAPI_StateTextObs,
	:SrvSharePoint_StateTextObs
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_exchange_servers_C_PROC ( 
	bflt1 INTEGER,
	bflt_desc INTEGER,
	bflt_dmn INTEGER,
	bflt_ip INTEGER,
	bflt_os INTEGER,
	bflt_infected INTEGER,
	bflt_stool INTEGER,
	bflt_rst INTEGER,
	flt1_AVG_STATIONNAME VARCHAR(64),
	flt1_AVG_STATIONNAME_L VARCHAR(512),
	flt_desc_AVG_STATIONDESC VARCHAR(64),
	flt_desc_AVG_STATIONDESC_L VARCHAR(512),
	flt_dmn_AVG_STATION_DOMAIN VARCHAR(64),
	flt_dmn_AVG_STATION_DOMAIN_L VARCHAR(512),
	flt_ip_AVG_STATION_IP VARCHAR(64),
	flt_ip_AVG_STATION_IP_L VARCHAR(512),
	flt_os_AVG_STATION_OS VARCHAR(64),
	flt_os_AVG_STATION_OS_L VARCHAR(512) )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_exchange_servers"
	WHERE
	((:bflt1=0)OR((:bflt1=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt1_AVG_STATIONNAME)))) AND
	((:bflt_desc=0)OR((:bflt_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_desc_AVG_STATIONDESC)))) AND
	((:bflt_dmn=0)OR((:bflt_dmn=1)AND(UPPER(AVG_StationDomain) LIKE UPPER(:flt_dmn_AVG_STATION_DOMAIN)))) AND
	((:bflt_infected=0)OR((:bflt_infected=1)AND((AVG_UnhealedInfections > 0) OR (AVG_UnhealedPups > 0) OR (AVG_UnhealedRootkits > 0)))) AND
	((:bflt_ip=0)OR((:bflt_ip=1)AND(UPPER(AVG_IPAddress) LIKE UPPER(:flt_ip_AVG_STATION_IP)))) AND
	((:bflt_os=0)OR((:bflt_os=1)AND(UPPER(AVG_WinVersion) LIKE UPPER(:flt_os_AVG_STATION_OS)))) AND
	((:bflt_rst=0)OR((:bflt_rst=1)AND(NeedRestart = '1'))) AND
	((:bflt_stool=0)OR((:bflt_stool=1)AND(AVG_LastCall = '')))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_scan_logs"(
 AVG_Code,
 AVG_GroupID,
 AVG_StationName,
 AVG_GroupName,
 AVG_TestName,
 AVG_ScanEnded,
 AVG_ConfirmTime,
 AVG_FoundInfections,
 AVG_UnhealedInfections,
 AVG_FoundPups,
 AVG_UnhealedPups,
 AVG_FoundRootkits,
 AVG_UnhealedRootkits,
 AVG_StationDesc,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_User,
 AVG_Warnings,
 AVG_UnhealedWarnings,
 AVG_Informations,
 AVG_UnhealedInformations,
 AVG_ScannedObjects,
 AVG_ScannedRootkits,
 AVG_LogID,
 AVG_OwnerID,
 AVG_LogStateText,
 AVG_OwnerType,
 AVG_LogVersion,
 AVG_AvgVersion
) AS SELECT
 "AVG_ScanLogs".AVG_Code,
 "AVG_Stations".AVG_GroupID,
 "AVG_Stations".AVG_StationName,
 "AVG_Groups".AVG_GroupName,
 "AVG_ScanLogs".AVG_TestName,
 "AVG_ScanLogs".AVG_ScanEnded,
 "AVG_ScanLogs".AVG_ConfirmTime,
 "AVG_ScanLogs".AVG_FoundInfections,
 ("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections),
 "AVG_ScanLogs".AVG_FoundPups,
 ("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups),
 "AVG_ScanLogs".AVG_FoundRootkits,
 "AVG_ScanLogs".AVG_FoundRootkits - "AVG_ScanLogs".AVG_HealedRootkits,
 "AVG_Stations".AVG_StationDesc,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_ScanLogs".AVG_User,
 "AVG_ScanLogs".AVG_Warnings,
 ("AVG_ScanLogs".AVG_Warnings - "AVG_ScanLogs".AVG_HealedWarnings),
 "AVG_ScanLogs".AVG_Informations,
 ("AVG_ScanLogs".AVG_Informations - "AVG_ScanLogs".AVG_HealedInformations),
 "AVG_ScanLogs".AVG_ScannedObjects,
 "AVG_ScanLogs".AVG_ScannedRootkits,
 "AVG_ScanLogs".AVG_LogID,
 "AVG_ScanLogs".AVG_OwnerID,
 "AVG_ScanLogs".AVG_LogStateText,
 "AVG_ScanLogs".AVG_OwnerType,
 "AVG_ScanLogs".AVG_LogVersion,
 "AVG_StationsStates".AVG_AvgVersion
 FROM "AVG_ScanLogs" LEFT JOIN "AVG_Stations" ON ("AVG_ScanLogs".AVG_OwnerID="AVG_Stations".AVG_Code) LEFT JOIN "AVG_Groups" ON ("AVG_Stations".AVG_GroupID="AVG_Groups".AVG_Code) LEFT JOIN "AVG_StationsStates" ON ("AVG_Stations".AVG_Code="AVG_StationsStates".AVG_StationID);

<SQLBlock>
CREATE PROCEDURE view_scan_logs_PROC ( 
	bflt_sr_name INTEGER,
	bflt_sr_desc INTEGER,
	bflt_sr_scan INTEGER,
	bflt_sr_user INTEGER,
	bflt_sr_infections INTEGER,
	bflt_sr_notconfirmed INTEGER,
	flt_sr_name_AVG_STATIONNAME VARCHAR(64),
	flt_sr_name_AVG_STATIONNAME_L VARCHAR(512),
	flt_sr_desc_AVG_SRDESC VARCHAR(64),
	flt_sr_desc_AVG_SRDESC_L VARCHAR(512),
	flt_sr_scan_AVG_TESTNAME VARCHAR(64),
	flt_sr_scan_AVG_TESTNAME_L VARCHAR(512),
	flt_sr_user_AVG_USER VARCHAR(64),
	flt_sr_user_AVG_USER_L VARCHAR(512),
	flt_sr_infections_SEVERITY INTEGER,
	flt_sr_infections_ROOTKIT INTEGER )
	RETURNS (
	AVG_Code INTEGER,
	AVG_GroupID INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_GroupName VARCHAR(64),
	AVG_TestName VARCHAR(128),
	AVG_ScanEnded VARCHAR(20),
	AVG_ConfirmTime VARCHAR(20),
	AVG_FoundInfections INTEGER,
	AVG_UnhealedInfections INTEGER,
	AVG_FoundPups INTEGER,
	AVG_UnhealedPups INTEGER,
	AVG_FoundRootkits INTEGER,
	AVG_UnhealedRootkits INTEGER,
	AVG_StationDesc VARCHAR(250),
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_User VARCHAR(64),
	AVG_Warnings INTEGER,
	AVG_UnhealedWarnings INTEGER,
	AVG_Informations INTEGER,
	AVG_UnhealedInformations INTEGER,
	AVG_ScannedObjects INTEGER,
	AVG_ScannedRootkits INTEGER,
	AVG_LogID INTEGER,
	AVG_OwnerID INTEGER,
	AVG_LogStateText VARCHAR(128),
	AVG_OwnerType INTEGER,
	AVG_LogVersion INTEGER,
	AVG_AvgVersion VARCHAR(50))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_GroupID,
	AVG_StationName,
	AVG_GroupName,
	AVG_TestName,
	AVG_ScanEnded,
	AVG_ConfirmTime,
	AVG_FoundInfections,
	AVG_UnhealedInfections,
	AVG_FoundPups,
	AVG_UnhealedPups,
	AVG_FoundRootkits,
	AVG_UnhealedRootkits,
	AVG_StationDesc,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_User,
	AVG_Warnings,
	AVG_UnhealedWarnings,
	AVG_Informations,
	AVG_UnhealedInformations,
	AVG_ScannedObjects,
	AVG_ScannedRootkits,
	AVG_LogID,
	AVG_OwnerID,
	AVG_LogStateText,
	AVG_OwnerType,
	AVG_LogVersion,
	AVG_AvgVersion
	FROM "view_scan_logs"
	WHERE
	((:bflt_sr_desc=0)OR((:bflt_sr_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_sr_desc_AVG_SRDESC)))) AND
	((:bflt_sr_infections=0)OR((:bflt_sr_infections=1)AND(:flt_sr_infections_SEVERITY=0 OR (:flt_sr_infections_SEVERITY<=1 AND AVG_Informations>0) OR (:flt_sr_infections_SEVERITY<=2 AND AVG_Warnings>0) OR (:flt_sr_infections_SEVERITY<=2 AND AVG_FoundRootkits>0) OR (:flt_sr_infections_SEVERITY<=3 AND AVG_FoundPups>0) OR (:flt_sr_infections_SEVERITY<=4 AND AVG_FoundInfections>0) OR (:flt_sr_infections_ROOTKIT=1 AND AVG_FoundRootkits > 0)))) AND
	((:bflt_sr_name=0)OR((:bflt_sr_name=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt_sr_name_AVG_STATIONNAME)))) AND
	((:bflt_sr_notconfirmed=0)OR((:bflt_sr_notconfirmed=1)AND((AVG_ConfirmTime IS NULL) OR (AVG_ConfirmTime = '')))) AND
	((:bflt_sr_scan=0)OR((:bflt_sr_scan=1)AND(UPPER(AVG_TestName) LIKE UPPER(:flt_sr_scan_AVG_TESTNAME) OR (((:flt_sr_scan_AVG_TESTNAME_L <> '') OR (:flt_sr_scan_AVG_TESTNAME_L IS NOT NULL)) AND (( ',' || UPPER(:flt_sr_scan_AVG_TESTNAME_L) || ',' ) LIKE ( '%,' || UPPER(AVG_TestName) || ',%' )))))) AND
	((:bflt_sr_user=0)OR((:bflt_sr_user=1)AND(UPPER(AVG_User) LIKE UPPER(:flt_sr_user_AVG_USER))))
	INTO
	:AVG_Code,
	:AVG_GroupID,
	:AVG_StationName,
	:AVG_GroupName,
	:AVG_TestName,
	:AVG_ScanEnded,
	:AVG_ConfirmTime,
	:AVG_FoundInfections,
	:AVG_UnhealedInfections,
	:AVG_FoundPups,
	:AVG_UnhealedPups,
	:AVG_FoundRootkits,
	:AVG_UnhealedRootkits,
	:AVG_StationDesc,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_User,
	:AVG_Warnings,
	:AVG_UnhealedWarnings,
	:AVG_Informations,
	:AVG_UnhealedInformations,
	:AVG_ScannedObjects,
	:AVG_ScannedRootkits,
	:AVG_LogID,
	:AVG_OwnerID,
	:AVG_LogStateText,
	:AVG_OwnerType,
	:AVG_LogVersion,
	:AVG_AvgVersion
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_scan_logs_C_PROC ( 
	bflt_sr_name INTEGER,
	bflt_sr_desc INTEGER,
	bflt_sr_scan INTEGER,
	bflt_sr_user INTEGER,
	bflt_sr_infections INTEGER,
	bflt_sr_notconfirmed INTEGER,
	flt_sr_name_AVG_STATIONNAME VARCHAR(64),
	flt_sr_name_AVG_STATIONNAME_L VARCHAR(512),
	flt_sr_desc_AVG_SRDESC VARCHAR(64),
	flt_sr_desc_AVG_SRDESC_L VARCHAR(512),
	flt_sr_scan_AVG_TESTNAME VARCHAR(64),
	flt_sr_scan_AVG_TESTNAME_L VARCHAR(512),
	flt_sr_user_AVG_USER VARCHAR(64),
	flt_sr_user_AVG_USER_L VARCHAR(512),
	flt_sr_infections_SEVERITY INTEGER,
	flt_sr_infections_ROOTKIT INTEGER )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_scan_logs"
	WHERE
	((:bflt_sr_desc=0)OR((:bflt_sr_desc=1)AND(UPPER(AVG_StationDesc) LIKE UPPER(:flt_sr_desc_AVG_SRDESC)))) AND
	((:bflt_sr_infections=0)OR((:bflt_sr_infections=1)AND(:flt_sr_infections_SEVERITY=0 OR (:flt_sr_infections_SEVERITY<=1 AND AVG_Informations>0) OR (:flt_sr_infections_SEVERITY<=2 AND AVG_Warnings>0) OR (:flt_sr_infections_SEVERITY<=2 AND AVG_FoundRootkits>0) OR (:flt_sr_infections_SEVERITY<=3 AND AVG_FoundPups>0) OR (:flt_sr_infections_SEVERITY<=4 AND AVG_FoundInfections>0) OR (:flt_sr_infections_ROOTKIT=1 AND AVG_FoundRootkits > 0)))) AND
	((:bflt_sr_name=0)OR((:bflt_sr_name=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt_sr_name_AVG_STATIONNAME)))) AND
	((:bflt_sr_notconfirmed=0)OR((:bflt_sr_notconfirmed=1)AND((AVG_ConfirmTime IS NULL) OR (AVG_ConfirmTime = '')))) AND
	((:bflt_sr_scan=0)OR((:bflt_sr_scan=1)AND(UPPER(AVG_TestName) LIKE UPPER(:flt_sr_scan_AVG_TESTNAME) OR (((:flt_sr_scan_AVG_TESTNAME_L <> '') OR (:flt_sr_scan_AVG_TESTNAME_L IS NOT NULL)) AND (( ',' || UPPER(:flt_sr_scan_AVG_TESTNAME_L) || ',' ) LIKE ( '%,' || UPPER(AVG_TestName) || ',%' )))))) AND
	((:bflt_sr_user=0)OR((:bflt_sr_user=1)AND(UPPER(AVG_User) LIKE UPPER(:flt_sr_user_AVG_USER))))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_am_events"(
 AVG_StationName,
 AMSeverity,
 AMType,
 AMDate,
 AVG_GroupID,
 AMUserName,
 AMAttributes,
 AVG_Code,
 AMConfirmed
) AS SELECT
 "AVG_Stations".AVG_StationName,
 "AVG_AMEvents".AMSeverity,
 "AVG_AMEvents".AMType,
 "AVG_AMEvents".AMDate,
 "AVG_Stations".AVG_GroupID,
 "AVG_AMEvents".AMUserName,
 "AVG_AMEvents".AMAttributes,
 "AVG_AMEvents".AVG_Code,
 "AVG_AMEvents".AMConfirmed
 FROM "AVG_AMEvents" LEFT JOIN "AVG_Stations" ON ("AVG_AMEvents".AVG_OwnerID="AVG_Stations".AVG_Code);

<SQLBlock>
CREATE PROCEDURE view_am_events_PROC ( 
	bflt_am_sev INTEGER,
	bflt_am_type INTEGER,
	bflt_am_station INTEGER,
	bflt_am_user INTEGER,
	bflt_am_date INTEGER,
	flt_am_sev_AM_SEV INTEGER,
	flt_am_type_AM_TYPE2 VARCHAR(64),
	flt_am_type_AM_TYPE3 VARCHAR(64),
	flt_am_type_AM_TYPE4 VARCHAR(64),
	flt_am_type_AM_TYPE5 VARCHAR(64),
	flt_am_type_AM_TYPE6 VARCHAR(64),
	flt_am_type_AM_TYPE7 VARCHAR(64),
	flt_am_type_AM_TYPE8 VARCHAR(64),
	flt_am_type_AM_TYPE10 VARCHAR(64),
	flt_am_type_AM_TYPE11 VARCHAR(64),
	flt_am_type_AM_TYPE12 VARCHAR(64),
	flt_am_type_AM_TYPE13 VARCHAR(64),
	flt_am_type_AM_TYPE14 VARCHAR(64),
	flt_am_type_AM_TYPE15 VARCHAR(64),
	flt_am_type_AM_TYPE16 VARCHAR(64),
	flt_am_type_AM_TYPE17 VARCHAR(64),
	flt_am_type_AM_TYPE18 VARCHAR(64),
	flt_am_station_AM_SNAME VARCHAR(64),
	flt_am_station_AM_SNAME_L VARCHAR(512),
	flt_am_user_AM_USER VARCHAR(64),
	flt_am_user_AM_USER_L VARCHAR(512),
	flt_am_date_AM_FROM VARCHAR(64),
	flt_am_date_AM_FROM_L VARCHAR(512),
	flt_am_date_AM_TO VARCHAR(64),
	flt_am_date_AM_TO_L VARCHAR(512) )
	RETURNS (
	AVG_StationName VARCHAR(64),
	AMSeverity INTEGER,
	AMType VARCHAR(64),
	AMDate VARCHAR(20),
	AVG_GroupID INTEGER,
	AMUserName VARCHAR(64),
	AMAttributes VARCHAR(4092) CHARACTER SET NONE,
	AVG_Code INTEGER,
	AMConfirmed INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_StationName,
	AMSeverity,
	AMType,
	AMDate,
	AVG_GroupID,
	AMUserName,
	AMAttributes,
	AVG_Code,
	AMConfirmed
	FROM "view_am_events"
	WHERE
	((:bflt_am_date=0)OR((:bflt_am_date=1)AND(AMDate >= :flt_am_date_AM_FROM AND AMDate <= :flt_am_date_AM_TO))) AND
	((:bflt_am_sev=0)OR((:bflt_am_sev=1)AND(AMSeverity = :flt_am_sev_AM_SEV))) AND
	((:bflt_am_station=0)OR((:bflt_am_station=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt_am_station_AM_SNAME)))) AND
	((:bflt_am_type=0)OR((:bflt_am_type=1)AND(( AMType IN ( :flt_am_type_AM_TYPE2,:flt_am_type_AM_TYPE3,:flt_am_type_AM_TYPE4,:flt_am_type_AM_TYPE5,:flt_am_type_AM_TYPE6,:flt_am_type_AM_TYPE7,:flt_am_type_AM_TYPE8,:flt_am_type_AM_TYPE10,:flt_am_type_AM_TYPE11,:flt_am_type_AM_TYPE12,:flt_am_type_AM_TYPE13,:flt_am_type_AM_TYPE14,:flt_am_type_AM_TYPE15,:flt_am_type_AM_TYPE16,:flt_am_type_AM_TYPE17,:flt_am_type_AM_TYPE18 ) )
		))) AND
	((:bflt_am_user=0)OR((:bflt_am_user=1)AND(UPPER(AMUserName) LIKE UPPER(:flt_am_user_AM_USER))))
	INTO
	:AVG_StationName,
	:AMSeverity,
	:AMType,
	:AMDate,
	:AVG_GroupID,
	:AMUserName,
	:AMAttributes,
	:AVG_Code,
	:AMConfirmed
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_am_events_C_PROC ( 
	bflt_am_sev INTEGER,
	bflt_am_type INTEGER,
	bflt_am_station INTEGER,
	bflt_am_user INTEGER,
	bflt_am_date INTEGER,
	flt_am_sev_AM_SEV INTEGER,
	flt_am_type_AM_TYPE2 VARCHAR(64),
	flt_am_type_AM_TYPE3 VARCHAR(64),
	flt_am_type_AM_TYPE4 VARCHAR(64),
	flt_am_type_AM_TYPE5 VARCHAR(64),
	flt_am_type_AM_TYPE6 VARCHAR(64),
	flt_am_type_AM_TYPE7 VARCHAR(64),
	flt_am_type_AM_TYPE8 VARCHAR(64),
	flt_am_type_AM_TYPE10 VARCHAR(64),
	flt_am_type_AM_TYPE11 VARCHAR(64),
	flt_am_type_AM_TYPE12 VARCHAR(64),
	flt_am_type_AM_TYPE13 VARCHAR(64),
	flt_am_type_AM_TYPE14 VARCHAR(64),
	flt_am_type_AM_TYPE15 VARCHAR(64),
	flt_am_type_AM_TYPE16 VARCHAR(64),
	flt_am_type_AM_TYPE17 VARCHAR(64),
	flt_am_type_AM_TYPE18 VARCHAR(64),
	flt_am_station_AM_SNAME VARCHAR(64),
	flt_am_station_AM_SNAME_L VARCHAR(512),
	flt_am_user_AM_USER VARCHAR(64),
	flt_am_user_AM_USER_L VARCHAR(512),
	flt_am_date_AM_FROM VARCHAR(64),
	flt_am_date_AM_FROM_L VARCHAR(512),
	flt_am_date_AM_TO VARCHAR(64),
	flt_am_date_AM_TO_L VARCHAR(512) )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_am_events"
	WHERE
	((:bflt_am_date=0)OR((:bflt_am_date=1)AND(AMDate >= :flt_am_date_AM_FROM AND AMDate <= :flt_am_date_AM_TO))) AND
	((:bflt_am_sev=0)OR((:bflt_am_sev=1)AND(AMSeverity = :flt_am_sev_AM_SEV))) AND
	((:bflt_am_station=0)OR((:bflt_am_station=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt_am_station_AM_SNAME)))) AND
	((:bflt_am_type=0)OR((:bflt_am_type=1)AND(( AMType IN ( :flt_am_type_AM_TYPE2,:flt_am_type_AM_TYPE3,:flt_am_type_AM_TYPE4,:flt_am_type_AM_TYPE5,:flt_am_type_AM_TYPE6,:flt_am_type_AM_TYPE7,:flt_am_type_AM_TYPE8,:flt_am_type_AM_TYPE10,:flt_am_type_AM_TYPE11,:flt_am_type_AM_TYPE12,:flt_am_type_AM_TYPE13,:flt_am_type_AM_TYPE14,:flt_am_type_AM_TYPE15,:flt_am_type_AM_TYPE16,:flt_am_type_AM_TYPE17,:flt_am_type_AM_TYPE18 ) )
		))) AND
	((:bflt_am_user=0)OR((:bflt_am_user=1)AND(UPPER(AMUserName) LIKE UPPER(:flt_am_user_AM_USER))))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_event_mgr"(
 AVG_Code,
 NotifyActive,
 Name,
 Description,
 Grouped,
 BarrierSize
) AS SELECT
 "AVG_EMTerm".AVG_Code,
 "AVG_EMTerm".NotifyActive,
 "AVG_EMTerm".Name,
 "AVG_EMTerm".Description,
 "AVG_EMTerm".Grouped,
 "AVG_EMTerm".BarrierSize
 FROM "AVG_EMTerm";

<SQLBlock>
CREATE PROCEDURE view_event_mgr_PROC
	RETURNS (
	AVG_Code INTEGER,
	NotifyActive INTEGER,
	Name VARCHAR(256),
	Description VARCHAR(8192),
	Grouped INTEGER,
	BarrierSize INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_Code,
	NotifyActive,
	Name,
	Description,
	Grouped,
	BarrierSize
	FROM "view_event_mgr"
	INTO
	:AVG_Code,
	:NotifyActive,
	:Name,
	:Description,
	:Grouped,
	:BarrierSize
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_event_mgr_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_event_mgr"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>


CREATE VIEW "view_gr_template"(
 AVG_GUID,
 Name,
 Description,
 AVG_Code
) AS SELECT
 "AVG_ADMRepType".AVG_GUID,
 "AVG_ADMRepType".Name,
 "AVG_ADMRepType".Description,
 "AVG_ADMRepType".AVG_Code
 FROM "AVG_ADMRepType"
 WHERE ( "AVG_ADMRepType".AVG_GUID NOT LIKE ('4769D6BA-5CAA-4759-BD12-8E39571D9B63'));

<SQLBlock>
CREATE PROCEDURE view_gr_template_PROC
	RETURNS (
	AVG_GUID VARCHAR(36),
	Name VARCHAR(250),
	Description VARCHAR(8192),
	AVG_Code INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_GUID,
	Name,
	Description,
	AVG_Code
	FROM "view_gr_template"
	INTO
	:AVG_GUID,
	:Name,
	:Description,
	:AVG_Code
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_gr_template_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_gr_template"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_gr_schedule"(
 AVG_GUID,
 Name,
 Description,
 NextGenerate,
 Activated,
 AVG_Code
) AS SELECT
 "AVG_ADMRepShedule".AVG_GUID,
 "AVG_ADMRepShedule".Name,
 "AVG_ADMRepShedule".Description,
 "AVG_ADMRepShedule".NextGenerate,
 ("AVG_ADMRepShedule".Deleted*(-1)+1),
 "AVG_ADMRepShedule".AVG_Code
 FROM "AVG_ADMRepShedule";

<SQLBlock>
CREATE PROCEDURE view_gr_schedule_PROC
	RETURNS (
	AVG_GUID VARCHAR(36),
	Name VARCHAR(255),
	Description VARCHAR(8192),
	NextGenerate VARCHAR(20),
	Activated INTEGER,
	AVG_Code INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_GUID,
	Name,
	Description,
	NextGenerate,
	Activated,
	AVG_Code
	FROM "view_gr_schedule"
	INTO
	:AVG_GUID,
	:Name,
	:Description,
	:NextGenerate,
	:Activated,
	:AVG_Code
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_gr_schedule_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_gr_schedule"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_gr_generated"(
 AVG_GUID,
 SheduleId,
 TypeId,
 SheduleName,
 TypeName,
 GenerateTime,
 AVG_Code
) AS SELECT
 "AVG_ADMRepReport".AVG_GUID,
 "AVG_ADMRepReport".SheduleId,
 "AVG_ADMRepReport".TypeId,
 "AVG_ADMRepShedule".Name,
 "AVG_ADMRepType".Name,
 "AVG_ADMRepReport".GenerateTime,
 "AVG_ADMRepReport".AVG_Code
 FROM "AVG_ADMRepReport" LEFT JOIN "AVG_ADMRepType" ON ("AVG_ADMRepReport".TypeId="AVG_ADMRepType".AVG_GUID) LEFT JOIN "AVG_ADMRepShedule" ON ("AVG_ADMRepReport".SheduleId="AVG_ADMRepShedule".AVG_GUID);

<SQLBlock>
CREATE PROCEDURE view_gr_generated_PROC ( 
	btype_flt INTEGER,
	bsched_flt INTEGER,
	bflt_date INTEGER,
	type_flt_TYPENAME VARCHAR(64),
	type_flt_TYPENAME_L VARCHAR(512),
	sched_flt_SCHEDNAME VARCHAR(64),
	sched_flt_SCHEDNAME_L VARCHAR(512),
	flt_date_GEN_FROM VARCHAR(64),
	flt_date_GEN_FROM_L VARCHAR(512),
	flt_date_GEN_TO VARCHAR(64),
	flt_date_GEN_TO_L VARCHAR(512) )
	RETURNS (
	AVG_GUID VARCHAR(36),
	SheduleId VARCHAR(36),
	TypeId VARCHAR(36),
	SheduleName VARCHAR(255),
	TypeName VARCHAR(250),
	GenerateTime VARCHAR(20),
	AVG_Code INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_GUID,
	SheduleId,
	TypeId,
	SheduleName,
	TypeName,
	GenerateTime,
	AVG_Code
	FROM "view_gr_generated"
	WHERE
	((:bflt_date=0)OR((:bflt_date=1)AND(GenerateTime >= :flt_date_GEN_FROM AND GenerateTime <= :flt_date_GEN_TO))) AND
	((:bsched_flt=0)OR((:bsched_flt=1)AND(UPPER(SheduleName) LIKE UPPER(:sched_flt_SCHEDNAME)))) AND
	((:btype_flt=0)OR((:btype_flt=1)AND(UPPER(TypeName) LIKE UPPER(:type_flt_TYPENAME) OR (((:type_flt_TYPENAME_L <> '') OR (:type_flt_TYPENAME_L IS NOT NULL)) AND (( ',' || UPPER(:type_flt_TYPENAME_L) || ',' ) LIKE ( '%,' || UPPER(TypeName) || ',%' ))))))
	INTO
	:AVG_GUID,
	:SheduleId,
	:TypeId,
	:SheduleName,
	:TypeName,
	:GenerateTime,
	:AVG_Code
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_gr_generated_C_PROC ( 
	btype_flt INTEGER,
	bsched_flt INTEGER,
	bflt_date INTEGER,
	type_flt_TYPENAME VARCHAR(64),
	type_flt_TYPENAME_L VARCHAR(512),
	sched_flt_SCHEDNAME VARCHAR(64),
	sched_flt_SCHEDNAME_L VARCHAR(512),
	flt_date_GEN_FROM VARCHAR(64),
	flt_date_GEN_FROM_L VARCHAR(512),
	flt_date_GEN_TO VARCHAR(64),
	flt_date_GEN_TO_L VARCHAR(512) )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_gr_generated"
	WHERE
	((:bflt_date=0)OR((:bflt_date=1)AND(GenerateTime >= :flt_date_GEN_FROM AND GenerateTime <= :flt_date_GEN_TO))) AND
	((:bsched_flt=0)OR((:bsched_flt=1)AND(UPPER(SheduleName) LIKE UPPER(:sched_flt_SCHEDNAME)))) AND
	((:btype_flt=0)OR((:btype_flt=1)AND(UPPER(TypeName) LIKE UPPER(:type_flt_TYPENAME) OR (((:type_flt_TYPENAME_L <> '') OR (:type_flt_TYPENAME_L IS NOT NULL)) AND (( ',' || UPPER(:type_flt_TYPENAME_L) || ',' ) LIKE ( '%,' || UPPER(TypeName) || ',%' ))))))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_lic_win"(
 krnl__license__view__number,
 ColLicWithoutCrc2,
 ColLicUsedCount,
 ColLicForCount,
 ColLicExpirate,
 ColLicInfo,
 AVG_SortCode
) AS SELECT
 "krnl".krnl__license__view__number,
 '',
 COUNT("krnl".AVG_Code),
 0,
 '2007-01-01 00:00:00',
 '',
 0
 FROM "krnl" JOIN "AVG_Stations" ON ("krnl".AVG_OwnerID="AVG_Stations".AVG_Code)
 WHERE ( "krnl".AVG_OwnerType = 0 ) AND ( ( "krnl".krnl__license__view__number IS NOT NULL ) AND ( "krnl".krnl__license__view__number <> '' ) ) GROUP BY "krnl".krnl__license__view__number;

<SQLBlock>
CREATE PROCEDURE view_lic_win_PROC
	RETURNS (
	krnl__license__view__number VARCHAR(128),
	ColLicWithoutCrc2 VARCHAR(48),
	ColLicUsedCount INTEGER,
	ColLicForCount VARCHAR(48),
	ColLicExpirate VARCHAR(20),
	ColLicInfo VARCHAR(80),
	AVG_SortCode INTEGER)
AS BEGIN
	FOR SELECT 
	krnl__license__view__number,
	ColLicWithoutCrc2,
	ColLicUsedCount,
	ColLicForCount,
	ColLicExpirate,
	ColLicInfo,
	AVG_SortCode
	FROM "view_lic_win"
	INTO
	:krnl__license__view__number,
	:ColLicWithoutCrc2,
	:ColLicUsedCount,
	:ColLicForCount,
	:ColLicExpirate,
	:ColLicInfo,
	:AVG_SortCode
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_lic_win_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_lic_win"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_lic_win_shared"(
 AVG_Code,
 AVG_OwnerType,
 AVG_ValidityMask,
 krnl__license__view__number,
 NumberDupl,
 AVG_GroupName,
 ColLicOwner,
 ColLicWithoutCrc2,
 ColLicDuplWithoutCrc2,
 AVG_GroupID
) AS SELECT
 "krnl".AVG_Code,
 "krnl".AVG_OwnerType,
 "krnl".AVG_ValidityMask,
 "krnl".krnl__license__view__number,
 "krnl".krnl__license__view__n3252a434,
 "AVG_Groups".AVG_GroupName,
 "AVG_Groups".AVG_GroupName,
 '',
 '',
 "AVG_Groups".AVG_Code
 FROM "AVG_Groups" RIGHT JOIN "krnl" ON ("AVG_Groups".AVG_Code="krnl".AVG_OwnerID)
 WHERE "krnl".AVG_OwnerType IN (2,1);

<SQLBlock>
CREATE PROCEDURE view_lic_win_shared_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_OwnerType INTEGER,
	AVG_ValidityMask VARCHAR(255),
	krnl__license__view__number VARCHAR(128),
	NumberDupl VARCHAR(128),
	AVG_GroupName VARCHAR(64),
	ColLicOwner VARCHAR(255),
	ColLicWithoutCrc2 VARCHAR(48),
	ColLicDuplWithoutCrc2 VARCHAR(48),
	AVG_GroupID INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_OwnerType,
	AVG_ValidityMask,
	krnl__license__view__number,
	NumberDupl,
	AVG_GroupName,
	ColLicOwner,
	ColLicWithoutCrc2,
	ColLicDuplWithoutCrc2,
	AVG_GroupID
	FROM "view_lic_win_shared"
	INTO
	:AVG_Code,
	:AVG_OwnerType,
	:AVG_ValidityMask,
	:krnl__license__view__number,
	:NumberDupl,
	:AVG_GroupName,
	:ColLicOwner,
	:ColLicWithoutCrc2,
	:ColLicDuplWithoutCrc2,
	:AVG_GroupID
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_lic_win_shared_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_lic_win_shared"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_lic_win_stations"(
 AVG_Code,
 AVG_OwnerType,
 AVG_OwnerID,
 AVG_ValidityMask,
 AVG_StationName,
 AVG_GroupID,
 AVG_LicenceNumber,
 krnl__license__view__number,
 NumberDupl,
 ColLicWithoutCrc2,
 ColLicDuplWithoutCrc2,
 krnl__version__major
) AS SELECT
 "krnl".AVG_Code,
 "krnl".AVG_OwnerType,
 "krnl".AVG_OwnerID,
 "krnl".AVG_ValidityMask,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_GroupID,
 "AVG_Stations".AVG_LicenceNumber,
 "krnl".krnl__license__view__number,
 "krnl".krnl__license__view__n3252a434,
 '',
 '',
 "krnl".krnl__version__major
 FROM "krnl" JOIN "AVG_Stations" ON ("krnl".AVG_OwnerID="AVG_Stations".AVG_Code)
 WHERE "krnl".AVG_OwnerType = 0;

<SQLBlock>
CREATE PROCEDURE view_lic_win_stations_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_OwnerType INTEGER,
	AVG_OwnerID INTEGER,
	AVG_ValidityMask VARCHAR(255),
	AVG_StationName VARCHAR(64),
	AVG_GroupID INTEGER,
	AVG_LicenceNumber VARCHAR(64),
	krnl__license__view__number VARCHAR(128),
	NumberDupl VARCHAR(128),
	ColLicWithoutCrc2 VARCHAR(48),
	ColLicDuplWithoutCrc2 VARCHAR(48),
	krnl__version__major INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_OwnerType,
	AVG_OwnerID,
	AVG_ValidityMask,
	AVG_StationName,
	AVG_GroupID,
	AVG_LicenceNumber,
	krnl__license__view__number,
	NumberDupl,
	ColLicWithoutCrc2,
	ColLicDuplWithoutCrc2,
	krnl__version__major
	FROM "view_lic_win_stations"
	INTO
	:AVG_Code,
	:AVG_OwnerType,
	:AVG_OwnerID,
	:AVG_ValidityMask,
	:AVG_StationName,
	:AVG_GroupID,
	:AVG_LicenceNumber,
	:krnl__license__view__number,
	:NumberDupl,
	:ColLicWithoutCrc2,
	:ColLicDuplWithoutCrc2,
	:krnl__version__major
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_lic_win_stations_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_lic_win_stations"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_pending_requests"(
 AVG_Code,
 AVG_StationName,
 AVG_MessageCode,
 AVG_TimeOfCreating,
 AVG_ReceiverID,
 AVG_ReceiverType,
 AVG_SenderID,
 AVG_SenderType,
 AVG_Data
) AS SELECT
 "AVG_Messages".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Messages".AVG_MessageCode,
 "AVG_Messages".AVG_TimeOfCreating,
 "AVG_Messages".AVG_ReceiverID,
 "AVG_Messages".AVG_ReceiverType,
 "AVG_Messages".AVG_SenderID,
 "AVG_Messages".AVG_SenderType,
 "AVG_Messages".AVG_Data
 FROM "AVG_Messages" LEFT JOIN "AVG_Stations" ON ("AVG_Messages".AVG_ReceiverID="AVG_Stations".AVG_Code AND "AVG_Messages".AVG_ReceiverType="AVG_Stations".AVG_StationType)
 WHERE ( "AVG_Messages".AVG_MessageType = 1 AND "AVG_Messages".AVG_TimeOfReading = '' ) AND ( ( "AVG_Messages".AVG_ReceiverType = 0 ) OR  ( "AVG_Messages".AVG_ReceiverType = 7 ) );

<SQLBlock>
CREATE PROCEDURE view_pending_requests_PROC ( 
	bflt_msgcode INTEGER,
	bflt_station INTEGER,
	bflt_date INTEGER,
	flt_msgcode_MSG_CODE INTEGER,
	flt_station_AVG_STATIONNAME VARCHAR(64),
	flt_station_AVG_STATIONNAME_L VARCHAR(512),
	flt_date_REQ_FROM VARCHAR(64),
	flt_date_REQ_FROM_L VARCHAR(512),
	flt_date_REQ_TO VARCHAR(64),
	flt_date_REQ_TO_L VARCHAR(512) )
	RETURNS (
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_MessageCode INTEGER,
	AVG_TimeOfCreating VARCHAR(20),
	AVG_ReceiverID INTEGER,
	AVG_ReceiverType INTEGER,
	AVG_SenderID INTEGER,
	AVG_SenderType INTEGER,
	AVG_Data VARCHAR(8192))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_StationName,
	AVG_MessageCode,
	AVG_TimeOfCreating,
	AVG_ReceiverID,
	AVG_ReceiverType,
	AVG_SenderID,
	AVG_SenderType,
	AVG_Data
	FROM "view_pending_requests"
	WHERE
	((:bflt_date=0)OR((:bflt_date=1)AND(AVG_TimeOfCreating >= :flt_date_REQ_FROM AND AVG_TimeOfCreating <= :flt_date_REQ_TO))) AND
	((:bflt_msgcode=0)OR((:bflt_msgcode=1)AND(AVG_MessageCode = :flt_msgcode_MSG_CODE))) AND
	((:bflt_station=0)OR((:bflt_station=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt_station_AVG_STATIONNAME))))
	INTO
	:AVG_Code,
	:AVG_StationName,
	:AVG_MessageCode,
	:AVG_TimeOfCreating,
	:AVG_ReceiverID,
	:AVG_ReceiverType,
	:AVG_SenderID,
	:AVG_SenderType,
	:AVG_Data
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_pending_requests_C_PROC ( 
	bflt_msgcode INTEGER,
	bflt_station INTEGER,
	bflt_date INTEGER,
	flt_msgcode_MSG_CODE INTEGER,
	flt_station_AVG_STATIONNAME VARCHAR(64),
	flt_station_AVG_STATIONNAME_L VARCHAR(512),
	flt_date_REQ_FROM VARCHAR(64),
	flt_date_REQ_FROM_L VARCHAR(512),
	flt_date_REQ_TO VARCHAR(64),
	flt_date_REQ_TO_L VARCHAR(512) )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_pending_requests"
	WHERE
	((:bflt_date=0)OR((:bflt_date=1)AND(AVG_TimeOfCreating >= :flt_date_REQ_FROM AND AVG_TimeOfCreating <= :flt_date_REQ_TO))) AND
	((:bflt_msgcode=0)OR((:bflt_msgcode=1)AND(AVG_MessageCode = :flt_msgcode_MSG_CODE))) AND
	((:bflt_station=0)OR((:bflt_station=1)AND(UPPER(AVG_StationName) LIKE UPPER(:flt_station_AVG_STATIONNAME))))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_installer"(
 AVG_StationName,
 AVG_Code,
 AVG_IpAddress,
 AVG_State,
 AVG_AvgVersion,
 AVG_GroupName,
 AVG_InstallerId,
 AVG_StateIcon,
 AVG_Result,
 AVG_StateDw
) AS SELECT
 "AVG_InstallStations".AVG_StationName,
 "AVG_InstallStations".AVG_Code,
 "AVG_InstallStations".AVG_IpAddress,
 "AVG_InstallStations".AVG_State,
 "AVG_InstallStations".AVG_AvgVersion,
 "AVG_InstallStations".AVG_GroupName,
 "AVG_InstallStations".AVG_InstallerId,
 "AVG_InstallStations".AVG_StateIcon,
 "AVG_InstallStations".AVG_Result,
 "AVG_InstallStations".AVG_State
 FROM "AVG_InstallStations";

<SQLBlock>
CREATE PROCEDURE view_installer_PROC ( 
	RowFilter INTEGER )
	RETURNS (
	AVG_StationName VARCHAR(64),
	AVG_Code INTEGER,
	AVG_IpAddress VARCHAR(50),
	AVG_State INTEGER,
	AVG_AvgVersion VARCHAR(64),
	AVG_GroupName VARCHAR(250),
	AVG_InstallerId INTEGER,
	AVG_StateIcon INTEGER,
	AVG_Result INTEGER,
	AVG_StateDw INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_StationName,
	AVG_Code,
	AVG_IpAddress,
	AVG_State,
	AVG_AvgVersion,
	AVG_GroupName,
	AVG_InstallerId,
	AVG_StateIcon,
	AVG_Result,
	AVG_StateDw
	FROM "view_installer"
	WHERE
	AVG_InstallerId = :RowFilter
	INTO
	:AVG_StationName,
	:AVG_Code,
	:AVG_IpAddress,
	:AVG_State,
	:AVG_AvgVersion,
	:AVG_GroupName,
	:AVG_InstallerId,
	:AVG_StateIcon,
	:AVG_Result,
	:AVG_StateDw
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_installer_C_PROC ( 
	RowFilter INTEGER )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_installer"
	WHERE
	AVG_InstallerId = :RowFilter
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>


CREATE VIEW "view_sp_allstations"(
 AVG_Code,
 AVG_StationName,
 AVG_GroupID,
 AVG_GroupName,
 AVG_LastCall,
 AVG_IPAddress,
 AVG_AvgVersion,
 Antivirus_Version,
 Antivirus_ReleaseDate,
 FW_StateText,
 License_StateText,
 RS_StateText,
 LastScanTime,
 AVG_ExpirationDate,
 AVG_UnhealedInfections,
 AVG_UnhealedPups,
 AVG_UnhealedRootkits,
 AVG_BuildType,
 Core_Version
) AS SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_GroupID,
 "AVG_Groups".AVG_GroupName,
 "AVG_Stations".AVG_LastCall,
 "AVG_Stations".AVG_IPAddress,
 "AVG_StationsStates".AVG_AvgVersion,
 "AVG_StationsStates".Antivirus_Version,
 "AVG_StationsStates".Antivirus_ReleaseDate,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".RS_StateText,
 "AVG_StationsStates".LastScanTime,
 "AVG_Stations".AVG_ExpirationDate,
 SUM("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits - "AVG_ScanLogs".AVG_HealedRootkits),
 "AVG_Stations".AVG_BuildType,
 "AVG_StationsStates".Core_Version
 FROM "AVG_Stations" LEFT JOIN "AVG_Groups" ON ("AVG_Stations".AVG_GroupID="AVG_Groups".AVG_Code) LEFT JOIN "AVG_StationsStates" ON ("AVG_Stations".AVG_Code="AVG_StationsStates".AVG_StationID) LEFT JOIN "AVG_ScanLogs" ON ("AVG_Stations".AVG_Code="AVG_ScanLogs".AVG_OwnerID AND ( "AVG_ScanLogs".AVG_ConfirmTime IS NULL OR "AVG_ScanLogs".AVG_ConfirmTime = '' ))
 WHERE "AVG_Stations".AVG_StationType = 0
 GROUP BY "AVG_Stations".AVG_Code,"AVG_Stations".AVG_StationName,"AVG_Stations".AVG_GroupID,"AVG_Groups".AVG_GroupName,"AVG_Stations".AVG_LastCall,"AVG_Stations".AVG_IPAddress,"AVG_StationsStates".AVG_AvgVersion,"AVG_StationsStates".Antivirus_Version,"AVG_StationsStates".Antivirus_ReleaseDate,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".License_StateText,"AVG_StationsStates".RS_StateText,"AVG_StationsStates".LastScanTime,"AVG_Stations".AVG_ExpirationDate,"AVG_Stations".AVG_BuildType,"AVG_StationsStates".Core_Version;

<SQLBlock>
CREATE PROCEDURE view_sp_allstations_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_GroupID INTEGER,
	AVG_GroupName VARCHAR(64),
	AVG_LastCall VARCHAR(20),
	AVG_IPAddress VARCHAR(50),
	AVG_AvgVersion VARCHAR(50),
	Antivirus_Version VARCHAR(50),
	Antivirus_ReleaseDate VARCHAR(20),
	FW_StateText VARCHAR(128),
	License_StateText VARCHAR(128),
	RS_StateText VARCHAR(128),
	LastScanTime VARCHAR(20),
	AVG_ExpirationDate VARCHAR(20),
	AVG_UnhealedInfections INTEGER,
	AVG_UnhealedPups INTEGER,
	AVG_UnhealedRootkits INTEGER,
	AVG_BuildType INTEGER,
	Core_Version VARCHAR(50))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_StationName,
	AVG_GroupID,
	AVG_GroupName,
	AVG_LastCall,
	AVG_IPAddress,
	AVG_AvgVersion,
	Antivirus_Version,
	Antivirus_ReleaseDate,
	FW_StateText,
	License_StateText,
	RS_StateText,
	LastScanTime,
	AVG_ExpirationDate,
	AVG_UnhealedInfections,
	AVG_UnhealedPups,
	AVG_UnhealedRootkits,
	AVG_BuildType,
	Core_Version
	FROM "view_sp_allstations"
	INTO
	:AVG_Code,
	:AVG_StationName,
	:AVG_GroupID,
	:AVG_GroupName,
	:AVG_LastCall,
	:AVG_IPAddress,
	:AVG_AvgVersion,
	:Antivirus_Version,
	:Antivirus_ReleaseDate,
	:FW_StateText,
	:License_StateText,
	:RS_StateText,
	:LastScanTime,
	:AVG_ExpirationDate,
	:AVG_UnhealedInfections,
	:AVG_UnhealedPups,
	:AVG_UnhealedRootkits,
	:AVG_BuildType,
	:Core_Version
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_sp_allstations_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_sp_allstations"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_sp_problemstations"(
 AVG_Code,
 AVG_StationName,
 AVG_GroupID,
 AVG_GroupName,
 AVG_LastCall,
 AVG_IPAddress,
 AVG_AvgVersion,
 Antivirus_Version,
 Antivirus_ReleaseDate,
 FW_StateText,
 License_StateText,
 RS_StateText,
 LastScanTime,
 AVG_ExpirationDate,
 AVG_UnhealedInfections,
 AVG_UnhealedPups,
 AVG_UnhealedRootkits,
 AVG_BuildType,
 Core_Version
) AS SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_GroupID,
 "AVG_Groups".AVG_GroupName,
 "AVG_Stations".AVG_LastCall,
 "AVG_Stations".AVG_IPAddress,
 "AVG_StationsStates".AVG_AvgVersion,
 "AVG_StationsStates".Antivirus_Version,
 "AVG_StationsStates".Antivirus_ReleaseDate,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".RS_StateText,
 "AVG_StationsStates".LastScanTime,
 "AVG_Stations".AVG_ExpirationDate,
 SUM("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits - "AVG_ScanLogs".AVG_HealedRootkits),
 "AVG_Stations".AVG_BuildType,
 "AVG_StationsStates".Core_Version
 FROM "AVG_Stations" LEFT JOIN "AVG_Groups" ON ("AVG_Stations".AVG_GroupID="AVG_Groups".AVG_Code) LEFT JOIN "AVG_StationsStates" ON ("AVG_Stations".AVG_Code="AVG_StationsStates".AVG_StationID) LEFT JOIN "AVG_ScanLogs" ON ("AVG_Stations".AVG_Code="AVG_ScanLogs".AVG_OwnerID AND ( "AVG_ScanLogs".AVG_ConfirmTime IS NULL OR "AVG_ScanLogs".AVG_ConfirmTime = '' ))
 WHERE "AVG_Stations".AVG_StationType = 0
 GROUP BY "AVG_Stations".AVG_Code,"AVG_Stations".AVG_StationName,"AVG_Stations".AVG_GroupID,"AVG_Groups".AVG_GroupName,"AVG_Stations".AVG_LastCall,"AVG_Stations".AVG_IPAddress,"AVG_StationsStates".AVG_AvgVersion,"AVG_StationsStates".Antivirus_Version,"AVG_StationsStates".Antivirus_ReleaseDate,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".License_StateText,"AVG_StationsStates".RS_StateText,"AVG_StationsStates".LastScanTime,"AVG_Stations".AVG_ExpirationDate,"AVG_Stations".AVG_BuildType,"AVG_StationsStates".Core_Version;

<SQLBlock>
CREATE PROCEDURE view_sp_problemstations_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_GroupID INTEGER,
	AVG_GroupName VARCHAR(64),
	AVG_LastCall VARCHAR(20),
	AVG_IPAddress VARCHAR(50),
	AVG_AvgVersion VARCHAR(50),
	Antivirus_Version VARCHAR(50),
	Antivirus_ReleaseDate VARCHAR(20),
	FW_StateText VARCHAR(128),
	License_StateText VARCHAR(128),
	RS_StateText VARCHAR(128),
	LastScanTime VARCHAR(20),
	AVG_ExpirationDate VARCHAR(20),
	AVG_UnhealedInfections INTEGER,
	AVG_UnhealedPups INTEGER,
	AVG_UnhealedRootkits INTEGER,
	AVG_BuildType INTEGER,
	Core_Version VARCHAR(50))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_StationName,
	AVG_GroupID,
	AVG_GroupName,
	AVG_LastCall,
	AVG_IPAddress,
	AVG_AvgVersion,
	Antivirus_Version,
	Antivirus_ReleaseDate,
	FW_StateText,
	License_StateText,
	RS_StateText,
	LastScanTime,
	AVG_ExpirationDate,
	AVG_UnhealedInfections,
	AVG_UnhealedPups,
	AVG_UnhealedRootkits,
	AVG_BuildType,
	Core_Version
	FROM "view_sp_problemstations"
	INTO
	:AVG_Code,
	:AVG_StationName,
	:AVG_GroupID,
	:AVG_GroupName,
	:AVG_LastCall,
	:AVG_IPAddress,
	:AVG_AvgVersion,
	:Antivirus_Version,
	:Antivirus_ReleaseDate,
	:FW_StateText,
	:License_StateText,
	:RS_StateText,
	:LastScanTime,
	:AVG_ExpirationDate,
	:AVG_UnhealedInfections,
	:AVG_UnhealedPups,
	:AVG_UnhealedRootkits,
	:AVG_BuildType,
	:Core_Version
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_sp_problemstations_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_sp_problemstations"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_non_compliant_gr"(
 AVG_Code,
 AVG_GroupID,
 AVG_StationName,
 AVG_StationDomain,
 AVG_GroupName,
 AVG_LastCall,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_WinVersion,
 AVG_LastSynchro,
 AVG_AvgVersion,
 Antivirus_Version,
 Antivirus_ReleaseDate,
 FW_StateText,
 License_StateText,
 RS_StateText,
 LastScanTime,
 AVG_ExpirationDate,
 AVG_UnhealedInfections,
 AVG_UnhealedPups,
 AVG_UnhealedRootkits,
 AVG_BuildType,
 Core_Version
) AS SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_GroupID,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Groups".AVG_GroupName,
 "AVG_Stations".AVG_LastCall,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_WinVersion,
 "AVG_Stations".AVG_LastSynchro,
 "AVG_StationsStates".AVG_AvgVersion,
 "AVG_StationsStates".Antivirus_Version,
 "AVG_StationsStates".Antivirus_ReleaseDate,
 "AVG_StationsStates".FW_StateText,
 "AVG_StationsStates".License_StateText,
 "AVG_StationsStates".RS_StateText,
 "AVG_StationsStates".LastScanTime,
 "AVG_Stations".AVG_ExpirationDate,
 SUM("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits - "AVG_ScanLogs".AVG_HealedRootkits),
 "AVG_Stations".AVG_BuildType,
 "AVG_StationsStates".Core_Version
 FROM "AVG_Stations" LEFT JOIN "AVG_Groups" ON ("AVG_Stations".AVG_GroupID="AVG_Groups".AVG_Code) LEFT JOIN "AVG_StationsStates" ON ("AVG_Stations".AVG_Code="AVG_StationsStates".AVG_StationID) LEFT JOIN "AVG_ScanLogs" ON ("AVG_Stations".AVG_Code="AVG_ScanLogs".AVG_OwnerID AND ( "AVG_ScanLogs".AVG_ConfirmTime IS NULL OR "AVG_ScanLogs".AVG_ConfirmTime = '' ))
 WHERE ( "AVG_Stations".AVG_StationType = 0 AND ("AVG_ScanLogs".AVG_OwnerType IS NULL OR "AVG_ScanLogs".AVG_OwnerType = 0) )
 GROUP BY "AVG_Stations".AVG_Code,"AVG_Stations".AVG_GroupID,"AVG_Stations".AVG_StationName,"AVG_Stations".AVG_StationDomain,"AVG_Groups".AVG_GroupName,"AVG_Stations".AVG_LastCall,"AVG_Stations".AVG_IPAddress,"AVG_Stations".AVG_MACAddress,"AVG_Stations".AVG_WinVersion,"AVG_Stations".AVG_LastSynchro,"AVG_StationsStates".AVG_AvgVersion,"AVG_StationsStates".Antivirus_Version,"AVG_StationsStates".Antivirus_ReleaseDate,"AVG_StationsStates".FW_StateText,"AVG_StationsStates".License_StateText,"AVG_StationsStates".RS_StateText,"AVG_StationsStates".LastScanTime,"AVG_Stations".AVG_ExpirationDate,"AVG_Stations".AVG_BuildType,"AVG_StationsStates".Core_Version;

<SQLBlock>
CREATE PROCEDURE view_non_compliant_gr_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_GroupID INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_StationDomain VARCHAR(64),
	AVG_GroupName VARCHAR(64),
	AVG_LastCall VARCHAR(20),
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_WinVersion VARCHAR(255),
	AVG_LastSynchro VARCHAR(20),
	AVG_AvgVersion VARCHAR(50),
	Antivirus_Version VARCHAR(50),
	Antivirus_ReleaseDate VARCHAR(20),
	FW_StateText VARCHAR(128),
	License_StateText VARCHAR(128),
	RS_StateText VARCHAR(128),
	LastScanTime VARCHAR(20),
	AVG_ExpirationDate VARCHAR(20),
	AVG_UnhealedInfections INTEGER,
	AVG_UnhealedPups INTEGER,
	AVG_UnhealedRootkits INTEGER,
	AVG_BuildType INTEGER,
	Core_Version VARCHAR(50))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_GroupID,
	AVG_StationName,
	AVG_StationDomain,
	AVG_GroupName,
	AVG_LastCall,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_WinVersion,
	AVG_LastSynchro,
	AVG_AvgVersion,
	Antivirus_Version,
	Antivirus_ReleaseDate,
	FW_StateText,
	License_StateText,
	RS_StateText,
	LastScanTime,
	AVG_ExpirationDate,
	AVG_UnhealedInfections,
	AVG_UnhealedPups,
	AVG_UnhealedRootkits,
	AVG_BuildType,
	Core_Version
	FROM "view_non_compliant_gr"
	INTO
	:AVG_Code,
	:AVG_GroupID,
	:AVG_StationName,
	:AVG_StationDomain,
	:AVG_GroupName,
	:AVG_LastCall,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_WinVersion,
	:AVG_LastSynchro,
	:AVG_AvgVersion,
	:Antivirus_Version,
	:Antivirus_ReleaseDate,
	:FW_StateText,
	:License_StateText,
	:RS_StateText,
	:LastScanTime,
	:AVG_ExpirationDate,
	:AVG_UnhealedInfections,
	:AVG_UnhealedPups,
	:AVG_UnhealedRootkits,
	:AVG_BuildType,
	:Core_Version
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_non_compliant_gr_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_non_compliant_gr"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>


CREATE VIEW "view_versions"(
 AVG_Code,
 BuildNumber,
 DowloadUrl,
 ProductName,
 ReleaseTime,
 Version
) AS SELECT
 "AVG_Versions".AVG_Code,
 "AVG_Versions".BuildNumber,
 "AVG_Versions".DowloadUrl,
 "AVG_Versions".ProductName,
 "AVG_Versions".ReleaseTime,
 "AVG_Versions".Version
 FROM "AVG_Versions";

<SQLBlock>
CREATE PROCEDURE view_versions_PROC
	RETURNS (
	AVG_Code INTEGER,
	BuildNumber INTEGER,
	DowloadUrl VARCHAR(256),
	ProductName VARCHAR(64),
	ReleaseTime VARCHAR(20),
	Version VARCHAR(32))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	BuildNumber,
	DowloadUrl,
	ProductName,
	ReleaseTime,
	Version
	FROM "view_versions"
	INTO
	:AVG_Code,
	:BuildNumber,
	:DowloadUrl,
	:ProductName,
	:ReleaseTime,
	:Version
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_versions_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_versions"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_virusvault"(
 AVG_DetectionSeverity,
 AVG_DetectionName,
 AVG_ObjectName,
 AVG_InsertTimeStamp,
 AVG_Code,
 AVG_OwnerID,
 AVG_VaultItemIndex
) AS SELECT
 "AVG_VirusVault".AVG_DetectionSeverity,
 "AVG_VirusVault".AVG_DetectionName,
 "AVG_VirusVault".AVG_ObjectName,
 "AVG_VirusVault".AVG_InsertTimeStamp,
 "AVG_VirusVault".AVG_Code,
 "AVG_VirusVault".AVG_OwnerID,
 "AVG_VirusVault".AVG_VaultItemIndex
 FROM "AVG_VirusVault";

<SQLBlock>
CREATE PROCEDURE view_virusvault_PROC ( 
	RowFilter INTEGER )
	RETURNS (
	AVG_DetectionSeverity INTEGER,
	AVG_DetectionName VARCHAR(512),
	AVG_ObjectName VARCHAR(512),
	AVG_InsertTimeStamp VARCHAR(20),
	AVG_Code INTEGER,
	AVG_OwnerID INTEGER,
	AVG_VaultItemIndex INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_DetectionSeverity,
	AVG_DetectionName,
	AVG_ObjectName,
	AVG_InsertTimeStamp,
	AVG_Code,
	AVG_OwnerID,
	AVG_VaultItemIndex
	FROM "view_virusvault"
	WHERE
	AVG_OwnerID = :RowFilter
	INTO
	:AVG_DetectionSeverity,
	:AVG_DetectionName,
	:AVG_ObjectName,
	:AVG_InsertTimeStamp,
	:AVG_Code,
	:AVG_OwnerID,
	:AVG_VaultItemIndex
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_virusvault_C_PROC ( 
	RowFilter INTEGER )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_virusvault"
	WHERE
	AVG_OwnerID = :RowFilter
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_allstations"(
 AVG_Code,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_StationDomain,
 AVG_StationName
) AS SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Stations".AVG_StationName
 FROM "AVG_Stations";

<SQLBlock>
CREATE PROCEDURE view_allstations_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_StationDomain VARCHAR(64),
	AVG_StationName VARCHAR(64))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_StationDomain,
	AVG_StationName
	FROM "view_allstations"
	INTO
	:AVG_Code,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_StationDomain,
	:AVG_StationName
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_allstations_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_allstations"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_stationlist"(
 AVG_Code,
 AVG_StationType,
 AVG_StationName,
 AVG_GroupID
) AS SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationType,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_GroupID
 FROM "AVG_Stations";

<SQLBlock>
CREATE PROCEDURE view_stationlist_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_StationType INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_GroupID INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_StationType,
	AVG_StationName,
	AVG_GroupID
	FROM "view_stationlist"
	INTO
	:AVG_Code,
	:AVG_StationType,
	:AVG_StationName,
	:AVG_GroupID
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_stationlist_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_stationlist"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_emsstations"(
 emssrv__port,
 emssrv__name,
 AVG_StationName,
 AVG_GroupName,
 AVG_GroupID
) AS SELECT
 "emssrv".emssrv__port,
 "emssrv".emssrv__name,
 "AVG_Stations".AVG_StationName,
 "AVG_Groups".AVG_GroupName,
 "AVG_Stations".AVG_GroupID
 FROM "emssrv" LEFT JOIN "AVG_Stations" ON ("emssrv".AVG_OwnerID="AVG_Stations".AVG_Code AND ( "emssrv".AVG_OwnerType = 0 )) LEFT JOIN "AVG_Groups" ON ("emssrv".AVG_OwnerID="AVG_Groups".AVG_Code AND ( "emssrv".AVG_OwnerType = 1 ))
 WHERE ( "emssrv".AVG_OwnerType IN ( 0, 1 ) );

<SQLBlock>
CREATE PROCEDURE view_emsstations_PROC ( 
	bgroup INTEGER,
	bname INTEGER,
	bport INTEGER,
	group_GROUPID INTEGER,
	name_NAME VARCHAR(64),
	name_NAME_L VARCHAR(512),
	port_PORT INTEGER )
	RETURNS (
	emssrv__port INTEGER,
	emssrv__name VARCHAR(32),
	AVG_StationName VARCHAR(64),
	AVG_GroupName VARCHAR(64),
	AVG_GroupID INTEGER)
AS BEGIN
	FOR SELECT 
	emssrv__port,
	emssrv__name,
	AVG_StationName,
	AVG_GroupName,
	AVG_GroupID
	FROM "view_emsstations"
	WHERE
	((:bgroup=0)OR((:bgroup=1)AND(( AVG_GroupID=:group_GROUPID )))) AND
	((:bname=0)OR((:bname=1)AND(( ( emssrv__name<>:name_NAME ) AND ( emssrv__name<>:name_NAME_L ) )))) AND
	((:bport=0)OR((:bport=1)AND(( emssrv__port=:port_PORT ))))
	INTO
	:emssrv__port,
	:emssrv__name,
	:AVG_StationName,
	:AVG_GroupName,
	:AVG_GroupID
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_emsstations_C_PROC ( 
	bgroup INTEGER,
	bname INTEGER,
	bport INTEGER,
	group_GROUPID INTEGER,
	name_NAME VARCHAR(64),
	name_NAME_L VARCHAR(512),
	port_PORT INTEGER )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_emsstations"
	WHERE
	((:bgroup=0)OR((:bgroup=1)AND(( AVG_GroupID=:group_GROUPID )))) AND
	((:bname=0)OR((:bname=1)AND(( ( emssrv__name<>:name_NAME ) AND ( emssrv__name<>:name_NAME_L ) )))) AND
	((:bport=0)OR((:bport=1)AND(( emssrv__port=:port_PORT ))))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_emsmailservers"(
 emssrv__port,
 emssrv__name,
 AVG_StationName
) AS SELECT
 "emssrv".emssrv__port,
 "emssrv".emssrv__name,
 "AVG_Stations".AVG_StationName
 FROM "emssrv" LEFT JOIN "AVG_Stations" ON ("emssrv".AVG_OwnerID="AVG_Stations".AVG_Code AND ( "emssrv".AVG_OwnerType = 7 ))
 WHERE ( "emssrv".AVG_OwnerType IN ( 7 ) );

<SQLBlock>
CREATE PROCEDURE view_emsmailservers_PROC ( 
	bname INTEGER,
	bport INTEGER,
	name_NAME VARCHAR(64),
	name_NAME_L VARCHAR(512),
	port_PORT INTEGER )
	RETURNS (
	emssrv__port INTEGER,
	emssrv__name VARCHAR(32),
	AVG_StationName VARCHAR(64))
AS BEGIN
	FOR SELECT 
	emssrv__port,
	emssrv__name,
	AVG_StationName
	FROM "view_emsmailservers"
	WHERE
	((:bname=0)OR((:bname=1)AND(( ( emssrv__name<>:name_NAME ) AND ( emssrv__name<>:name_NAME_L ) )))) AND
	((:bport=0)OR((:bport=1)AND(( emssrv__port=:port_PORT ))))
	INTO
	:emssrv__port,
	:emssrv__name,
	:AVG_StationName
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_emsmailservers_C_PROC ( 
	bname INTEGER,
	bport INTEGER,
	name_NAME VARCHAR(64),
	name_NAME_L VARCHAR(512),
	port_PORT INTEGER )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_emsmailservers"
	WHERE
	((:bname=0)OR((:bname=1)AND(( ( emssrv__name<>:name_NAME ) AND ( emssrv__name<>:name_NAME_L ) )))) AND
	((:bport=0)OR((:bport=1)AND(( emssrv__port=:port_PORT ))))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_stationssamename"(
 AVG_Code,
 AVG_StationName,
 AVG_StationDomain,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_LastSynchro
) AS SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_LastSynchro
 FROM "AVG_Stations"
 WHERE "AVG_Stations".AVG_StationType IN (0, 7) AND "AVG_Stations".AVG_StationName IN (SELECT "AVG_Stations".AVG_StationName FROM "AVG_Stations" GROUP BY "AVG_Stations".AVG_StationName HAVING COUNT("AVG_Stations".AVG_Code) > 1) ;

<SQLBlock>
CREATE PROCEDURE view_stationssamename_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_StationDomain VARCHAR(64),
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_LastSynchro VARCHAR(20))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_StationName,
	AVG_StationDomain,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_LastSynchro
	FROM "view_stationssamename"
	INTO
	:AVG_Code,
	:AVG_StationName,
	:AVG_StationDomain,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_LastSynchro
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_stationssamename_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_stationssamename"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_stationssamename2"(
 AVG_Code,
 AVG_StationName,
 AVG_StationDomain,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_LastSynchro
) AS SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_LastSynchro
 FROM "AVG_Stations"
 WHERE "AVG_Stations".AVG_StationType IN (0, 7) AND "AVG_Stations".AVG_StationName IN (SELECT "AVG_Stations".AVG_StationName FROM "AVG_Stations" GROUP BY "AVG_Stations".AVG_StationName,  "AVG_Stations".AVG_StationDomain HAVING COUNT("AVG_Stations".AVG_Code) > 1) AND "AVG_Stations".AVG_StationDomain IN (SELECT "AVG_Stations".AVG_StationDomain FROM "AVG_Stations" GROUP BY "AVG_Stations".AVG_StationName,  "AVG_Stations".AVG_StationDomain HAVING COUNT("AVG_Stations".AVG_Code) > 1) ;

<SQLBlock>
CREATE PROCEDURE view_stationssamename2_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_StationDomain VARCHAR(64),
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_LastSynchro VARCHAR(20))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_StationName,
	AVG_StationDomain,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_LastSynchro
	FROM "view_stationssamename2"
	INTO
	:AVG_Code,
	:AVG_StationName,
	:AVG_StationDomain,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_LastSynchro
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_stationssamename2_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_stationssamename2"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_stationssameip"(
 AVG_Code,
 AVG_StationName,
 AVG_StationDomain,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_LastSynchro
) AS SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_LastSynchro
 FROM "AVG_Stations"
 WHERE "AVG_Stations".AVG_StationType IN (0, 7) AND "AVG_Stations".AVG_IPAddress IN (SELECT "AVG_Stations".AVG_IPAddress FROM "AVG_Stations" GROUP BY "AVG_Stations".AVG_IPAddress HAVING COUNT("AVG_Stations".AVG_Code) > 1) ;

<SQLBlock>
CREATE PROCEDURE view_stationssameip_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_StationDomain VARCHAR(64),
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_LastSynchro VARCHAR(20))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_StationName,
	AVG_StationDomain,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_LastSynchro
	FROM "view_stationssameip"
	INTO
	:AVG_Code,
	:AVG_StationName,
	:AVG_StationDomain,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_LastSynchro
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_stationssameip_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_stationssameip"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_stationssamemac"(
 AVG_Code,
 AVG_StationName,
 AVG_StationDomain,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_LastSynchro
) AS SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_StationDomain,
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_LastSynchro
 FROM "AVG_Stations"
 WHERE "AVG_Stations".AVG_StationType IN (0, 7) AND "AVG_Stations".AVG_MACAddress IN (SELECT "AVG_Stations".AVG_MACAddress FROM "AVG_Stations" GROUP BY "AVG_Stations".AVG_MACAddress HAVING COUNT("AVG_Stations".AVG_Code) > 1) ;

<SQLBlock>
CREATE PROCEDURE view_stationssamemac_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_StationDomain VARCHAR(64),
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_LastSynchro VARCHAR(20))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_StationName,
	AVG_StationDomain,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_LastSynchro
	FROM "view_stationssamemac"
	INTO
	:AVG_Code,
	:AVG_StationName,
	:AVG_StationDomain,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_LastSynchro
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_stationssamemac_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_stationssamemac"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_eventhistory"(
 AVG_Code,
 AVG_OwnerID,
 AVG_OwnerType,
 AVG_Date,
 AVG_User,
 AVG_Source,
 AVG_Description
) AS SELECT
 "AVG_EventHistory".AVG_Code,
 "AVG_EventHistory".AVG_OwnerID,
 "AVG_EventHistory".AVG_OwnerType,
 "AVG_EventHistory".AVG_Date,
 "AVG_EventHistory".AVG_User,
 "AVG_EventHistory".AVG_Source,
 "AVG_EventHistory".AVG_Description
 FROM "AVG_EventHistory";

<SQLBlock>
CREATE PROCEDURE view_eventhistory_PROC ( 
	RowFilter INTEGER )
	RETURNS (
	AVG_Code INTEGER,
	AVG_OwnerID INTEGER,
	AVG_OwnerType INTEGER,
	AVG_Date VARCHAR(20),
	AVG_User VARCHAR(250),
	AVG_Source VARCHAR(250),
	AVG_Description VARCHAR(2048))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_OwnerID,
	AVG_OwnerType,
	AVG_Date,
	AVG_User,
	AVG_Source,
	AVG_Description
	FROM "view_eventhistory"
	WHERE
	AVG_OwnerID = :RowFilter
	INTO
	:AVG_Code,
	:AVG_OwnerID,
	:AVG_OwnerType,
	:AVG_Date,
	:AVG_User,
	:AVG_Source,
	:AVG_Description
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_eventhistory_C_PROC ( 
	RowFilter INTEGER )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_eventhistory"
	WHERE
	AVG_OwnerID = :RowFilter
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_installerlist"(
 AVG_Code,
 AVG_Name,
 AVG_Date,
 AVG_SetupFileGuid,
 AVG_IniFileGuid
) AS SELECT
 "AVG_Installer".AVG_Code,
 "AVG_Installer".AVG_Name,
 "AVG_Installer".AVG_Date,
 "AVG_Installer".AVG_SetupFileGuid,
 "AVG_Installer".AVG_IniFileGuid
 FROM "AVG_Installer";

<SQLBlock>
CREATE PROCEDURE view_installerlist_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_Name VARCHAR(250),
	AVG_Date VARCHAR(20),
	AVG_SetupFileGuid VARCHAR(250),
	AVG_IniFileGuid VARCHAR(250))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_Name,
	AVG_Date,
	AVG_SetupFileGuid,
	AVG_IniFileGuid
	FROM "view_installerlist"
	INTO
	:AVG_Code,
	:AVG_Name,
	:AVG_Date,
	:AVG_SetupFileGuid,
	:AVG_IniFileGuid
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_installerlist_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_installerlist"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_sp_stations"(
 AVG_Code,
 AVG_StationName,
 AVG_LastCall,
 AVG_UnhealedInfections,
 AVG_UnhealedPups,
 AVG_UnhealedRootkits,
 AVG_TotalInfections,
 AVG_TotalPups,
 AVG_TotalRootkits,
 AVG_IPAddress,
 AVG_MACAddress,
 AVG_WinVersion,
 AVG_LastSynchro,
 LastScanTime,
 NeedRestart,
 AVG_ExpirationDate,
 AVG_AvgVersion,
 Core_Version,
 Antivirus_Version,
 Antivirus_ReleaseDate,
 AVG_LicenceNumber
) AS SELECT
 "AVG_Stations".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_Stations".AVG_LastCall,
 SUM("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits - "AVG_ScanLogs".AVG_HealedRootkits),
 SUM("AVG_ScanLogs".AVG_FoundInfections),
 SUM("AVG_ScanLogs".AVG_FoundPups),
 SUM("AVG_ScanLogs".AVG_FoundRootkits),
 "AVG_Stations".AVG_IPAddress,
 "AVG_Stations".AVG_MACAddress,
 "AVG_Stations".AVG_WinVersion,
 "AVG_Stations".AVG_LastSynchro,
 "AVG_StationsStates".LastScanTime,
 "AVG_StationsStates".NeedRestart,
 "AVG_Stations".AVG_ExpirationDate,
 "AVG_StationsStates".AVG_AvgVersion,
 "AVG_StationsStates".Core_Version,
 "AVG_StationsStates".Antivirus_Version,
 "AVG_StationsStates".Antivirus_ReleaseDate,
 "AVG_Stations".AVG_LicenceNumber
 FROM "AVG_Stations" LEFT JOIN "AVG_StationsStates" ON ("AVG_Stations".AVG_Code="AVG_StationsStates".AVG_StationID) LEFT JOIN "AVG_ScanLogs" ON ("AVG_Stations".AVG_Code="AVG_ScanLogs".AVG_OwnerID AND ( "AVG_ScanLogs".AVG_ConfirmTime IS NULL OR "AVG_ScanLogs".AVG_ConfirmTime = '' ))
 WHERE ( "AVG_Stations".AVG_StationType = 0 AND ("AVG_ScanLogs".AVG_OwnerType IS NULL OR "AVG_ScanLogs".AVG_OwnerType = 0) )
 GROUP BY "AVG_Stations".AVG_Code,"AVG_Stations".AVG_StationName,"AVG_Stations".AVG_LastCall,"AVG_Stations".AVG_IPAddress,"AVG_Stations".AVG_MACAddress,"AVG_Stations".AVG_WinVersion,"AVG_Stations".AVG_LastSynchro,"AVG_StationsStates".LastScanTime,"AVG_StationsStates".NeedRestart,"AVG_Stations".AVG_ExpirationDate,"AVG_StationsStates".AVG_AvgVersion,"AVG_StationsStates".Core_Version,"AVG_StationsStates".Antivirus_Version,"AVG_StationsStates".Antivirus_ReleaseDate,"AVG_Stations".AVG_LicenceNumber;

<SQLBlock>
CREATE PROCEDURE view_sp_stations_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_LastCall VARCHAR(20),
	AVG_UnhealedInfections INTEGER,
	AVG_UnhealedPups INTEGER,
	AVG_UnhealedRootkits INTEGER,
	AVG_TotalInfections INTEGER,
	AVG_TotalPups INTEGER,
	AVG_TotalRootkits INTEGER,
	AVG_IPAddress VARCHAR(50),
	AVG_MACAddress VARCHAR(18),
	AVG_WinVersion VARCHAR(255),
	AVG_LastSynchro VARCHAR(20),
	LastScanTime VARCHAR(20),
	NeedRestart INTEGER,
	AVG_ExpirationDate VARCHAR(20),
	AVG_AvgVersion VARCHAR(50),
	Core_Version VARCHAR(50),
	Antivirus_Version VARCHAR(50),
	Antivirus_ReleaseDate VARCHAR(20),
	AVG_LicenceNumber VARCHAR(64))
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_StationName,
	AVG_LastCall,
	AVG_UnhealedInfections,
	AVG_UnhealedPups,
	AVG_UnhealedRootkits,
	AVG_TotalInfections,
	AVG_TotalPups,
	AVG_TotalRootkits,
	AVG_IPAddress,
	AVG_MACAddress,
	AVG_WinVersion,
	AVG_LastSynchro,
	LastScanTime,
	NeedRestart,
	AVG_ExpirationDate,
	AVG_AvgVersion,
	Core_Version,
	Antivirus_Version,
	Antivirus_ReleaseDate,
	AVG_LicenceNumber
	FROM "view_sp_stations"
	INTO
	:AVG_Code,
	:AVG_StationName,
	:AVG_LastCall,
	:AVG_UnhealedInfections,
	:AVG_UnhealedPups,
	:AVG_UnhealedRootkits,
	:AVG_TotalInfections,
	:AVG_TotalPups,
	:AVG_TotalRootkits,
	:AVG_IPAddress,
	:AVG_MACAddress,
	:AVG_WinVersion,
	:AVG_LastSynchro,
	:LastScanTime,
	:NeedRestart,
	:AVG_ExpirationDate,
	:AVG_AvgVersion,
	:Core_Version,
	:Antivirus_Version,
	:Antivirus_ReleaseDate,
	:AVG_LicenceNumber
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_sp_stations_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_sp_stations"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_sp_requests"(
 ColRequestCount
) AS SELECT
 COUNT("AVG_Messages".AVG_Code)
 FROM "AVG_Messages"
 WHERE ( "AVG_Messages".AVG_MessageType = 1 AND "AVG_Messages".AVG_TimeOfReading = '' ) AND ( ( "AVG_Messages".AVG_ReceiverType = 0 ) OR  ( "AVG_Messages".AVG_ReceiverType = 7 ) );

<SQLBlock>
CREATE PROCEDURE view_sp_requests_PROC
	RETURNS (
	ColRequestCount INTEGER)
AS BEGIN
	FOR SELECT 
	ColRequestCount
	FROM "view_sp_requests"
	INTO
	:ColRequestCount
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_sp_requests_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_sp_requests"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_sp_scanlogs"(
 AVG_Code,
 AVG_StationName,
 AVG_TestName,
 AVG_ConfirmTime,
 AVG_Unhealed,
 AVG_ScannedObjects,
 AVG_ScannedRootkits
) AS SELECT
 "AVG_ScanLogs".AVG_Code,
 "AVG_Stations".AVG_StationName,
 "AVG_ScanLogs".AVG_TestName,
 "AVG_ScanLogs".AVG_ConfirmTime,
 (("AVG_ScanLogs".AVG_FoundInfections - "AVG_ScanLogs".AVG_HealedInfections) + ("AVG_ScanLogs".AVG_FoundPups - "AVG_ScanLogs".AVG_HealedPups) + ("AVG_ScanLogs".AVG_HealedRootkits - "AVG_ScanLogs".AVG_HealedRootkits)),
 "AVG_ScanLogs".AVG_ScannedObjects,
 "AVG_ScanLogs".AVG_ScannedRootkits
 FROM "AVG_ScanLogs" LEFT JOIN "AVG_Stations" ON ("AVG_ScanLogs".AVG_OwnerID="AVG_Stations".AVG_Code);

<SQLBlock>
CREATE PROCEDURE view_sp_scanlogs_PROC
	RETURNS (
	AVG_Code INTEGER,
	AVG_StationName VARCHAR(64),
	AVG_TestName VARCHAR(128),
	AVG_ConfirmTime VARCHAR(20),
	AVG_Unhealed INTEGER,
	AVG_ScannedObjects INTEGER,
	AVG_ScannedRootkits INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_Code,
	AVG_StationName,
	AVG_TestName,
	AVG_ConfirmTime,
	AVG_Unhealed,
	AVG_ScannedObjects,
	AVG_ScannedRootkits
	FROM "view_sp_scanlogs"
	INTO
	:AVG_Code,
	:AVG_StationName,
	:AVG_TestName,
	:AVG_ConfirmTime,
	:AVG_Unhealed,
	:AVG_ScannedObjects,
	:AVG_ScannedRootkits
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_sp_scanlogs_C_PROC
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_sp_scanlogs"
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>

CREATE VIEW "view_stationsvercnt"(
 AVG_AvgVersion,
 VerCount
) AS SELECT
 "AVG_StationsStates".AVG_AvgVersion,
 COUNT(AVG_AvgVersion)
 FROM "AVG_StationsStates"
 GROUP BY "AVG_StationsStates".AVG_AvgVersion;

<SQLBlock>
CREATE PROCEDURE view_stationsvercnt_PROC ( 
	bflt INTEGER,
	flt_VER VARCHAR(64),
	flt_VER_L VARCHAR(512) )
	RETURNS (
	AVG_AvgVersion VARCHAR(50),
	VerCount INTEGER)
AS BEGIN
	FOR SELECT 
	AVG_AvgVersion,
	VerCount
	FROM "view_stationsvercnt"
	WHERE
	((:bflt=0)OR((:bflt=1)AND(AVG_AvgVersion < :flt_VER)))
	INTO
	:AVG_AvgVersion,
	:VerCount
	DO SUSPEND
;END;
</SQLBlock>
<SQLBlock>
CREATE PROCEDURE view_stationsvercnt_C_PROC ( 
	bflt INTEGER,
	flt_VER VARCHAR(64),
	flt_VER_L VARCHAR(512) )
	RETURNS( ret INTEGER )
AS BEGIN
	FOR SELECT COUNT(*)
	FROM "view_stationsvercnt"
	WHERE
	((:bflt=0)OR((:bflt=1)AND(AVG_AvgVersion < :flt_VER)))
	INTO
	:ret
	DO SUSPEND
;END;
</SQLBlock>


</DatabaseViews>
<EventManagerObjects>
<SQLBlock>
CREATE PROCEDURE EM_OldVersionSP (nextExec VARCHAR(20), ignoreBarrier INTEGER)
RETURNS (
  AVG_StationName VARCHAR(64),
  AVG_StationDomain VARCHAR(64),
  AVG_GroupName VARCHAR(64),
  AVG_IPAddress VARCHAR(16),
  AVG_MACAddress VARCHAR(18),
  AVG_LastCall VARCHAR(20),
  AVG_WinVersion VARCHAR(255),
  AVG_AvgVersion VARCHAR(50),
  Antivirus_Version VARCHAR(50),
  AVG_StationDesc VARCHAR(250)
)
AS
	DECLARE VARIABLE sp_BarrierSize INTEGER;
	DECLARE VARIABLE sp_MAX_AVG_AvgVersion_AVGcur VARCHAR(50);
	DECLARE VARIABLE sp_MAX_AVG_AvgVersion_AVGcur_64 VARCHAR(50);
	DECLARE VARIABLE sp_MAX_AVG_AvgVersion_AVGprev VARCHAR(50);
	DECLARE VARIABLE sp_MAX_AVG_AvgVersion_AVGprev_64 VARCHAR(50);
	DECLARE VARIABLE sp_REPORTED_AVG_AvgVersion_AVGcur VARCHAR(255);
	DECLARE VARIABLE sp_REPORTED_AVG_AvgVersion_AVGcur_64 VARCHAR(255);
	DECLARE VARIABLE sp_REPORTED_AVG_AvgVersion_AVGprev VARCHAR(255);
	DECLARE VARIABLE sp_REPORTED_AVG_AvgVersion_AVGprev_64 VARCHAR(255);
	DECLARE VARIABLE sp_LastReportedValue_AVGcur VARCHAR(255);
	DECLARE VARIABLE sp_LastReportedValue_AVGcur_64 VARCHAR(255);
	DECLARE VARIABLE sp_LastReportedValue_AVGprev VARCHAR(255);
	DECLARE VARIABLE sp_LastReportedValue_AVGprev_64 VARCHAR(255);
	DECLARE VARIABLE sp_RecVersion INTEGER;
	DECLARE VARIABLE sp_RowCount INTEGER;
	DECLARE VARIABLE sp_RowCount_AVGcur INTEGER;
	DECLARE VARIABLE sp_RowCount_AVGcur_64 INTEGER;
	DECLARE VARIABLE sp_RowCount_AVGprev INTEGER;
	DECLARE VARIABLE sp_RowCount_AVGprev_64 INTEGER;
	DECLARE VARIABLE sp_FirstMatchedExec VARCHAR(20);

BEGIN
		SELECT FIRST 1 FirstMatchedExecution, BarrierSize, LastReportedValue, LastReportedValue_64, LastReportedValue2, LastReportedValue2_64, AVG_RecVersion FROM "AVG_EMTerm" WHERE AVG_Code = 1
	INTO :sp_FirstMatchedExec, :sp_BarrierSize, :sp_LastReportedValue_AVGcur, :sp_LastReportedValue_AVGcur_64, :sp_LastReportedValue_AVGprev, :sp_LastReportedValue_AVGprev_64, :sp_RecVersion;
			SELECT FIRST 1 Version FROM "AVG_Versions" WHERE ProductName='avg2012winupd' INTO :sp_MAX_AVG_AvgVersion_AVGcur;
	SELECT FIRST 1 Version FROM "AVG_Versions" WHERE ProductName='avg2012winupd64' INTO :sp_MAX_AVG_AvgVersion_AVGcur_64;
	SELECT FIRST 1 Version FROM "AVG_Versions" WHERE ProductName='avg10winupd' INTO :sp_MAX_AVG_AvgVersion_AVGprev;
	SELECT FIRST 1 Version FROM "AVG_Versions" WHERE ProductName='avg10winupd64' INTO :sp_MAX_AVG_AvgVersion_AVGprev_64;
		SELECT COUNT(*), MAX(AVG_AvgVersion) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
		WHERE AVG_AvgVersion LIKE '2012.%' AND AVG_BuildType=32 AND :sp_LastReportedValue_AVGcur < AVG_AvgVersion AND AVG_AvgVersion < :sp_MAX_AVG_AvgVersion_AVGcur
		INTO :sp_RowCount_AVGcur, :sp_REPORTED_AVG_AvgVersion_AVGcur;
	SELECT COUNT(*), MAX(AVG_AvgVersion) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
		WHERE AVG_AvgVersion LIKE '2012.%' AND AVG_BuildType=64 AND :sp_LastReportedValue_AVGcur_64 < AVG_AvgVersion AND AVG_AvgVersion < :sp_MAX_AVG_AvgVersion_AVGcur_64
		INTO :sp_RowCount_AVGcur_64, :sp_REPORTED_AVG_AvgVersion_AVGcur_64;
	SELECT COUNT(*), MAX(AVG_AvgVersion) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
		WHERE AVG_AvgVersion LIKE '0010.%' AND AVG_BuildType=32 AND :sp_LastReportedValue_AVGprev < AVG_AvgVersion AND AVG_AvgVersion < :sp_MAX_AVG_AvgVersion_AVGprev
		INTO :sp_RowCount_AVGprev, :sp_REPORTED_AVG_AvgVersion_AVGprev;
	SELECT COUNT(*), MAX(AVG_AvgVersion) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
		WHERE AVG_AvgVersion LIKE '0010.%' AND AVG_BuildType=64 AND :sp_LastReportedValue_AVGprev_64 < AVG_AvgVersion AND AVG_AvgVersion < :sp_MAX_AVG_AvgVersion_AVGprev_64
		INTO :sp_RowCount_AVGprev_64, :sp_REPORTED_AVG_AvgVersion_AVGprev_64;
	sp_RowCount = :sp_RowCount_AVGcur + :sp_RowCount_AVGcur_64 + :sp_RowCount_AVGprev + :sp_RowCount_AVGprev_64;
	IF (sp_RowCount > 0 AND sp_FirstMatchedExec = '') THEN
	BEGIN
		sp_FirstMatchedExec = SUBSTRING(CAST(CURRENT_TIMESTAMP AS VARCHAR(24)) FROM 1 FOR 19);
	END
	IF ((sp_RowCount > 0) AND (ignoreBarrier = 1 OR sp_BarrierSize <= sp_RowCount)) THEN
	BEGIN
				FOR
			SELECT AVG_StationName, AVG_StationDomain, AVG_GroupName, AVG_IPAddress, AVG_MACAddress, AVG_LastCall, AVG_WinVersion, AVG_AvgVersion, Antivirus_Version, AVG_StationDesc
			FROM "AVG_Stations" 
			LEFT JOIN "AVG_Groups" ON "AVG_Groups".AVG_Code = "AVG_Stations".AVG_GroupID
			INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
			WHERE (AVG_AvgVersion LIKE '2012.%' AND AVG_BuildType=32 AND :sp_LastReportedValue_AVGcur < AVG_AvgVersion AND AVG_AvgVersion < :sp_MAX_AVG_AvgVersion_AVGcur)
			OR (AVG_AvgVersion LIKE '2012.%' AND AVG_BuildType=64 AND :sp_LastReportedValue_AVGcur_64 < AVG_AvgVersion AND AVG_AvgVersion < :sp_MAX_AVG_AvgVersion_AVGcur_64)
			OR (AVG_AvgVersion LIKE '0010.%' AND AVG_BuildType=32 AND :sp_LastReportedValue_AVGprev < AVG_AvgVersion AND AVG_AvgVersion < :sp_MAX_AVG_AvgVersion_AVGprev)
			OR (AVG_AvgVersion LIKE '0010.%' AND AVG_BuildType=64 AND :sp_LastReportedValue_AVGprev_64 < AVG_AvgVersion AND AVG_AvgVersion < :sp_MAX_AVG_AvgVersion_AVGprev_64)
			ORDER BY AVG_AvgVersion ASC
			INTO :AVG_StationName,:AVG_StationDomain,:AVG_GroupName,:AVG_IPAddress,:AVG_MACAddress,:AVG_LastCall,:AVG_WinVersion,:AVG_AvgVersion, :Antivirus_Version, :AVG_StationDesc
		DO SUSPEND;
				IF (:sp_REPORTED_AVG_AvgVersion_AVGcur IS NULL) THEN
			sp_REPORTED_AVG_AvgVersion_AVGcur = :sp_LastReportedValue_AVGcur;
		IF (:sp_REPORTED_AVG_AvgVersion_AVGcur_64 IS NULL) THEN
			sp_REPORTED_AVG_AvgVersion_AVGcur_64 = :sp_LastReportedValue_AVGcur_64;
		IF (:sp_REPORTED_AVG_AvgVersion_AVGprev IS NULL) THEN
			sp_REPORTED_AVG_AvgVersion_AVGprev = :sp_LastReportedValue_AVGprev;
		IF (:sp_REPORTED_AVG_AvgVersion_AVGprev_64 IS NULL) THEN
			sp_REPORTED_AVG_AvgVersion_AVGprev_64 = :sp_LastReportedValue_AVGprev_64;
		sp_RecVersion = :sp_RecVersion + 1;
		UPDATE "AVG_EMTerm" SET FirstMatchedExecution = '', LastReportedValue = :sp_REPORTED_AVG_AvgVersion_AVGcur, LastReportedValue_64 = :sp_REPORTED_AVG_AvgVersion_AVGcur_64, LastReportedValue2 = :sp_REPORTED_AVG_AvgVersion_AVGprev, LastReportedValue2_64 = :sp_REPORTED_AVG_AvgVersion_AVGprev_64, AVG_RecVersion = :sp_RecVersion WHERE AVG_Code = 1;
	END
	ELSE
	BEGIN
				UPDATE "AVG_EMTerm" SET FirstMatchedExecution = :sp_FirstMatchedExec, NextExecution = :nextExec WHERE AVG_Code = 1;
	END
END;
</SQLBlock>




<SQLBlock>
CREATE PROCEDURE EM_OldVirBaseSP (nextExec VARCHAR(20), ignoreBarrier INTEGER, hours INTEGER)
RETURNS (
  AVG_StationName VARCHAR(64),
  AVG_StationDomain VARCHAR(64),
  AVG_GroupName VARCHAR(64),
  AVG_IPAddress VARCHAR(16),
  AVG_MACAddress VARCHAR(18),
  AVG_LastCall VARCHAR(20),
  AVG_WinVersion VARCHAR(255),
  AVG_AvgVersion VARCHAR(50),
  Antivirus_Version VARCHAR(50),
  Antivirus_ReleaseDate VARCHAR(20),
  AVG_StationDesc VARCHAR(250)
)
AS
	DECLARE VARIABLE sp_BarrierSize INTEGER;
	DECLARE VARIABLE sp_MAX_Antivirus_ReleaseDate_AVGcur VARCHAR(20);
	DECLARE VARIABLE sp_MAX_Antivirus_ReleaseDate_AVGprev VARCHAR(20);
	DECLARE VARIABLE sp_REPORTED_Antivirus_ReleaseDate_AVGcur VARCHAR(255);
	DECLARE VARIABLE sp_REPORTED_Antivirus_ReleaseDate_AVGprev VARCHAR(255);
	DECLARE VARIABLE sp_LastReportedValue_AVGcur VARCHAR(255);
	DECLARE VARIABLE sp_LastReportedValue_AVGprev VARCHAR(255);
	DECLARE VARIABLE sp_RecVersion INTEGER;
	DECLARE VARIABLE sp_RowCount_AVGcur INTEGER = 0;
	DECLARE VARIABLE sp_RowCount_AVGprev INTEGER = 0;
	DECLARE VARIABLE sp_FirstMatchedExec VARCHAR(20);
BEGIN
		SELECT FIRST 1 FirstMatchedExecution, BarrierSize, LastReportedValue, LastReportedValue2, AVG_RecVersion FROM "AVG_EMTerm" WHERE AVG_Code = 2
	INTO :sp_FirstMatchedExec, :sp_BarrierSize, :sp_LastReportedValue_AVGcur, :sp_LastReportedValue_AVGprev, :sp_RecVersion;
		SELECT FIRST 1 ReleaseTime FROM "AVG_Versions" WHERE ProductName='avg2012avi' INTO :sp_MAX_Antivirus_ReleaseDate_AVGcur;
	SELECT FIRST 1 ReleaseTime FROM "AVG_Versions" WHERE ProductName='avg10avi' INTO :sp_MAX_Antivirus_ReleaseDate_AVGprev;
	if( (sp_MAX_Antivirus_ReleaseDate_AVGcur <> '') AND (sp_MAX_Antivirus_ReleaseDate_AVGprev <> '') ) THEN
	BEGIN
				sp_MAX_Antivirus_ReleaseDate_AVGcur = SUBSTRING(CAST((CAST(sp_MAX_Antivirus_ReleaseDate_AVGcur AS TIMESTAMP) - CAST(hours AS FLOAT)/24) AS VARCHAR(24)) FROM 1 FOR 19);
		sp_MAX_Antivirus_ReleaseDate_AVGprev = SUBSTRING(CAST((CAST(sp_MAX_Antivirus_ReleaseDate_AVGprev AS TIMESTAMP) - CAST(hours AS FLOAT)/24) AS VARCHAR(24)) FROM 1 FOR 19);
				SELECT COUNT(*), MAX(Antivirus_ReleaseDate) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
		WHERE AVG_AvgVersion LIKE '2012.%' AND :sp_LastReportedValue_AVGcur < Antivirus_ReleaseDate AND Antivirus_ReleaseDate < :sp_MAX_Antivirus_ReleaseDate_AVGcur
		INTO :sp_RowCount_AVGcur, :sp_REPORTED_Antivirus_ReleaseDate_AVGcur;
		SELECT COUNT(*), MAX(Antivirus_ReleaseDate) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
		WHERE AVG_AvgVersion LIKE '0010.%' AND :sp_LastReportedValue_AVGprev < Antivirus_ReleaseDate AND Antivirus_ReleaseDate < :sp_MAX_Antivirus_ReleaseDate_AVGprev
		INTO :sp_RowCount_AVGprev, :sp_REPORTED_Antivirus_ReleaseDate_AVGprev;
		IF (sp_RowCount_AVGcur + sp_RowCount_AVGprev > 0 AND sp_FirstMatchedExec = '') THEN
		BEGIN
			sp_FirstMatchedExec = SUBSTRING(CAST(CURRENT_TIMESTAMP AS VARCHAR(24)) FROM 1 FOR 19);
		END	
	END
	IF (sp_RowCount_AVGcur + sp_RowCount_AVGprev > 0 AND (ignoreBarrier = 1 OR sp_BarrierSize <= sp_RowCount_AVGcur + sp_RowCount_AVGprev)) THEN
	BEGIN
				FOR
		  SELECT AVG_StationName, AVG_StationDomain, AVG_GroupName, AVG_IPAddress, AVG_MACAddress, AVG_LastCall, AVG_WinVersion, AVG_AvgVersion, Antivirus_Version, Antivirus_ReleaseDate, AVG_StationDesc
			FROM "AVG_Stations" 
			LEFT JOIN "AVG_Groups" ON "AVG_Groups".AVG_Code = "AVG_Stations".AVG_GroupID
			INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
			WHERE (AVG_AvgVersion LIKE '2012.%' AND :sp_LastReportedValue_AVGcur < Antivirus_ReleaseDate AND Antivirus_ReleaseDate < :sp_MAX_Antivirus_ReleaseDate_AVGcur) OR
				(AVG_AvgVersion LIKE '0010.%' AND :sp_LastReportedValue_AVGprev < Antivirus_ReleaseDate AND Antivirus_ReleaseDate < :sp_MAX_Antivirus_ReleaseDate_AVGprev)
			ORDER BY Antivirus_ReleaseDate ASC
			INTO :AVG_StationName,:AVG_StationDomain,:AVG_GroupName,:AVG_IPAddress,:AVG_MACAddress,:AVG_LastCall,:AVG_WinVersion,:AVG_AvgVersion,:Antivirus_Version,:Antivirus_ReleaseDate,:AVG_StationDesc
		DO SUSPEND;
				IF (:sp_REPORTED_Antivirus_ReleaseDate_AVGcur IS NULL) THEN
			sp_REPORTED_Antivirus_ReleaseDate_AVGcur = :sp_LastReportedValue_AVGcur;
		IF (:sp_REPORTED_Antivirus_ReleaseDate_AVGprev IS NULL) THEN
			sp_REPORTED_Antivirus_ReleaseDate_AVGprev = :sp_LastReportedValue_AVGprev;
		sp_RecVersion = :sp_RecVersion + 1;
		UPDATE "AVG_EMTerm" SET FirstMatchedExecution = '', LastReportedValue = :sp_REPORTED_Antivirus_ReleaseDate_AVGcur, LastReportedValue2 = :sp_REPORTED_Antivirus_ReleaseDate_AVGprev, AVG_RecVersion = :sp_RecVersion WHERE AVG_Code = 2;
	END	
	ELSE
	BEGIN
				UPDATE "AVG_EMTerm" SET FirstMatchedExecution = :sp_FirstMatchedExec, NextExecution = :nextExec WHERE AVG_Code = 2;
	END
END;
</SQLBlock>


<SQLBlock>
CREATE PROCEDURE EM_StNeedRestartSP (nextExec VARCHAR(20), ignoreBarrier INTEGER)
RETURNS (
  AVG_StationName VARCHAR(64),
  AVG_StationDomain VARCHAR(64),
  AVG_GroupName VARCHAR(64),
  AVG_IPAddress VARCHAR(16),
  AVG_MACAddress VARCHAR(18),
  AVG_LastCall VARCHAR(20),
  AVG_WinVersion VARCHAR(255),
  AVG_AvgVersion VARCHAR(50),
  Antivirus_Version VARCHAR(50),
  AVG_StationDesc VARCHAR(250)
)
AS
	DECLARE VARIABLE sp_BarrierSize INTEGER;	
	DECLARE VARIABLE sp_LastReportedValue VARCHAR(512);
	DECLARE VARIABLE sp_RecVersion INTEGER;
	DECLARE VARIABLE sp_RowCount INTEGER;
	DECLARE VARIABLE sp_NeedRestartTime VARCHAR(20);
	DECLARE VARIABLE sp_FirstMatchedExec VARCHAR(20);
BEGIN
  	SELECT FIRST 1 FirstMatchedExecution, BarrierSize, LastReportedValue, AVG_RecVersion FROM "AVG_EMTerm" WHERE AVG_Code = 3
	INTO :sp_FirstMatchedExec, :sp_BarrierSize, :sp_LastReportedValue, :sp_RecVersion;
		SELECT COUNT(*) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
  WHERE NeedRestart>0 AND :sp_LastReportedValue < NeedRestartTime INTO :sp_RowCount;
	IF (sp_RowCount > 0 AND sp_FirstMatchedExec = '') THEN
	BEGIN
		sp_FirstMatchedExec = SUBSTRING(CAST(CURRENT_TIMESTAMP AS VARCHAR(24)) FROM 1 FOR 19);
	END
	IF (sp_RowCount > 0 AND (ignoreBarrier = 1 OR sp_BarrierSize <= sp_RowCount)) THEN
	BEGIN
				FOR
		  SELECT AVG_StationName, AVG_StationDomain, AVG_GroupName, AVG_IPAddress, AVG_MACAddress, AVG_LastCall, AVG_WinVersion, AVG_AvgVersion, Antivirus_Version, NeedRestartTime, AVG_StationDesc
			FROM "AVG_Stations" 
      LEFT JOIN "AVG_Groups" ON "AVG_Groups".AVG_Code = "AVG_Stations".AVG_GroupID
      INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
      WHERE NeedRestart>0 AND :sp_LastReportedValue < NeedRestartTime ORDER BY NeedRestartTime ASC
			INTO :AVG_StationName,:AVG_StationDomain,:AVG_GroupName,:AVG_IPAddress,:AVG_MACAddress,:AVG_LastCall,:AVG_WinVersion,:AVG_AvgVersion, :Antivirus_Version, :sp_NeedRestartTime, :AVG_StationDesc
		DO SUSPEND;
		if (:sp_NeedRestartTime IS NOT NULL) THEN
		BEGIN			
			      sp_LastReportedValue = :sp_NeedRestartTime;			
			sp_RecVersion = :sp_RecVersion + 1;
			UPDATE "AVG_EMTerm" SET FirstMatchedExecution = '', LastReportedValue = :sp_LastReportedValue, AVG_RecVersion = :sp_RecVersion WHERE AVG_Code = 3;
		END
	END	
	ELSE
	BEGIN
				UPDATE "AVG_EMTerm" SET FirstMatchedExecution = :sp_FirstMatchedExec, NextExecution = :nextExec WHERE AVG_Code = 3;
	END
END;
</SQLBlock>


<SQLBlock>
CREATE PROCEDURE EM_StNotCommLongTimeSP (nextExec VARCHAR(20), ignoreBarrier INTEGER, days INTEGER)
RETURNS (
  AVG_StationName VARCHAR(64),
  AVG_StationDomain VARCHAR(64),
  AVG_GroupName VARCHAR(64),
  AVG_IPAddress VARCHAR(16),
  AVG_MACAddress VARCHAR(18),
  AVG_LastCall VARCHAR(20),
  AVG_WinVersion VARCHAR(255),
  AVG_AvgVersion VARCHAR(50),
  Antivirus_Version VARCHAR(50),
  AVG_StationDesc VARCHAR(250)
)
AS
	DECLARE VARIABLE sp_BarrierSize INTEGER;
	DECLARE VARIABLE sp_LastReportedValue VARCHAR(512);
	DECLARE VARIABLE sp_RecVersion INTEGER;
	DECLARE VARIABLE sp_RowCount INTEGER;
	DECLARE VARIABLE sp_FirstMatchedExec VARCHAR(20);
BEGIN
  	SELECT FIRST 1 FirstMatchedExecution, BarrierSize, LastReportedValue, AVG_RecVersion FROM "AVG_EMTerm" WHERE AVG_Code = 4
	INTO :sp_FirstMatchedExec, :sp_BarrierSize, :sp_LastReportedValue, :sp_RecVersion;
		SELECT COUNT(*) FROM "AVG_Stations" WHERE AVG_LastCall IS NOT NULL AND AVG_LastCall <> '' AND :sp_LastReportedValue < AVG_LastCall AND (CURRENT_TIMESTAMP - CAST(AVG_LastCall AS TIMESTAMP)) >= :days INTO :sp_RowCount;
	IF (sp_RowCount > 0 AND sp_FirstMatchedExec = '') THEN
	BEGIN
		sp_FirstMatchedExec = SUBSTRING(CAST(CURRENT_TIMESTAMP AS VARCHAR(24)) FROM 1 FOR 19);
	END
	IF (sp_RowCount > 0 AND (ignoreBarrier = 1 OR sp_BarrierSize <= sp_RowCount)) THEN
	BEGIN
				FOR
		  SELECT AVG_StationName, AVG_StationDomain, AVG_GroupName, AVG_IPAddress, AVG_MACAddress, AVG_LastCall, AVG_WinVersion, AVG_AvgVersion, Antivirus_Version, AVG_StationDesc
			FROM "AVG_Stations" 
      INNER JOIN "AVG_Groups" ON "AVG_Groups".AVG_Code = "AVG_Stations".AVG_GroupID
      LEFT JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code
      WHERE AVG_LastCall IS NOT NULL AND AVG_LastCall <> '' AND :sp_LastReportedValue < AVG_LastCall AND (CURRENT_TIMESTAMP - CAST(AVG_LastCall AS TIMESTAMP)) >= :days
      ORDER BY AVG_LastCall
			INTO :AVG_StationName,:AVG_StationDomain,:AVG_GroupName,:AVG_IPAddress,:AVG_MACAddress,:AVG_LastCall,:AVG_WinVersion,:AVG_AvgVersion, :Antivirus_Version, :AVG_StationDesc
		DO SUSPEND;
		if (AVG_LastCall IS NOT NULL) THEN
		BEGIN			
			      sp_LastReportedValue = AVG_LastCall;			
			sp_RecVersion = :sp_RecVersion + 1;
			UPDATE "AVG_EMTerm" SET FirstMatchedExecution = '', LastReportedValue = :sp_LastReportedValue, AVG_RecVersion = :sp_RecVersion WHERE AVG_Code = 4;
		END
	END	
	ELSE
	BEGIN
				UPDATE "AVG_EMTerm" SET FirstMatchedExecution = :sp_FirstMatchedExec, NextExecution = :nextExec WHERE AVG_Code = 4;
	END
END;
</SQLBlock>



CREATE VIEW "view_EM_VirusFound" (AVG_Infected,AVG_ScanStarted,AVG_OwnerID) AS 
	SELECT CAST((AVG_FoundInfections-AVG_HealedInfections) AS INTEGER) AS AVG_Infected, AVG_ScanStarted, AVG_OwnerID 
		FROM "AVG_ScanLogs" 
		WHERE AVG_ConfirmTime = '' AND AVG_OwnerType=0 AND AVG_LogID<>1
	UNION ALL
	SELECT 1 AS AVG_Infected, "AVG_ScanResults".AVG_DetectionTimestamp AS AVG_ScanStarted, "AVG_ScanLogs".AVG_OwnerID 
		FROM "AVG_ScanLogs" 
		INNER JOIN "AVG_ScanResults" 
			ON "AVG_ScanLogs".AVG_Code = "AVG_ScanResults".AVG_ParentCode AND AVG_LogID=1 AND AVG_OwnerType=0 AND "AVG_ScanLogs".AVG_ConfirmTime = '' AND ("AVG_ScanResults".AVG_ResultState = 2 OR "AVG_ScanResults".AVG_ResultState = 4 OR 					"AVG_ScanResults".AVG_ResultState = 8 OR "AVG_ScanResults".AVG_ResultState = 64);

<SQLBlock>
CREATE PROCEDURE EM_VirusFoundSP (nextExec VARCHAR(20), ignoreBarrier INTEGER)
RETURNS (
  AVG_StationName VARCHAR(64),
  AVG_StationDomain VARCHAR(64),
  AVG_GroupName VARCHAR(64),
  AVG_IPAddress VARCHAR(16),
  AVG_MACAddress VARCHAR(18),
  AVG_LastCall VARCHAR(20),
  AVG_WinVersion VARCHAR(255),
  AVG_AvgVersion VARCHAR(50),
  Antivirus_Version VARCHAR(50),
  AVG_Infected INTEGER,
  AVG_ScanStarted VARCHAR(20),
  AVG_StationDesc VARCHAR(250)
)
AS
	DECLARE VARIABLE sp_BarrierSize INTEGER;
	DECLARE VARIABLE sp_LastReportedValue VARCHAR(512);
	DECLARE VARIABLE sp_RecVersion INTEGER;
	DECLARE VARIABLE sp_RowCount INTEGER;
	DECLARE VARIABLE sp_FirstMatchedExec VARCHAR(20);
BEGIN
  		SELECT FIRST 1 FirstMatchedExecution, BarrierSize, LastReportedValue, AVG_RecVersion FROM "AVG_EMTerm" WHERE AVG_Code = 5
	INTO :sp_FirstMatchedExec, :sp_BarrierSize, :sp_LastReportedValue, :sp_RecVersion;
	  	SELECT COUNT(DISTINCT AVG_OwnerID) FROM "AVG_Stations" 
  	INNER JOIN "view_EM_VirusFound" ON "AVG_Stations".AVG_Code = "view_EM_VirusFound".AVG_OwnerID AND "view_EM_VirusFound".AVG_ScanStarted > :sp_LastReportedValue 
  	WHERE (AVG_Infected > 0)
  	INTO :sp_RowCount;
  
	IF (sp_RowCount > 0 AND sp_FirstMatchedExec = '') THEN
	BEGIN
		sp_FirstMatchedExec = SUBSTRING(CAST(CURRENT_TIMESTAMP AS VARCHAR(24)) FROM 1 FOR 19);
	END
	IF (sp_RowCount > 0 AND (ignoreBarrier = 1 OR sp_BarrierSize <= sp_RowCount)) THEN
	BEGIN
				FOR 	
			SELECT AVG_StationName, AVG_StationDomain, AVG_GroupName, AVG_IPAddress, AVG_MACAddress, AVG_LastCall, AVG_WinVersion,AVG_AvgVersion,Antivirus_Version, SUM(AVG_Infected) AS AVG_Infected, MAX(AVG_ScanStarted) AS AVG_ScanStarted, AVG_StationDesc
	    		FROM "AVG_Stations" 
			INNER JOIN "view_EM_VirusFound" "View" ON "AVG_Stations".AVG_Code = "View".AVG_OwnerID AND "View".AVG_ScanStarted > :sp_LastReportedValue
      			LEFT JOIN "AVG_Groups" ON "AVG_Groups".AVG_Code = "AVG_Stations".AVG_GroupID 
      			LEFT JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code
			       GROUP BY AVG_OwnerID, AVG_StationName, AVG_StationDomain, AVG_GroupName, AVG_IPAddress, AVG_MACAddress, AVG_LastCall, AVG_WinVersion, AVG_AvgVersion, Antivirus_Version, AVG_StationDesc HAVING SUM("View".AVG_Infected)>0
      INTO :AVG_StationName,:AVG_StationDomain,:AVG_GroupName,:AVG_IPAddress,:AVG_MACAddress,:AVG_LastCall,:AVG_WinVersion,:AVG_AvgVersion,:Antivirus_Version,:AVG_Infected,:AVG_ScanStarted, :AVG_StationDesc
		DO SUSPEND;
		if (AVG_ScanStarted IS NOT NULL) THEN
		BEGIN			
			      			sp_LastReportedValue = AVG_ScanStarted;			
			sp_RecVersion = :sp_RecVersion + 1;
			UPDATE "AVG_EMTerm" SET FirstMatchedExecution = '', LastReportedValue = :sp_LastReportedValue, AVG_RecVersion = :sp_RecVersion WHERE 			AVG_Code = 5;
		END
	END	
	ELSE
	BEGIN
				UPDATE "AVG_EMTerm" SET FirstMatchedExecution = :sp_FirstMatchedExec, NextExecution = :nextExec WHERE AVG_Code = 5;
	END
END;
</SQLBlock>




<SQLBlock>
CREATE PROCEDURE EM_StComAfterInstallSP (nextExec VARCHAR(20), ignoreBarrier INTEGER)
RETURNS (
  AVG_StationName VARCHAR(64),
  AVG_StationDomain VARCHAR(64),
  AVG_GroupName VARCHAR(64),
  AVG_IPAddress VARCHAR(16),
  AVG_MACAddress VARCHAR(18),
  AVG_LastCall VARCHAR(20),
  AVG_WinVersion VARCHAR(255),
  AVG_AvgVersion VARCHAR(50),
  Antivirus_Version VARCHAR(50),
  AVG_InstallTime VARCHAR(20),
  AVG_StationDesc VARCHAR(250)
)
AS
	DECLARE VARIABLE sp_BarrierSize INTEGER;
	DECLARE VARIABLE sp_LastReportedValue VARCHAR(512);
	DECLARE VARIABLE sp_RecVersion INTEGER;
	DECLARE VARIABLE sp_RowCount INTEGER;
	DECLARE VARIABLE sp_FirstMatchedExec VARCHAR(20);
BEGIN
  	SELECT FIRST 1 FirstMatchedExecution, BarrierSize, LastReportedValue, AVG_RecVersion FROM "AVG_EMTerm" WHERE AVG_Code = 6
	INTO :sp_FirstMatchedExec, :sp_BarrierSize, :sp_LastReportedValue, :sp_RecVersion;
		SELECT COUNT(*) FROM "AVG_Stations" WHERE :sp_LastReportedValue < AVG_InstallTime AND AVG_InstallTime > AVG_LastCall INTO :sp_RowCount;
	IF (sp_RowCount > 0 AND sp_FirstMatchedExec = '') THEN
	BEGIN
		sp_FirstMatchedExec = SUBSTRING(CAST(CURRENT_TIMESTAMP AS VARCHAR(24)) FROM 1 FOR 19);
	END
	IF (sp_RowCount > 0 AND (ignoreBarrier = 1 OR sp_BarrierSize <= sp_RowCount)) THEN
	BEGIN
				FOR
		  SELECT AVG_StationName, AVG_StationDomain, AVG_GroupName, AVG_IPAddress, AVG_MACAddress, AVG_LastCall, AVG_WinVersion, AVG_AvgVersion, Antivirus_Version, AVG_InstallTime, AVG_StationDesc
			FROM "AVG_Stations" 
      LEFT JOIN "AVG_Groups" ON "AVG_Groups".AVG_Code = "AVG_Stations".AVG_GroupID
      LEFT JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code
      WHERE :sp_LastReportedValue < AVG_InstallTime AND AVG_InstallTime > AVG_LastCall
      ORDER BY AVG_InstallTime
			INTO :AVG_StationName,:AVG_StationDomain,:AVG_GroupName,:AVG_IPAddress,:AVG_MACAddress,:AVG_LastCall,:AVG_WinVersion,:AVG_AvgVersion, :Antivirus_Version, :AVG_InstallTime, :AVG_StationDesc
		DO SUSPEND;
		if (AVG_InstallTime IS NOT NULL) THEN
		BEGIN			
			      sp_LastReportedValue = AVG_InstallTime;			
			sp_RecVersion = :sp_RecVersion + 1;
			UPDATE "AVG_EMTerm" SET FirstMatchedExecution = '', LastReportedValue = :sp_LastReportedValue, AVG_RecVersion = :sp_RecVersion WHERE AVG_Code = 6;
		END
	END	
	ELSE
	BEGIN
				UPDATE "AVG_EMTerm" SET FirstMatchedExecution = :sp_FirstMatchedExec, NextExecution = :nextExec WHERE AVG_Code = 6;
	END
END;
</SQLBlock>





<SQLBlock>
CREATE PROCEDURE EM_SchedTestInterruptedSP (nextExec VARCHAR(20), ignoreBarrier INTEGER)
RETURNS (
  AVG_StationName VARCHAR(64),
  AVG_StationDomain VARCHAR(64),
  AVG_GroupName VARCHAR(64),
  AVG_IPAddress VARCHAR(16),
  AVG_MACAddress VARCHAR(18),
  AVG_LastCall VARCHAR(20),
  AVG_WinVersion VARCHAR(255),
  AVG_AvgVersion VARCHAR(50),
  Antivirus_Version VARCHAR(50),
  AVG_Infected INTEGER,
  AVG_ScanStarted VARCHAR(20),
  AVG_TestName VARCHAR(128),
  AVG_StationDesc VARCHAR(250)
)
AS
	DECLARE VARIABLE sp_BarrierSize INTEGER;
	DECLARE VARIABLE sp_LastReportedValue VARCHAR(512);
	DECLARE VARIABLE sp_RecVersion INTEGER;
	DECLARE VARIABLE sp_RowCount INTEGER;
	DECLARE VARIABLE sp_FirstMatchedExec VARCHAR(20);
BEGIN
    SELECT FIRST 1 FirstMatchedExecution, BarrierSize, LastReportedValue, AVG_RecVersion FROM "AVG_EMTerm" WHERE AVG_Code = 8
	INTO :sp_FirstMatchedExec, :sp_BarrierSize, :sp_LastReportedValue, :sp_RecVersion;
	  SELECT COUNT(*) FROM "AVG_Stations" 
  INNER JOIN "AVG_ScanLogs" ON "AVG_Stations".AVG_Code = "AVG_ScanLogs".AVG_OwnerID AND "AVG_ScanLogs".AVG_OwnerType=0 
  AND AVG_ConfirmTime = '' AND AVG_ScanStarted > :sp_LastReportedValue
  AND AVG_ScanType = 5 AND (AVG_LogState = 3 OR AVG_LogState = 4 OR AVG_LogState = 6)
  INTO :sp_RowCount;
	IF (sp_RowCount > 0 AND sp_FirstMatchedExec = '') THEN
	BEGIN
		sp_FirstMatchedExec = SUBSTRING(CAST(CURRENT_TIMESTAMP AS VARCHAR(24)) FROM 1 FOR 19);
	END
	IF (sp_RowCount > 0 AND (ignoreBarrier = 1 OR sp_BarrierSize <= sp_RowCount)) THEN
	BEGIN
				FOR
		  SELECT AVG_StationName, AVG_StationDomain, AVG_GroupName, AVG_IPAddress, AVG_MACAddress, AVG_LastCall, AVG_WinVersion, AVG_AvgVersion, Antivirus_Version, 
      (AVG_FoundInfections-AVG_HealedInfections) AS AVG_Infected, AVG_ScanStarted, AVG_TestName, AVG_StationDesc
      FROM "AVG_Stations"             
      INNER JOIN "AVG_ScanLogs" ON "AVG_Stations".AVG_Code = "AVG_ScanLogs".AVG_OwnerID AND "AVG_ScanLogs".AVG_OwnerType=0
      AND AVG_ConfirmTime = '' AND AVG_ScanStarted > :sp_LastReportedValue
      AND AVG_ScanType = 5 AND (AVG_LogState = 3 OR AVG_LogState = 4 OR AVG_LogState = 6)       
      LEFT JOIN "AVG_Groups" ON "AVG_Groups".AVG_Code = "AVG_Stations".AVG_GroupID 
      INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code      
      ORDER BY AVG_ScanStarted
      INTO :AVG_StationName,:AVG_StationDomain,:AVG_GroupName,:AVG_IPAddress,:AVG_MACAddress,:AVG_LastCall,:AVG_WinVersion,:AVG_AvgVersion,:Antivirus_Version,:AVG_Infected,:AVG_ScanStarted,:AVG_TestName, :AVG_StationDesc
		DO SUSPEND;
		if (AVG_ScanStarted IS NOT NULL) THEN
		BEGIN			
			      sp_LastReportedValue = AVG_ScanStarted;			
			sp_RecVersion = :sp_RecVersion + 1;
			UPDATE "AVG_EMTerm" SET LastReportedValue = :sp_LastReportedValue, AVG_RecVersion = :sp_RecVersion WHERE AVG_Code = 8;
		END
	END
	ELSE
	BEGIN
				UPDATE "AVG_EMTerm" SET FirstMatchedExecution = :sp_FirstMatchedExec, NextExecution = :nextExec WHERE AVG_Code = 8;
	END
END;
</SQLBlock>


CREATE VIEW "view_EM_StUpdateFailedSP" (AVG_TimeOfCreating, AVG_SenderID) 
  AS SELECT MAX(AVG_TimeOfCreating) AS AVG_TimeOfCreating, AVG_SenderID 
  FROM "AVG_Messages" WHERE "AVG_Messages".AVG_SenderType=0 AND AVG_MessageCode = 213 GROUP BY AVG_SenderID;


<SQLBlock>

CREATE PROCEDURE EM_StUpdateFailedSP (nextExec VARCHAR(20), ignoreBarrier INTEGER)
RETURNS (
  AVG_StationName VARCHAR(64),
  AVG_StationDomain VARCHAR(64),
  AVG_GroupName VARCHAR(64),
  AVG_IPAddress VARCHAR(16),
  AVG_MACAddress VARCHAR(18),
  AVG_LastCall VARCHAR(20),
  AVG_WinVersion VARCHAR(255),
  AVG_AvgVersion VARCHAR(50),
  Antivirus_Version VARCHAR(50),
  AVG_LastFailedUpdate VARCHAR(20),
  AVG_StationDesc VARCHAR(250)
)
AS
	DECLARE VARIABLE sp_BarrierSize INTEGER;	
	DECLARE VARIABLE sp_LastReportedValue VARCHAR(512);
	DECLARE VARIABLE sp_RecVersion INTEGER;
	DECLARE VARIABLE sp_RowCount INTEGER;
	DECLARE VARIABLE sp_FirstMatchedExec VARCHAR(20);
BEGIN
  	SELECT FIRST 1 FirstMatchedExecution, BarrierSize, LastReportedValue, AVG_RecVersion FROM "AVG_EMTerm" WHERE AVG_Code = 9
	INTO :sp_FirstMatchedExec, :sp_BarrierSize, :sp_LastReportedValue, :sp_RecVersion;
		SELECT COUNT(*) FROM "AVG_Stations" 
  INNER JOIN "view_EM_StUpdateFailedSP" ON AVG_SenderID = "AVG_Stations".AVG_Code and "view_EM_StUpdateFailedSP".AVG_TimeOfCreating > :sp_LastReportedValue
  INTO :sp_RowCount;
	IF (sp_RowCount > 0 AND sp_FirstMatchedExec = '') THEN
	BEGIN
		sp_FirstMatchedExec = SUBSTRING(CAST(CURRENT_TIMESTAMP AS VARCHAR(24)) FROM 1 FOR 19);
	END
	IF (sp_RowCount > 0 AND (ignoreBarrier = 1 OR sp_BarrierSize <= sp_RowCount)) THEN
	BEGIN
				FOR
      SELECT AVG_StationName, AVG_StationDomain, AVG_GroupName, AVG_IPAddress, AVG_MACAddress, AVG_LastCall, AVG_WinVersion, AVG_AvgVersion, Antivirus_Version, AVG_TimeOfCreating, AVG_StationDesc
			FROM "AVG_Stations"
      LEFT JOIN "AVG_Groups" ON "AVG_Groups".AVG_Code = "AVG_Stations".AVG_GroupID
      INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code
      INNER JOIN "view_EM_StUpdateFailedSP" ON AVG_SenderID = "AVG_Stations".AVG_Code AND "view_EM_StUpdateFailedSP".AVG_TimeOfCreating > :sp_LastReportedValue
      ORDER BY AVG_TimeOfCreating ASC
			INTO :AVG_StationName,:AVG_StationDomain,:AVG_GroupName,:AVG_IPAddress,:AVG_MACAddress,:AVG_LastCall,:AVG_WinVersion,:AVG_AvgVersion, :Antivirus_Version, :AVG_LastFailedUpdate, :AVG_StationDesc
		DO SUSPEND;
		if (:AVG_LastFailedUpdate IS NOT NULL) THEN
		BEGIN			
			      sp_LastReportedValue = AVG_LastFailedUpdate;			
			sp_RecVersion = :sp_RecVersion + 1;
			UPDATE "AVG_EMTerm" SET FirstMatchedExecution = '', LastReportedValue = :sp_LastReportedValue, AVG_RecVersion = :sp_RecVersion WHERE AVG_Code = 9;
		END
	END	
	ELSE
	BEGIN
				UPDATE "AVG_EMTerm" SET FirstMatchedExecution = :sp_FirstMatchedExec, NextExecution = :nextExec WHERE AVG_Code = 9;
	END
END;
</SQLBlock>



<SQLBlock>
CREATE PROCEDURE EM_OldCoreSP (nextExec VARCHAR(20), ignoreBarrier INTEGER)
RETURNS (
  AVG_StationName VARCHAR(64),
  AVG_StationDomain VARCHAR(64),
  AVG_GroupName VARCHAR(64),
  AVG_IPAddress VARCHAR(16),
  AVG_MACAddress VARCHAR(18),
  AVG_LastCall VARCHAR(20),
  AVG_WinVersion VARCHAR(255),
  AVG_AvgVersion VARCHAR(50),
  Antivirus_Version VARCHAR(50),
  AVG_StationDesc VARCHAR(250)
)
AS
	DECLARE VARIABLE sp_BarrierSize INTEGER;
	DECLARE VARIABLE sp_MAX_Core_Version_AVGcur VARCHAR(50);
	DECLARE VARIABLE sp_MAX_Core_Version_AVGcur_64 VARCHAR(50);
	DECLARE VARIABLE sp_MAX_Core_Version_AVGprev VARCHAR(50);
	DECLARE VARIABLE sp_MAX_Core_Version_AVGprev_64 VARCHAR(50);
	DECLARE VARIABLE sp_REPORTED_Core_Version_AVGcur VARCHAR(255);
	DECLARE VARIABLE sp_REPORTED_Core_Version_AVGcur_64 VARCHAR(255);
	DECLARE VARIABLE sp_REPORTED_Core_Version_AVGprev VARCHAR(255);
	DECLARE VARIABLE sp_REPORTED_Core_Version_AVGprev_64 VARCHAR(255);
	DECLARE VARIABLE sp_LastReportedValue_AVGcur VARCHAR(255);
	DECLARE VARIABLE sp_LastReportedValue_AVGcur_64 VARCHAR(255);
	DECLARE VARIABLE sp_LastReportedValue_AVGprev VARCHAR(255);
	DECLARE VARIABLE sp_LastReportedValue_AVGprev_64 VARCHAR(255);
	DECLARE VARIABLE sp_RecVersion INTEGER;
	DECLARE VARIABLE sp_RowCount INTEGER;
	DECLARE VARIABLE sp_RowCount_AVGcur INTEGER;
	DECLARE VARIABLE sp_RowCount_AVGcur_64 INTEGER;
	DECLARE VARIABLE sp_RowCount_AVGprev INTEGER;
	DECLARE VARIABLE sp_RowCount_AVGprev_64 INTEGER;
	DECLARE VARIABLE sp_FirstMatchedExec VARCHAR(20);

BEGIN
		SELECT FIRST 1 FirstMatchedExecution, BarrierSize, LastReportedValue, LastReportedValue_64, LastReportedValue2, LastReportedValue2_64, AVG_RecVersion FROM "AVG_EMTerm" WHERE AVG_Code = 11
	INTO :sp_FirstMatchedExec, :sp_BarrierSize, :sp_LastReportedValue_AVGcur, :sp_LastReportedValue_AVGcur_64, :sp_LastReportedValue_AVGprev, :sp_LastReportedValue_AVGprev_64, :sp_RecVersion;
		SELECT FIRST 1 Version FROM "AVG_Versions" WHERE ProductName='avg2012coreupd' INTO :sp_MAX_Core_Version_AVGcur;
	SELECT FIRST 1 Version FROM "AVG_Versions" WHERE ProductName='avg2012coreupd64' INTO :sp_MAX_Core_Version_AVGcur_64;
	SELECT FIRST 1 Version FROM "AVG_Versions" WHERE ProductName='avg10coreupd' INTO :sp_MAX_Core_Version_AVGprev;
	SELECT FIRST 1 Version FROM "AVG_Versions" WHERE ProductName='avg10coreupd64' INTO :sp_MAX_Core_Version_AVGprev_64;
		SELECT COUNT(*), MAX(Core_Version) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
		WHERE AVG_AvgVersion LIKE '2012.%' AND AVG_BuildType=32 AND :sp_LastReportedValue_AVGcur < Core_Version AND Core_Version < :sp_MAX_Core_Version_AVGcur
		INTO :sp_RowCount_AVGcur, :sp_REPORTED_Core_Version_AVGcur;
	SELECT COUNT(*), MAX(Core_Version) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
		WHERE AVG_AvgVersion LIKE '2012.%' AND AVG_BuildType=64 AND :sp_LastReportedValue_AVGcur_64 < Core_Version AND Core_Version < :sp_MAX_Core_Version_AVGcur_64
		INTO :sp_RowCount_AVGcur_64, :sp_REPORTED_Core_Version_AVGcur_64;
	SELECT COUNT(*), MAX(Core_Version) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
		WHERE AVG_AvgVersion LIKE '0010.%' AND AVG_BuildType=32 AND :sp_LastReportedValue_AVGprev < Core_Version AND Core_Version < :sp_MAX_Core_Version_AVGprev
		INTO :sp_RowCount_AVGprev, :sp_REPORTED_Core_Version_AVGprev;
	SELECT COUNT(*), MAX(Core_Version) FROM "AVG_Stations" INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
		WHERE AVG_AvgVersion LIKE '0010.%' AND AVG_BuildType=64 AND :sp_LastReportedValue_AVGprev_64 < Core_Version AND Core_Version < :sp_MAX_Core_Version_AVGprev_64
		INTO :sp_RowCount_AVGprev_64, :sp_REPORTED_Core_Version_AVGprev_64;
	sp_RowCount = :sp_RowCount_AVGcur + :sp_RowCount_AVGcur_64 + :sp_RowCount_AVGprev + :sp_RowCount_AVGprev_64;
	IF (sp_RowCount > 0 AND sp_FirstMatchedExec = '') THEN
	BEGIN
		sp_FirstMatchedExec = SUBSTRING(CAST(CURRENT_TIMESTAMP AS VARCHAR(24)) FROM 1 FOR 19);
	END
	IF ((sp_RowCount > 0) AND (ignoreBarrier = 1 OR sp_BarrierSize <= sp_RowCount)) THEN
	BEGIN
				FOR
			SELECT AVG_StationName, AVG_StationDomain, AVG_GroupName, AVG_IPAddress, AVG_MACAddress, AVG_LastCall, AVG_WinVersion, AVG_AvgVersion, Antivirus_Version, AVG_StationDesc
			FROM "AVG_Stations" 
			LEFT JOIN "AVG_Groups" ON "AVG_Groups".AVG_Code = "AVG_Stations".AVG_GroupID
			INNER JOIN "AVG_StationsStates" ON "AVG_StationsStates".AVG_StationID = "AVG_Stations".AVG_Code 
			WHERE (AVG_AvgVersion LIKE '2012.%' AND AVG_BuildType=32 AND :sp_LastReportedValue_AVGcur < Core_Version AND Core_Version < :sp_MAX_Core_Version_AVGcur)
			OR (AVG_AvgVersion LIKE '2012.%' AND AVG_BuildType=64 AND :sp_LastReportedValue_AVGcur_64 < Core_Version AND Core_Version < :sp_MAX_Core_Version_AVGcur_64)
			OR (AVG_AvgVersion LIKE '0010.%' AND AVG_BuildType=32 AND :sp_LastReportedValue_AVGprev < Core_Version AND Core_Version < :sp_MAX_Core_Version_AVGprev)
			OR (AVG_AvgVersion LIKE '0010.%' AND AVG_BuildType=64 AND :sp_LastReportedValue_AVGprev_64 < Core_Version AND Core_Version < :sp_MAX_Core_Version_AVGprev_64)
			ORDER BY Core_Version ASC
			INTO :AVG_StationName,:AVG_StationDomain,:AVG_GroupName,:AVG_IPAddress,:AVG_MACAddress,:AVG_LastCall,:AVG_WinVersion,:AVG_AvgVersion, :Antivirus_Version, :AVG_StationDesc
		DO SUSPEND;
				IF (:sp_REPORTED_Core_Version_AVGcur IS NULL) THEN
			sp_REPORTED_Core_Version_AVGcur = :sp_LastReportedValue_AVGcur;
		IF (:sp_REPORTED_Core_Version_AVGcur_64 IS NULL) THEN
			sp_REPORTED_Core_Version_AVGcur_64 = :sp_LastReportedValue_AVGcur_64;
		IF (:sp_REPORTED_Core_Version_AVGprev IS NULL) THEN
			sp_REPORTED_Core_Version_AVGprev = :sp_LastReportedValue_AVGprev;
		IF (:sp_REPORTED_Core_Version_AVGprev_64 IS NULL) THEN
			sp_REPORTED_Core_Version_AVGprev_64 = :sp_LastReportedValue_AVGprev_64;
		sp_RecVersion = :sp_RecVersion + 1;
		UPDATE "AVG_EMTerm" SET FirstMatchedExecution = '', LastReportedValue = :sp_REPORTED_Core_Version_AVGcur, LastReportedValue_64 = :sp_REPORTED_Core_Version_AVGcur_64, LastReportedValue2 = :sp_REPORTED_Core_Version_AVGprev, LastReportedValue2_64 = :sp_REPORTED_Core_Version_AVGprev_64, AVG_RecVersion = :sp_RecVersion WHERE AVG_Code = 11;
	END
	ELSE
	BEGIN
				UPDATE "AVG_EMTerm" SET FirstMatchedExecution = :sp_FirstMatchedExec, NextExecution = :nextExec WHERE AVG_Code = 11;
	END
END;
</SQLBlock>
</EventManagerObjects>


</CommonDatabaseData>
</DatabaseCreateScript>

